﻿namespace Otaku
{
    using Otaku.Managers;
    using Otaku.Socketservers;
    using System;
    using System.IO;
    using System.Runtime.CompilerServices;
    using System.Security.Cryptography;
    using System.Text;
    using System.Threading;

    public class phoenix
    {
        private static Thread serverMonitor = new Thread(new ThreadStart(phoenix.monitorServer));

        private static void Boot()
        {
            ThreadPool.SetMaxThreads(300, 400);
            DateTime now = DateTime.Now;
            Out.WriteLine("Starting up Project Phoenix for " + Environment.UserName + "...");
            Out.WriteLine("Expanded threadpool.");
            Out.WriteLine(@"Checking for \bin\mysql.ini...");
            string path = IO.workingDirectory + @"\mysql.ini";
            if (!File.Exists(path))
            {
                Out.WriteError("mysql.ini not found at " + path);
                Shutdown();
            }
            else
            {
                Out.WriteLine("mysql.ini found at " + path);
                Out.WriteBlank();
                string str2 = IO.readINI("licence", "user", path);
                string str3 = IO.readINI("licence", "pass", path);
                MD5CryptoServiceProvider provider = new MD5CryptoServiceProvider();
                byte[] bytes = Encoding.UTF8.GetBytes("otaku" + str3 + "licencekey");
                bytes = provider.ComputeHash(bytes);
                StringBuilder builder = new StringBuilder();
                foreach (byte num in bytes)
                {
                    builder.Append(num.ToString("x2").ToLower());
                }
                str3 = builder.ToString();
                bytes = Encoding.UTF8.GetBytes("otaku" + str2 + "licencename");
                bytes = provider.ComputeHash(bytes);
                StringBuilder builder2 = new StringBuilder();
                foreach (byte num2 in bytes)
                {
                    builder2.Append(num2.ToString("x2").ToLower());
                }
                str2 = builder2.ToString();
                Out.WriteLine("Checking licence details..");
                if (DB.openConnection("alpha.privatesystem.net", 0xcea, "otakudb_phoenixhotel", "otakudb_3412752", "0_94a3214-A$8579G432n0"))
                {
                    int num3 = DB.runRead("SELECT id FROM users WHERE username = '" + str2 + "' AND password = '" + str3 + "'", null);
                    if (num3 != 0)
                    {
                        Out.WriteLine("Connected as licence " + num3);
                        string dbHost = IO.readINI("mysql", "host", path);
                        int dbPort = int.Parse(IO.readINI("mysql", "port", path));
                        string dbUsername = IO.readINI("mysql", "username", path);
                        string dbPassword = IO.readINI("mysql", "password", path);
                        string dbName = IO.readINI("mysql", "database", path);
                        if (DB.openConnection(dbHost, dbPort, dbName, dbUsername, dbPassword))
                        {
                            int num5;
                            int num6;
                            int num7;
                            string str8;
                            Out.WriteBlank();
                            try
                            {
                                num5 = int.Parse(Config.getTableEntry("server_game_port"));
                                num6 = int.Parse(Config.getTableEntry("server_game_maxconnections"));
                                num7 = int.Parse(Config.getTableEntry("server_mus_port"));
                                int.Parse(Config.getTableEntry("server_mus_maxconnections"));
                                str8 = Config.getTableEntry("server_mus_host");
                            }
                            catch
                            {
                                Out.WriteError("system_config table contains invalid values for socket server configuration!");
                                Shutdown();
                                return;
                            }
                            string langExtension = Config.getTableEntry("lang");
                            if (!(langExtension == ""))
                            {
                                stringManager.Init(langExtension);
                                Out.WriteBlank();
                                stringManager.initFilter();
                                Out.WriteBlank();
                                catalogueManager.Init();
                                Out.WriteBlank();
                                recyclerManager.Init();
                                Out.WriteBlank();
                                rankManager.Init();
                                Out.WriteBlank();
                                Config.Init();
                                Out.WriteBlank();
                                userManager.Init();
                                eventManager.Init();
                                if (!gameSocketServer.Init(num5, num6))
                                {
                                    Shutdown();
                                }
                                else
                                {
                                    Out.WriteBlank();
                                    if (!musSocketServer.Init(num7, str8))
                                    {
                                        Shutdown();
                                    }
                                    else
                                    {
                                        Out.WriteBlank();
                                        resetDynamics();
                                        Out.WriteBlank();
                                        printDatabaseStats();
                                        Out.WriteBlank();
                                        TimeSpan span = (TimeSpan) (DateTime.Now - now);
                                        Out.WriteLine("Startup time in fixed milliseconds: " + span.TotalMilliseconds.ToString() + ".");
                                        GC.Collect();
                                        Out.WriteLine("Project Phoenix ready. Status: idle");
                                        Out.WriteBlank();
                                        Out.minimumImportance = Out.logFlags.MehAction;
                                        serverMonitor.Priority = ThreadPriority.Lowest;
                                        serverMonitor.Start();
                                    }
                                }
                            }
                            else
                            {
                                Out.WriteError("No valid language extension [field: lang] was set in the system_config table!");
                                Shutdown();
                            }
                        }
                    }
                }
            }
        }

        private static void Main()
        {
            Console.WindowHeight = Console.LargestWindowHeight - 0x19;
            Console.WindowWidth = Console.LargestWindowWidth - 0x19;
            Console.CursorVisible = false;
            Console.Title = "Phoenix Emulator";
            Out.WritePlain("  __                                    __                            ");
            Out.WritePlain(" /  |            |           /         /  | /                   /     ");
            Out.WritePlain("(___| ___  ___     ___  ___ (___      (___|(___  ___  ___  ___        ");
            Out.WritePlain("|    |   )|   )  )|___)|    |         |    |   )|   )|___)|   )| (_/_ ");
            Out.WritePlain("|    |    |__/  / |__  |__  |__       |    |  / |__/ |__  |  / |  / / ");
            Out.WritePlain("             __/                                                      ");
            Out.WriteBlank();
            Out.WritePlain("1.0.16");
            Out.WritePlain("Copyright \x00a9 2006 - 2009 Otaku Studios");
            Out.WriteBlank();
            Boot();
        }

        private static void monitorServer()
        {
            while (true)
            {
                int userCount = userManager.userCount;
                int peakUserCount = userManager.peakUserCount;
                int roomCount = roomManager.roomCount;
                int peakRoomCount = roomManager.peakRoomCount;
                int acceptedConnections = gameSocketServer.acceptedConnections;
                long num6 = GC.GetTotalMemory(false) / 0x400L;
                Console.Title = string.Concat(new object[] { "Project Phoenix | online users: ", userCount, " | loaded rooms ", roomCount, " | RAM usage: ", num6, "KB" });
                DB.runQuery(string.Concat(new object[] { "UPDATE system SET onlinecount = '", userCount, "',onlinecount_peak = '", peakUserCount, "',activerooms = '", roomCount, "',activerooms_peak = '", peakRoomCount, "',connections_accepted = '", acceptedConnections, "'" }));
                Thread.Sleep(0x1770);
                Out.WriteTrace("Servermonitor loop");
            }
        }

        private static void printDatabaseStats()
        {
            int num = DB.runRead("SELECT COUNT(*) FROM users", null);
            int num2 = DB.runRead("SELECT COUNT(*) FROM rooms", null);
            int num3 = DB.runRead("SELECT COUNT(*) FROM furniture", null);
            Out.WriteLine(string.Concat(new object[] { "Result: ", num, " users, ", num2, " rooms and ", num3, " furnitures." }));
        }

        private static void resetDynamics()
        {
            DB.runQuery("UPDATE system SET onlinecount = '0',onlinecount_peak = '0',connections_accepted = '0',activerooms = '0'");
            DB.runQuery("UPDATE users SET ticket_sso = NULL");
            DB.runQuery("UPDATE rooms SET visitors_now = '0'");
            Out.WriteLine("Client connection statistics reset.");
            Out.WriteLine("Room inside counts reset.");
            Out.WriteLine("Login tickets nulled.");
        }

        public static void Shutdown()
        {
            Out.WriteBlank();
            if (serverMonitor.IsAlive)
            {
                serverMonitor.Abort();
            }
            DB.closeConnection();
            Environment.Exit(2);
            Out.WriteLine("Shutdown completed. Press a key to exit.");
            Console.ReadKey(true);
            Console.Beep(0x578, 0x3e8);
            Environment.Exit(2);
        }

        public delegate void commonDelegate();
    }
}

