﻿namespace Otaku
{
    using Otaku.Managers;
    using System;

    public static class Config
    {
        internal static int BattleX;
        internal static int BattleY;
        internal static bool enableChatAnims;
        internal static bool enableRecycler;
        internal static bool enableTrading;
        internal static bool enableWelcomeMessage;
        internal static bool enableWordFilter;
        internal static int Game_BattleBall_gameLength_Seconds;
        internal static int Game_Countdown_Seconds;
        internal static int Game_scoreWindow_restartGame_Seconds;
        internal static int Items_Stacking_maxHeight;
        internal static byte Minimum_CFH_Rank;
        internal static byte Moderacy_ReceiveCFHs_minRank;
        internal static int Navigator_createRoom_maxRooms;
        internal static int Navigator_Favourites_maxRooms;
        internal static int Navigator_openCategory_maxResults;
        internal static int Navigator_roomSearch_maxResults;
        internal static string Rooms_LoadAvertisement_img;
        internal static string Rooms_LoadAvertisement_uri;
        internal static int Rooms_roomBan_banDuration;
        internal static int Soundmachine_burnToDisk_diskTemplateID;
        internal static int Statuses_itemCarrying_SipAmount;
        internal static int Statuses_itemCarrying_SipDuration;
        internal static int Statuses_itemCarrying_SipInterval;
        internal static int Statuses_Wave_waveDuration;

        public static string getTableEntry(string Key)
        {
            return DB.runRead("SELECT sval FROM system_config WHERE skey = '" + Key + "'");
        }

        public static void Init()
        {
            BattleX = DB.runRead("SELECT x FROM furniture WHERE id = '10181948'", null);
            BattleY = DB.runRead("SELECT y FROM furniture WHERE id = '10181948'", null);
            if (getTableEntry("chatanims_enable") == "1")
            {
                enableChatAnims = true;
                Out.WriteLine("Chat animations enabled.");
            }
            else
            {
                Out.WriteLine("Chat animations disabled.");
            }
            if (getTableEntry("trading_enable") == "1")
            {
                enableTrading = true;
                Out.WriteLine("Trading enabled.");
            }
            else
            {
                Out.WriteLine("Trading disabled.");
            }
            for (byte i = 1; i <= 7; i = (byte) (i + 1))
            {
                if (rankManager.containsRight(i, "fuse_receive_calls_for_help"))
                {
                    Moderacy_ReceiveCFHs_minRank = i;
                    break;
                }
            }
            Rooms_LoadAvertisement_img = getTableEntry("rooms_loadadvertisement_img");
            if (Rooms_LoadAvertisement_img != "")
            {
                Rooms_LoadAvertisement_uri = getTableEntry("rooms_loadadvertisement_uri");
                if (stringManager.getStringPart(Rooms_LoadAvertisement_uri, 0, 7) != "http://")
                {
                    Rooms_LoadAvertisement_uri = "http://www.otaku-studios.com";
                }
            }
            Rooms_roomBan_banDuration = int.Parse(getTableEntry("rooms_roomban_duration"));
            Statuses_itemCarrying_SipAmount = int.Parse(getTableEntry("statuses_carryitem_sipamount"));
            Statuses_itemCarrying_SipInterval = int.Parse(getTableEntry("statuses_carryitem_sipinterval"));
            Statuses_itemCarrying_SipDuration = int.Parse(getTableEntry("statuses_carryitem_sipduration"));
            Statuses_Wave_waveDuration = int.Parse(getTableEntry("statuses_wave_duration"));
            Items_Stacking_maxHeight = int.Parse(getTableEntry("items_stacking_maxstackheight"));
            Navigator_createRoom_maxRooms = int.Parse(getTableEntry("navigator_createroom_maxrooms"));
            Navigator_roomSearch_maxResults = int.Parse(getTableEntry("navigator_roomsearch_maxresults"));
            Navigator_openCategory_maxResults = int.Parse(getTableEntry("navigator_opencategory_maxresults"));
            Navigator_Favourites_maxRooms = int.Parse(getTableEntry("navigator_favourites_maxrooms"));
            Soundmachine_burnToDisk_diskTemplateID = int.Parse(getTableEntry("soundmachine_burntodisk_disktid"));
            Minimum_CFH_Rank = byte.Parse(DB.runRead("SELECT minrank FROM rank_fuserights WHERE fuseright = 'fuse_receive_calls_for_help'"));
            Minimum_CFH_Rank = byte.Parse(DB.runRead("SELECT minrank FROM rank_fuserights WHERE fuseright = 'fuse_receive_calls_for_help'"));
            Game_Countdown_Seconds = int.Parse(getTableEntry("game_countdown_seconds"));
            Game_scoreWindow_restartGame_Seconds = int.Parse(getTableEntry("game_scorewindow_restartgame_seconds"));
            Game_BattleBall_gameLength_Seconds = int.Parse(getTableEntry("game_bb_gamelength_seconds"));
        }
    }
}

