﻿namespace Otaku
{
    using System;
    using System.Diagnostics;

    public static class Out
    {
        public static logFlags minimumImportance;

        public static void WriteBlank()
        {
            Console.WriteLine();
        }

        public static void WriteError(string logText)
        {
            DateTime now = DateTime.Now;
            StackFrame frame = new StackTrace().GetFrame(1);
            Console.Write("[" + now.ToLongTimeString() + "] [");
            Console.ForegroundColor = ConsoleColor.Red;
            Console.Write(frame.GetMethod().ReflectedType.Name + "." + frame.GetMethod().Name);
            Console.ForegroundColor = ConsoleColor.Gray;
            Console.Write("] \x00bb ");
            Console.ForegroundColor = ConsoleColor.DarkRed;
            Console.WriteLine(logText);
            Console.ForegroundColor = ConsoleColor.Gray;
        }

        public static void WriteError(string logText, logFlags logFlag)
        {
            if (logFlag >= minimumImportance)
            {
                DateTime now = DateTime.Now;
                StackFrame frame = new StackTrace().GetFrame(1);
                Console.Write("[" + now.ToLongTimeString() + "] [");
                Console.ForegroundColor = ConsoleColor.Red;
                Console.Write(frame.GetMethod().ReflectedType.Name + "." + frame.GetMethod().Name);
                Console.ForegroundColor = ConsoleColor.Gray;
                Console.Write("] \x00bb ");
                Console.ForegroundColor = ConsoleColor.DarkRed;
                Console.WriteLine(logText);
                Console.ForegroundColor = ConsoleColor.Gray;
            }
        }

        public static void WriteLine(string logText)
        {
            DateTime now = DateTime.Now;
            new StackTrace().GetFrame(1);
            Console.Write("[" + now.ToLongTimeString() + "] \x00bb ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine(logText);
            Console.ForegroundColor = ConsoleColor.Gray;
        }

        public static void WriteLine(string logText, logFlags logFlag)
        {
            if (logFlag >= minimumImportance)
            {
                DateTime now = DateTime.Now;
                new StackTrace().GetFrame(1);
                Console.Write("[" + now.ToLongTimeString() + "] \x00bb ");
                Console.ForegroundColor = ConsoleColor.DarkGreen;
                Console.WriteLine(logText);
                Console.ForegroundColor = ConsoleColor.Gray;
            }
        }

        public static void WriteLine(string logText, string username)
        {
            DateTime now = DateTime.Now;
            new StackTrace().GetFrame(1);
            Console.Write("[" + now.ToLongTimeString() + "] [");
            Console.ForegroundColor = ConsoleColor.Red;
            Console.Write(username);
            Console.ForegroundColor = ConsoleColor.Gray;
            Console.Write("] \x00bb ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine(logText);
            Console.ForegroundColor = ConsoleColor.Gray;
        }

        public static void WriteLine(string logText, logFlags logFlag, ConsoleColor colorOne, ConsoleColor colorTwo)
        {
            if (logFlag >= minimumImportance)
            {
                DateTime now = DateTime.Now;
                StackFrame frame = new StackTrace().GetFrame(1);
                Console.Write("[" + now.ToLongTimeString() + "] [");
                Console.ForegroundColor = colorOne;
                Console.Write(frame.GetMethod().ReflectedType.Name + "." + frame.GetMethod().Name);
                Console.ForegroundColor = ConsoleColor.Gray;
                Console.Write("] \x00bb ");
                Console.ForegroundColor = colorTwo;
                Console.WriteLine(logText);
                Console.ForegroundColor = ConsoleColor.Gray;
            }
        }

        public static void WritePlain(string logText)
        {
            Console.WriteLine(logText);
        }

        public static void WriteSpecialLine(string logText, logFlags logFlag, ConsoleColor colorOne, ConsoleColor colorTwo, string headerHead, int headerLength, ConsoleColor headerColor)
        {
            DateTime now = DateTime.Now;
            StackFrame frame = new StackTrace().GetFrame(1);
            Console.Write("[" + now.ToLongTimeString() + "] [");
            Console.ForegroundColor = colorOne;
            Console.Write(frame.GetMethod().ReflectedType.Name + "." + frame.GetMethod().Name);
            Console.ForegroundColor = ConsoleColor.Gray;
            Console.Write("] " + headerHead + " ");
            Console.ForegroundColor = headerColor;
            Console.Write(logText.Substring(0, headerLength));
            Console.ForegroundColor = colorTwo;
            Console.WriteLine(logText.Substring(headerLength));
            Console.ForegroundColor = ConsoleColor.Gray;
        }

        public static void WriteTrace(string logText)
        {
        }

        public enum logFlags
        {
            MehAction,
            BelowStandardAction,
            StandardAction,
            ImportantAction
        }
    }
}

