﻿namespace Otaku.Virtual.Rooms.Items
{
    using Otaku;
    using Otaku.Managers;
    using System;

    public class floorItem
    {
        internal double H;
        internal int ID;
        internal int templateID;
        internal string Var;
        internal int X;
        internal int Y;
        internal byte Z;

        public floorItem(int ID, int tID, int X, int Y, int Z, double H, string Var)
        {
            this.ID = ID;
            this.templateID = tID;
            this.X = X;
            this.Y = Y;
            this.Z = Convert.ToByte(Z);
            this.H = H;
            this.Var = Var;
        }

        public override string ToString()
        {
            catalogueManager.itemTemplate template = catalogueManager.getTemplate(this.templateID);
            if (template.Sprite == "song_disk")
            {
                return string.Concat(new object[] { this.ID.ToString(), Convert.ToChar(2), template.Sprite, Convert.ToChar(2), Encoding.encodeVL64(this.X), Encoding.encodeVL64(this.Y), Encoding.encodeVL64(template.Length), Encoding.encodeVL64(template.Width), Encoding.encodeVL64(this.Z), this.H.ToString().Replace(",", "."), Convert.ToChar(2), template.Colour, Convert.ToChar(2), Convert.ToChar(2), this.Var, Convert.ToChar(2) });
            }
            return string.Concat(new object[] { 
                this.ID.ToString(), Convert.ToChar(2), template.Sprite, Convert.ToChar(2), Encoding.encodeVL64(this.X), Encoding.encodeVL64(this.Y), Encoding.encodeVL64(template.Length), Encoding.encodeVL64(template.Width), Encoding.encodeVL64(this.Z), this.H.ToString().Replace(",", "."), Convert.ToChar(2), template.Colour, Convert.ToChar(2), Convert.ToChar(2), "H", this.Var, 
                Convert.ToChar(2)
             });
        }

        internal string Sprite
        {
            get
            {
                return catalogueManager.getTemplate(this.templateID).Sprite;
            }
        }
    }
}

