﻿namespace Otaku.Virtual.Users
{
    using Otaku;
    using Otaku.Managers;
    using Otaku.Socketservers;
    using Otaku.Virtual.Rooms;
    using Otaku.Virtual.Rooms.Games;
    using Otaku.Virtual.Rooms.Items;
    using Otaku.Virtual.Rooms.Pathfinding;
    using Otaku.Virtual.Users.Items;
    using Otaku.Virtual.Users.Messenger;
    using System;
    using System.Globalization;
    using System.Net.Sockets;
    using System.Runtime.CompilerServices;
    using System.Text;
    using System.Threading;

    public class virtualUser
    {
        internal int _alcohol;
        internal bool _clubMember;
        internal string _consoleMission;
        internal int _Credits;
        internal string _Figure;
        internal int _groupID;
        internal int _groupMemberRank;
        private int _handPage;
        internal bool _hasRights;
        internal int _health;
        internal bool _hostsEvent;
        internal int _hunger;
        internal bool _inPublicroom;
        private bool _isDisconnected;
        private bool _isLoggedIn;
        internal bool _isMuted;
        internal bool _isOwner;
        internal bool _isRoomStaff;
        internal string _Mission;
        internal string _nowBadge;
        internal byte _Rank;
        private bool _receivedSpriteIndex;
        internal bool _ROOMACCESS_PRIMARY_OK;
        internal bool _ROOMACCESS_SECONDARY_OK;
        internal int _roomID;
        internal char _Sex;
        internal int _TeamID;
        internal int _teleporterID;
        internal int _Tickets;
        internal bool _tradeAccept;
        internal int _tradeItemCount;
        internal int[] _tradeItems = new int[0x41];
        internal int _tradePartnerRoomUID = -1;
        internal int _tradePartnerUID = -1;
        internal string _Username;
        private static Thread CaptureCheck;
        private int connectionID;
        private Socket connectionSocket;
        private byte[] dataBuffer = new byte[0x400];
        internal Otaku.Virtual.Rooms.Games.gamePlayer gamePlayer;
        internal virtualMessenger Messenger;
        internal bool pingOK;
        internal virtualRoom Room;
        internal virtualRoomUser roomUser;
        private virtualSongEditor songEditor;
        internal virtualRoomUserStatusManager statusManager;
        internal int userID;

        public virtualUser(int connectionID, Socket connectionSocket)
        {
            this.connectionID = connectionID;
            this.connectionSocket = connectionSocket;
            try
            {
                string str = userManager.getBanReason(this.connectionRemoteIP);
                if (str != "")
                {
                    this.sendData("@c" + str);
                    this.Disconnect();
                }
                else
                {
                    this.pingOK = true;
                    this.sendData("@@");
                    connectionSocket.BeginReceive(this.dataBuffer, 0, this.dataBuffer.Length, SocketFlags.None, new AsyncCallback(this.dataArrival), null);
                }
            }
            catch
            {
            }
        }

        internal void abortTrade()
        {
            if (((this.Room != null) && this.Room.containsUser(this._tradePartnerRoomUID)) && (this.roomUser != null))
            {
                virtualUser user = this.Room.getUser(this._tradePartnerRoomUID);
                this.sendData("An");
                this.refreshHand("update");
                user.sendData("An");
                user.refreshHand("update");
                this._tradePartnerRoomUID = -1;
                this._tradeAccept = false;
                this._tradeItems = new int[0x41];
                this._tradeItemCount = 0;
                this.statusManager.removeStatus("trd");
                this.roomUser.Refresh();
                user._tradePartnerRoomUID = -1;
                user._tradeAccept = false;
                user._tradeItems = new int[0x41];
                user._tradeItemCount = 0;
                user.statusManager.removeStatus("trd");
                user.roomUser.Refresh();
            }
        }

        internal void CapturePoint()
        {
            int num = 0;
            while (((num < 0x65) && (this.roomUser.X == 8)) && ((this.roomUser.Y == 7) && (this.roomUser.roomID == 0x2b3c)))
            {
                this.Room.sendShout(this.roomUser, "..." + num + "...");
                num++;
                switch (num)
                {
                    case 50:
                        userManager.sendData("BK" + this._Username + " is half way to capturing Ardashir!");
                        break;

                    case 100:
                        userManager.sendData("BK" + this._Username + " has captured Ardashir!");
                        break;
                }
                Thread.Sleep(0x1388);
            }
        }

        private void dataArrival(IAsyncResult iAr)
        {
            try
            {
                int num2;
                int count = this.connectionSocket.EndReceive(iAr);
                string str = Encoding.Default.GetString(this.dataBuffer, 0, count);
                if ((!str.Contains("\x0001") && !str.Contains("\x0002")) && (!str.Contains("\x0005") && !str.Contains("\t")))
                {
                    goto Label_008C;
                }
                this.Disconnect();
                return;
            Label_005C:
                num2 = Encoding.decodeB64(str.Substring(1, 2));
                this.processPacket(str.Substring(3, num2));
                str = str.Substring(num2 + 3);
                Out.WriteTrace("Processing packet part");
            Label_008C:
                if (str != "")
                {
                    goto Label_005C;
                }
                this.connectionSocket.BeginReceive(this.dataBuffer, 0, this.dataBuffer.Length, SocketFlags.None, new AsyncCallback(this.dataArrival), null);
            }
            catch
            {
                this.Disconnect();
            }
        }

        private void delDisconnectTimed(int ms)
        {
            this.connectionSocket.Shutdown(SocketShutdown.Receive);
            Thread.Sleep(ms);
            this.Disconnect();
        }

        internal void Disconnect()
        {
            if (!this._isDisconnected)
            {
                try
                {
                    this.connectionSocket.Close();
                }
                catch
                {
                }
                this.connectionSocket = null;
                if ((this.Room != null) && (this.roomUser != null))
                {
                    this.Room.removeUser(this.roomUser.roomUID, false, "");
                }
                if (this.Messenger != null)
                {
                    this.Messenger.Clear();
                }
                userManager.removeUser(this.userID);
                gameSocketServer.freeConnection(this.connectionID);
                this._isDisconnected = true;
            }
        }

        internal void Disconnect(int ms)
        {
            new timedDisconnector(this.delDisconnectTimed).BeginInvoke(ms, null, null);
        }

        private bool isSpeechCommand(string Text)
        {
            string[] s = Text.Split(new char[] { ' ' });
            try
            {
                int num3;
                virtualUser user2;
                string str5;
                virtualUser user3;
                string str7;
                virtualUser user4;
                virtualUser user5;
                string str9;
                int[] numArray2;
                int[] numArray3;
                string str13;
                int num6;
                string str14;
                int num7;
                switch (s[0])
                {
                    case "commands":
                        this.sendData("BKAvailable Commands:\r :about\r :poof\r :cleanhand\r :roomid\r :pickupall \r :stats \r :sleep");
                        goto Label_149B;

                    case "about":
                        this.sendData("BKPhoenix Emulator BETA");
                        goto Label_149B;

                    case "roomid":
                        this.sendData("BKRoomID: " + this.roomUser.roomID);
                        goto Label_149B;

                    case "location":
                        this.sendData(string.Concat(new object[] { "BKRoomID: ", this.roomUser.roomID, "\rX: ", this.roomUser.X, "\rY:", this.roomUser.Y, "\rZ2:", this.roomUser.Z2 }));
                        goto Label_149B;

                    case "fx":
                        this.statusManager.addStatus("fx", Text.Substring(2));
                        goto Label_149B;

                    case "poof":
                        this.refreshAppearance(true, true, true);
                        goto Label_149B;

                    case "pickupall":
                        if (this._isOwner)
                        {
                            break;
                        }
                        return false;

                    case "cleanhand":
                        DB.runQuery("DELETE FROM furniture WHERE ownerid = '" + this.userID + "' AND roomid = '0'");
                        this.refreshHand("new");
                        goto Label_149B;

                    case "carry":
                        if (rankManager.containsRight(this._Rank, "fuse_administrator_access"))
                        {
                            goto Label_0502;
                        }
                        return false;

                    case "poll":
                        userManager.sendData("D|IYou have followed the draft, now tell me the code on the ice wall! Did you hear the sounds?!\x0002");
                        goto Label_149B;

                    case "capture":
                        if (((this.roomUser.X == 8) && (this.roomUser.Y == 7)) && (this.roomUser.roomID == 0x2b3c))
                        {
                            userManager.sendData("BK" + this._Username + " has begun capturing Ardashir!");
                            this.Room.sendShout(this.roomUser, "Capturing point...");
                            CaptureCheck = new Thread(new ThreadStart(this.CapturePoint));
                            CaptureCheck.Priority = ThreadPriority.BelowNormal;
                            CaptureCheck.Start();
                        }
                        goto Label_149B;

                    case "die":
                        this._health = 0;
                        this.KillUser();
                        goto Label_149B;

                    case "sleep":
                        if (this.statusManager.containsStatus("lay"))
                        {
                            this.Room.sendShout(this.roomUser, "Zzzzz Zzzzz");
                            this._alcohol = 0;
                        }
                        goto Label_149B;

                    case "time":
                        if (rankManager.containsRight(this._Rank, "fuse_administrator_access"))
                        {
                            goto Label_0622;
                        }
                        return false;

                    case "stats":
                        this.sendData(string.Concat(new object[] { "BKStats\rName: ", this._Username, "\rHealth: ", this._health, "\rHunger: ", this._hunger, "\rAlcohol: ", this._alcohol }));
                        goto Label_149B;

                    case "battleready":
                        if ((((this.roomUser.X != 7) || (this.roomUser.Y != 2)) && ((this.roomUser.X != 9) || (this.roomUser.Y != 2))) && ((this.roomUser.X == 11) && (this.roomUser.Y == 2)))
                        {
                        }
                        goto Label_149B;

                    case "score":
                        if ((this.roomUser.X == Config.BattleX) && (this.roomUser.Y == Config.BattleY))
                        {
                            Config.BattleX = new Random().Next(1, 12);
                            Config.BattleY = new Random().Next(1, 12);
                            this.Room.floorItemManager.relocateItem(0x9b5d3c, Config.BattleX, Config.BattleY, 2);
                            this.sendData("BKScooooore!");
                        }
                        goto Label_149B;

                    case "join":
                        num3 = Convert.ToInt16(Text.Substring(5));
                        if (num3 != 1)
                        {
                            goto Label_0826;
                        }
                        this._TeamID = 1;
                        this._Figure = "hd-185-1.ch-255-62.lg-280-62.sh-906-62.ea-1406-.wa-2009-62.ha-1008-.ca-1805-62";
                        this._Mission = "Battle Bunny!";
                        this.refreshAppearance(false, true, true);
                        goto Label_149B;

                    case "push":
                    {
                        string str3 = "down";
                        virtualUser user = userManager.getUser(Text.Split(new char[] { ' ' })[1]);
                        if ((user.roomUser != this.roomUser) && ((((this.roomUser.X + 1) == user.roomUser.X) || ((this.roomUser.X - 1) == user.roomUser.X)) || (((this.roomUser.Y + 1) == user.roomUser.Y) || ((this.roomUser.Y - 1) == user.roomUser.Y))))
                        {
                            if (this.roomUser.Z2 == 0)
                            {
                                str3 = "up";
                            }
                            if (this.roomUser.Z2 == 2)
                            {
                                str3 = "right";
                            }
                            if (this.roomUser.Z2 == 4)
                            {
                                str3 = "down";
                            }
                            if (this.roomUser.Z2 == 6)
                            {
                                str3 = "left";
                            }
                            if (str3 == "up")
                            {
                                user.roomUser.goalX = user.roomUser.X;
                                user.roomUser.goalY = user.roomUser.Y - 1;
                            }
                            if (str3 == "right")
                            {
                                user.roomUser.goalX = user.roomUser.X + 1;
                                user.roomUser.goalY = user.roomUser.Y;
                            }
                            if (str3 == "down")
                            {
                                user.roomUser.goalX = user.roomUser.X;
                                user.roomUser.goalY = user.roomUser.Y + 1;
                            }
                            if (str3 == "left")
                            {
                                user.roomUser.goalX = user.roomUser.X - 1;
                                user.roomUser.goalY = user.roomUser.Y;
                            }
                        }
                        goto Label_149B;
                    }
                    case "alert":
                        if (rankManager.containsRight(this._Rank, "fuse_alert"))
                        {
                            goto Label_0A75;
                        }
                        return false;

                    case "roomalert":
                        if (rankManager.containsRight(this._Rank, "fuse_room_alert"))
                        {
                            goto Label_0B03;
                        }
                        return false;

                    case "kick":
                        if (rankManager.containsRight(this._Rank, "fuse_kick"))
                        {
                            goto Label_0B70;
                        }
                        return false;

                    case "roomkick":
                        if (rankManager.containsRight(this._Rank, "fuse_room_kick"))
                        {
                            goto Label_0C35;
                        }
                        return false;

                    case "shutup":
                        if (rankManager.containsRight(this._Rank, "fuse_mute"))
                        {
                            goto Label_0CAC;
                        }
                        return false;

                    case "unmute":
                        if (rankManager.containsRight(this._Rank, "fuse_mute"))
                        {
                            goto Label_0D7C;
                        }
                        return false;

                    case "roomshutup":
                        if (rankManager.containsRight(this._Rank, "fuse_room_mute"))
                        {
                            goto Label_0E3F;
                        }
                        return false;

                    case "roomunmute":
                        if (rankManager.containsRight(this._Rank, "fuse_room_mute"))
                        {
                            goto Label_0EB6;
                        }
                        return false;

                    case "ban":
                        if (rankManager.containsRight(this._Rank, "fuse_ban"))
                        {
                            goto Label_0F25;
                        }
                        return false;

                    case "superban":
                        if (rankManager.containsRight(this._Rank, "fuse_superban"))
                        {
                            goto Label_1057;
                        }
                        return false;

                    case "ha":
                        if (rankManager.containsRight(this._Rank, "fuse_administrator_access"))
                        {
                            goto Label_11A4;
                        }
                        return false;

                    case "offline":
                        if (rankManager.containsRight(this._Rank, "fuse_administrator_access"))
                        {
                            goto Label_1204;
                        }
                        return false;

                    case "ra":
                        if (rankManager.containsRight(this._Rank, "fuse_alert"))
                        {
                            goto Label_126A;
                        }
                        return false;

                    case "teleport":
                        if (rankManager.containsRight(this._Rank, "fuse_teleport"))
                        {
                            goto Label_12D6;
                        }
                        return false;

                    case "catalogue":
                        if (rankManager.containsRight(this._Rank, "fuse_administrator_access"))
                        {
                            goto Label_1317;
                        }
                        return false;

                    case "specbar":
                        if (rankManager.containsRight(this._Rank, "fuse_administrator_access"))
                        {
                            goto Label_133B;
                        }
                        return false;

                    case "warp":
                        if (rankManager.containsRight(this._Rank, "fuse_teleport"))
                        {
                            goto Label_1380;
                        }
                        return false;

                    case "userinfo":
                        if (rankManager.containsRight(this._Rank, "fuse_administrator_access"))
                        {
                            goto Label_13F3;
                        }
                        return false;

                    case "pet_transform":
                        if (rankManager.containsRight(this._Rank, "fuse_administrator_access"))
                        {
                            goto Label_1434;
                        }
                        return false;

                    default:
                        return false;
                }
                int[] numArray = DB.runReadColumn("SELECT id FROM furniture WHERE roomid = '" + this._roomID + "'", 0, null);
                if (numArray.Length > 0)
                {
                    for (int i = 0; i < numArray.Length; i++)
                    {
                        int itemID = numArray[i];
                        if (this.Room.floorItemManager.containsItem(itemID))
                        {
                            this.Room.floorItemManager.removeItem(itemID, this.userID);
                        }
                        else if (this.Room.wallItemManager.containsItem(itemID) && (stringManager.getStringPart(this.Room.wallItemManager.getItem(itemID).Sprite, 0, 7) != "post.it"))
                        {
                            this.Room.wallItemManager.removeItem(itemID, this.userID);
                        }
                    }
                }
                this.refreshHand("update");
                goto Label_149B;
            Label_0502:
                this.statusManager.carryItem(Text.Substring(6));
                goto Label_149B;
            Label_0622:
                Text.Substring(5);
                this.Room.sendData("@nlandscape/" + Text.Substring(5) + "." + DB.runRead("SELECT landscape FROM rooms WHERE id = '" + this._roomID + "'").Split(new char[] { '.' })[1]);
                goto Label_149B;
            Label_0826:
                if (num3 == 2)
                {
                    this._TeamID = 2;
                    this._Figure = "hd-185-30.ch-255-90.lg-280-91.sh-906-90.ea-1401-62.wa-2009-91.ha-1020-.ca-1803-90.fa-1205-90";
                    this._Mission = "Battle Bear!";
                    this.refreshAppearance(false, true, true);
                }
                goto Label_149B;
            Label_0A75:
                user2 = userManager.getUser(DB.Stripslash(s[1]));
                user2.sendData("B!" + stringManager.wrapParameters(s, 2) + Convert.ToChar(2));
                this.sendData("BK" + stringManager.getString("scommand_success"));
                staffManager.addStaffMessage("alert", this.userID, user2.userID, s[2], "");
                goto Label_149B;
            Label_0B03:
                str5 = Text.Substring(10);
                this.Room.sendData("B!" + str5 + Convert.ToChar(2));
                staffManager.addStaffMessage("ralert", this.userID, this.Room.roomID, str5, "");
                goto Label_149B;
            Label_0B70:
                user3 = userManager.getUser(DB.Stripslash(s[1]));
                if (user3._Rank < this._Rank)
                {
                    string moderatorMessage = "";
                    if (s.Length > 2)
                    {
                        moderatorMessage = stringManager.wrapParameters(s, 2);
                    }
                    user3.Room.removeUser(user3.roomUser.roomUID, true, moderatorMessage);
                    this.sendData("BK" + stringManager.getString("scommand_success"));
                    staffManager.addStaffMessage("kick", this.userID, user3.userID, moderatorMessage, "");
                }
                else
                {
                    this.sendData("BK" + stringManager.getString("scommand_failed"));
                }
                goto Label_149B;
            Label_0C35:
                str7 = stringManager.wrapParameters(s, 1);
                this.Room.kickUsers(this._Rank, str7);
                this.sendData("BK" + stringManager.getString("scommand_success"));
                staffManager.addStaffMessage("rkick", this.userID, this.Room.roomID, str7, "");
                goto Label_149B;
            Label_0CAC:
                user4 = userManager.getUser(DB.Stripslash(s[1]));
                if ((user4._Rank < this._Rank) && !user4._isMuted)
                {
                    string message = stringManager.wrapParameters(s, 2);
                    user4._isMuted = true;
                    user4.sendData("BK" + stringManager.getString("scommand_muted") + "\r" + message);
                    this.sendData("BK" + stringManager.getString("scommand_success"));
                    staffManager.addStaffMessage("mute", this.userID, user4.userID, message, "");
                }
                else
                {
                    this.sendData("BK" + stringManager.getString("scommand_failed"));
                }
                goto Label_149B;
            Label_0D7C:
                user5 = userManager.getUser(DB.Stripslash(s[1]));
                if ((user5._Rank < this._Rank) && user5._isMuted)
                {
                    user5._isMuted = false;
                    user5.sendData("BK" + stringManager.getString("scommand_unmuted"));
                    this.sendData("BK" + stringManager.getString("scommand_success"));
                    staffManager.addStaffMessage("unmute", this.userID, user5.userID, "", "");
                }
                else
                {
                    this.sendData("BK" + stringManager.getString("scommand_failed"));
                }
                goto Label_149B;
            Label_0E3F:
                str9 = stringManager.wrapParameters(s, 1);
                this.Room.muteUsers(this._Rank, str9);
                this.sendData("BK" + stringManager.getString("scommand_success"));
                staffManager.addStaffMessage("rmute", this.userID, this.Room.roomID, str9, "");
                goto Label_149B;
            Label_0EB6:
                this.Room.unmuteUsers(this._Rank);
                this.sendData("BK" + stringManager.getString("scommand_success"));
                staffManager.addStaffMessage("runmute", this.userID, this.Room.roomID, "", "");
                goto Label_149B;
            Label_0F25:
                numArray2 = DB.runReadRow("SELECT id,rank FROM users WHERE name = '" + DB.Stripslash(s[1]) + "'", null);
                if (numArray2.Length == 0)
                {
                    this.sendData("BK" + stringManager.getString("modtool_actionfailed") + "\r" + stringManager.getString("modtool_usernotfound"));
                }
                else if (((byte) numArray2[1]) > this._Rank)
                {
                    this.sendData("BK" + stringManager.getString("modtool_actionfailed") + "\r" + stringManager.getString("modtool_rankerror"));
                }
                else
                {
                    int hours = int.Parse(s[2]);
                    string str10 = stringManager.wrapParameters(s, 3);
                    if ((hours == 0) || (str10 == ""))
                    {
                        this.sendData("BK" + stringManager.getString("scommand_failed"));
                    }
                    else
                    {
                        staffManager.addStaffMessage("ban", this.userID, numArray2[0], str10, "");
                        userManager.setBan(numArray2[0], hours, str10);
                        this.sendData("BK" + userManager.generateBanReport(numArray2[0]));
                    }
                }
                goto Label_149B;
            Label_1057:
                numArray3 = DB.runReadRow("SELECT id,rank FROM users WHERE name = '" + DB.Stripslash(s[1]) + "'", null);
                if (numArray3.Length == 0)
                {
                    this.sendData("BK" + stringManager.getString("modtool_actionfailed") + "\r" + stringManager.getString("modtool_usernotfound"));
                }
                else if (((byte) numArray3[1]) > this._Rank)
                {
                    this.sendData("BK" + stringManager.getString("modtool_actionfailed") + "\r" + stringManager.getString("modtool_rankerror"));
                }
                else
                {
                    int num5 = int.Parse(s[2]);
                    string str11 = stringManager.wrapParameters(s, 3);
                    if ((num5 == 0) || (str11 == ""))
                    {
                        this.sendData("BK" + stringManager.getString("scommand_failed"));
                    }
                    else
                    {
                        string iP = DB.runRead("SELECT ipaddress_last FROM users WHERE id = '" + numArray3[0] + "'");
                        staffManager.addStaffMessage("ban", this.userID, numArray3[0], str11, "");
                        userManager.setBan(iP, num5, str11);
                        this.sendData("BK" + userManager.generateBanReport(iP));
                    }
                }
                goto Label_149B;
            Label_11A4:
                str13 = Text.Substring(3);
                userManager.sendData("BK" + stringManager.getString("scommand_hotelalert") + "\r" + str13);
                staffManager.addStaffMessage("halert", this.userID, 0, str13, "");
                goto Label_149B;
            Label_1204:
                num6 = int.Parse(s[1]);
                userManager.sendData("Dc" + Encoding.encodeVL64(num6));
                staffManager.addStaffMessage("offline", this.userID, 0, "mm=" + num6, "");
                goto Label_149B;
            Label_126A:
                str14 = Text.Substring(3);
                userManager.sendToRank(this._Rank, false, "BK" + stringManager.getString("scommand_rankalert") + "\r" + str14);
                staffManager.addStaffMessage("rankalert", this.userID, this._Rank, str14, "");
                goto Label_149B;
            Label_12D6:
                this.roomUser.SPECIAL_TELEPORTABLE = !this.roomUser.SPECIAL_TELEPORTABLE;
                this.refreshAppearance(false, false, true);
                goto Label_149B;
            Label_1317:
                catalogueManager.Init();
                goto Label_149B;
            Label_133B:
                this.sendData("Dj" + Encoding.encodeVL64(this._health) + Encoding.encodeVL64(this._hunger));
                goto Label_149B;
            Label_1380:
                num7 = int.Parse(s[1]);
                int num8 = int.Parse(s[2]);
                this.roomUser.X = num7;
                this.roomUser.Y = num8;
                this.roomUser.goalX = -1;
                this.Room.Refresh(this.roomUser);
                this.refreshAppearance(false, false, true);
                goto Label_149B;
            Label_13F3:
                this.sendData("BK" + userManager.generateUserInfo(userManager.getUserID(DB.Stripslash(s[1])), this._Rank));
                goto Label_149B;
            Label_1434:
                if (this.Room != null)
                {
                    this.roomUser.petTransform = !this.roomUser.petTransform;
                    this.Room.sendData(@"@\" + this.roomUser.detailsString);
                }
            }
            catch
            {
                this.sendData("BK" + stringManager.getString("scommand_failed"));
            }
        Label_149B:
            return true;
        }

        internal void KillUser()
        {
            this.Room.removeUser(this.roomUser.roomUID, false, "");
            this._roomID = 0x2ac9;
            if (roomManager.containsRoom(this._roomID))
            {
                this.Room = roomManager.getRoom(this._roomID);
            }
            else
            {
                this.Room = new virtualRoom(this._roomID, this._inPublicroom);
                roomManager.addRoom(this._roomID, this.Room);
            }
            string str = "model_" + DB.runRead("SELECT model FROM rooms WHERE id = '" + this._roomID + "'");
            this.sendData(string.Concat(new object[] { "AE", str, " ", this._roomID }));
            int num = DB.runRead("SELECT wallpaper FROM rooms WHERE id = '" + this._roomID + "'", null);
            int num2 = DB.runRead("SELECT floor FROM rooms WHERE id = '" + this._roomID + "'", null);
            string str2 = DB.runRead("SELECT landscape FROM rooms WHERE id = '" + this._roomID + "'");
            if (num > 0)
            {
                this.sendData("@nwallpaper/" + num);
            }
            if (num2 > 0)
            {
                this.sendData("@nfloor/" + num2);
            }
            this.sendData("@nlandscape/" + str2);
            if (!this._isOwner)
            {
                this._isOwner = rankManager.containsRight(this._Rank, "fuse_any_room_controller");
            }
            if (this._isOwner)
            {
                this._hasRights = true;
                this.sendData("@o");
            }
            if (this._hasRights)
            {
                this.sendData("@j");
            }
            int i = -1;
            if (DB.checkExists(string.Concat(new object[] { "SELECT userid FROM room_votes WHERE userid = '", this.userID, "' AND roomid = '", this._roomID, "'" })))
            {
                i = DB.runRead("SELECT SUM(vote) FROM room_votes WHERE roomid = '" + this._roomID + "'", null);
                if (i < 0)
                {
                    i = 0;
                }
            }
            this.sendData("EY" + Encoding.encodeVL64(i));
            this.sendData("Er" + eventManager.getEvent(this._roomID));
            this.sendData("@_" + this.Room.Heightmap);
            this.sendData(@"@\" + this.Room.dynamicUnits);
            this.sendData("@^" + this.Room.PublicroomItems);
            this.sendData("@`" + this.Room.Flooritems);
            this.sendData("@m" + this.Room.Wallitems);
            this.sendData("@b" + this.Room.dynamicStatuses);
            this._ROOMACCESS_PRIMARY_OK = true;
            this._ROOMACCESS_SECONDARY_OK = true;
            this.Room.addUser(this);
            this._health = 100;
            this._hunger = 0;
            this.sendData("BKYou have passed out from starvation and been revived at the nearest hospital, this service is currently free.");
        }

        internal void leaveGame()
        {
            if ((this.gamePlayer != null) && (this.gamePlayer.Game != null))
            {
                if (this.gamePlayer.Game.Owner == this.gamePlayer)
                {
                    try
                    {
                        this.gamePlayer.Game.Lobby.Games.Remove(this.gamePlayer.Game.ID);
                    }
                    catch
                    {
                    }
                    this.gamePlayer.Game.Abort();
                }
                else if (this.gamePlayer.teamID != -1)
                {
                    this.gamePlayer.Game.movePlayer(this.gamePlayer, this.gamePlayer.teamID, -1);
                }
                else
                {
                    this.gamePlayer.Game.Subviewers.Remove(this.gamePlayer);
                    this.sendData("CmH");
                }
            }
            this.gamePlayer = null;
        }

        private bool PollSorter(string Text)
        {
            string str = Text;
            if (str != null)
            {
                if (!(str == "I"))
                {
                    if (str == "J")
                    {
                        this.sendData("D}IChristmas Puzzle\x0002Thank you for the answer. Unfortunatly I'm still under construction hehe.\x0002JKIKWhat kind of animal was rudolph?\x0002HJKQuestion 2?\x0002");
                        goto Label_003D;
                    }
                }
                else
                {
                    this.sendData("BKThankyou sir!\r\rNOTE: This is incomplete.");
                    goto Label_003D;
                }
            }
            return false;
        Label_003D:
            return true;
        }

        private void processPacket(string currentPacket)
        {
            string str3;
            if (this._isLoggedIn)
            {
                string str113;
                object obj2;
                Out.WriteLine(currentPacket, this._Username);
                switch (currentPacket.Substring(0, 2))
                {
                    case "CD":
                        this.pingOK = true;
                        return;

                    case "Cj":
                        this.PollSorter(currentPacket.Substring(2));
                        return;

                    case "Ch":
                    {
                        string[] strArray2 = DB.runReadRow("SELECT id,name,owner,description,state,visitors_now,visitors_max FROM rooms WHERE id = '" + this.Room.roomID + "'");
                        string[] strArray3 = DB.runReadRow("SELECT id,name,credits FROM users WHERE name = '" + strArray2[2] + "'");
                        int num3 = DB.runRead("SELECT credits FROM users WHERE name = '" + strArray3[1] + "'", null);
                        this.Room.sendData("Dx" + currentPacket.Substring(2) + "IH");
                        this.roomUser.goalX = -1;
                        str3 = "";
                        int x = this.roomUser.X;
                        int y = this.roomUser.Y;
                        if (x == (this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X + 1))
                        {
                            str3 = "X1";
                        }
                        if (x == (this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X - 1))
                        {
                            str3 = "X-1";
                        }
                        if (y == (this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y + 1))
                        {
                            str3 = "Y1";
                        }
                        if (y == (this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y - 1))
                        {
                            str3 = "Y-1";
                        }
                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                        Thread.Sleep(500);
                        if (this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Sprite == "one_way_door*0")
                        {
                            switch (str3)
                            {
                                case "X-1":
                                    this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X + 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                                    break;

                                case "X1":
                                    this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X - 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                                    break;

                                case "Y-1":
                                    this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y + 1, true);
                                    break;

                                case "Y1":
                                    this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y - 1, true);
                                    break;
                            }
                        }
                        if (this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Sprite == "one_way_door*1")
                        {
                            if (((this._Credits - 5) > -1) && !this._isOwner)
                            {
                                this._Credits -= 5;
                                num3 += 5;
                                this.sendData("@F" + this._Credits);
                                this.sendData("BKYou have been charged 5 credits for entry.");
                                DB.runQuery(string.Concat(new object[] { "UPDATE users SET credits = '", num3, "' WHERE id = '", strArray3[0], "'" }));
                                switch (str3)
                                {
                                    case "X-1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X + 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                                        break;

                                    case "X1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X - 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                                        break;

                                    case "Y-1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y + 1, true);
                                        break;

                                    case "Y1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y - 1, true);
                                        break;
                                }
                            }
                            else if (this._isOwner)
                            {
                                switch (str3)
                                {
                                    case "X-1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X + 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                                        break;

                                    case "X1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X - 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                                        break;

                                    case "Y-1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y + 1, true);
                                        break;

                                    case "Y1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y - 1, true);
                                        break;
                                }
                            }
                            else
                            {
                                this.sendData("BKYou cannot afford entry here.");
                                switch (str3)
                                {
                                    case "X1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X + 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                                        break;

                                    case "X-1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X - 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                                        break;

                                    case "Y1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y + 1, true);
                                        break;

                                    case "Y-1":
                                        this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y - 1, true);
                                        goto Label_173A;
                                }
                            }
                        }
                        goto Label_173A;
                    }
                    case "FL":
                        this.sendData("DwQAI");
                        return;

                    case "Dm":
                        this.sendData("FZH");
                        return;

                    case "Dn":
                        this.sendData("FYPC1\x0002SnowStorm level 1\x0002HI2\x0002SnowStorm level 2\x0002HJ3\x0002SnowStorm level 3\x0002HK4\x0002SnowStorm level 4\x0002HPA5\x0002SnowStorm level 5\x0002HQA6\x0002SnowStorm level 6\x0002HRA7\x0002SnowStorm level 7\x0002HSA8\x0002Bouncing Ball level 1\x0002III9\x0002Bouncing Ball level 2\x0002IJI10\x0002Bouncing Ball level 3\x0002IKI11\x0002Bouncing Ball level 4\x0002IPAI12\x0002Bouncing Ball level 5\x0002IQAH");
                        return;

                    case "Dc":
                        this.sendData("DcFG" + Convert.ToChar(1));
                        return;

                    case "Da":
                    {
                        string str4 = currentPacket.Substring(2);
                        this.statusManager.removeStatus("dance");
                        this.statusManager.removeStatus("wave");
                        this.statusManager.removeStatus("fx");
                        this.statusManager.addStatus("joingame", str4.ToString());
                        return;
                    }
                    case "Dl":
                        this.sendData("FIRA");
                        return;

                    case "Dw":
                        this.sendData("DwFL" + Convert.ToChar(1));
                        return;

                    case "Dr":
                        this.sendData("BrDa" + Convert.ToChar(1));
                        return;

                    case "Du":
                        this.sendData("FLPBH");
                        return;

                    case "Dv":
                        this.sendData("DvBKDv" + Convert.ToChar(1));
                        return;

                    case "Dx":
                        this.sendData("DxQA");
                        return;

                    case "@q":
                        this.sendData("Bc" + DateTime.Today.ToShortDateString());
                        return;

                    case "@L":
                        this._health = 100;
                        this._hunger = 1;
                        this._alcohol = 0;
                        this.sendData("Dj" + Encoding.encodeVL64(this._health) + Encoding.encodeVL64(this._hunger));
                        this.Messenger = new virtualMessenger(this.userID);
                        this.sendData("@L" + this.Messenger.friendList());
                        this.sendData("Dz" + this.Messenger.friendRequests());
                        return;

                    case "@Z":
                        return;

                    case "@G":
                        this.refreshAppearance(false, true, false);
                        return;

                    case "@H":
                        this.refreshValueables(true, true);
                        this.sendData("FtRPPAIACH_Login1\x0002PAJACH_Login2\x0002PAKACH_Login3\x0002PAPAACH_Login4\x0002PAQAACH_Login5\x0002PBIACH_RoomEntry1\x0002PBJACH_RoomEntry2\x0002PBKACH_RoomEntry3\x0002SBIACH_RegistrationDuration1\x0002SBJACH_RegistrationDuration2\x0002SBKACH_RegistrationDuration3\x0002SBPAACH_RegistrationDuration4\x0002SBQAACH_RegistrationDuration5\x0002SBRAACH_RegistrationDuration6\x0002SBSAACH_RegistrationDuration7\x0002SBPBACH_RegistrationDuration8\x0002SBQBACH_RegistrationDuration9\x0002SBRBACH_RegistrationDuration10\x0002PDIACH_AvatarTags1\x0002RDIACH_RespectGiven1\x0002KIACH_EmailVerification1\x0002SAIACH_Student1\x0002PCIHC1\x0002PCJHC2\x0002PCKHC3\x0002PCPAHC4\x0002PCQAHC5\x0002QDIACH_RespectEarned1\x0002QDJACH_RespectEarned2\x0002QDKACH_RespectEarned3\x0002QDPAACH_RespectEarned4\x0002QDQAACH_RespectEarned5\x0002QDRAACH_RespectEarned6\x0002QDSAACH_RespectEarned7\x0002QDPBACH_RespectEarned8\x0002QDQBACH_RespectEarned9\x0002QDRBACH_RespectEarned10\x0002JIACH_Graduate1\x0002QCIACH_MGM1\x0002QCJACH_MGM2\x0002QCKACH_MGM3\x0002QCPAACH_MGM4\x0002QCQAACH_MGM5\x0002QCRAACH_MGM6\x0002QCSAACH_MGM7\x0002QCPBACH_MGM8\x0002QCQBACH_MGM9\x0002QCRBACH_MGM10\x0002QBIACH_Motto1\x0002RAIACH_AvatarLooks1\x0002IIGLA\x0002IJGLB\x0002IKGLC\x0002IPAGLD\x0002IQAGLE\x0002IRAGLF\x0002ISAGLG\x0002IPBGLH\x0002IQBGLI\x0002IRBGLJ\x0002RBIACH_HappyHour1\x0002QAIACH_GamePlayed1\x0002QAJACH_GamePlayed2\x0002QAKACH_GamePlayed3\x0002QAPAACH_GamePlayed4\x0002QAQAACH_GamePlayed5\x0002\x0001");
                        return;

                    case "B]":
                        this.refreshBadges();
                        return;

                    case "Cd":
                        this.refreshGroupStatus();
                        return;

                    case "C^":
                        this.sendData("Do" + recyclerManager.setupString);
                        return;

                    case "C_":
                        this.sendData("Dp" + recyclerManager.sessionString(this.userID));
                        return;

                    case "BA":
                    {
                        string str5 = DB.Stripslash(currentPacket.Substring(4));
                        if (!DB.checkExists("SELECT * FROM vouchers WHERE voucher = '" + str5 + "'"))
                        {
                            this.sendData("CU1");
                            return;
                        }
                        int num6 = DB.runRead("SELECT credits FROM vouchers WHERE voucher = '" + str5 + "'", null);
                        DB.runQuery("DELETE FROM vouchers WHERE voucher = '" + str5 + "' LIMIT 1");
                        this._Credits += num6;
                        this.sendData("@F" + this._Credits);
                        this.sendData("CT");
                        DB.runQuery(string.Concat(new object[] { "UPDATE users SET credits = '", num6, "' WHERE id = '", this.userID, "' LIMIT 1" }));
                        return;
                    }
                    case "@g":
                        if (this.Messenger != null)
                        {
                            int userID = DB.runRead("SELECT id FROM users WHERE name = '" + DB.Stripslash(currentPacket.Substring(4)) + "'", null);
                            if (((userID <= 0) || this.Messenger.hasFriendRequests(userID)) || this.Messenger.hasFriendship(userID))
                            {
                                return;
                            }
                            int num8 = DB.runReadUnsafe("SELECT MAX(requestid) FROM messenger_friendrequests WHERE userid_to = '" + userID + "'", null) + 1;
                            DB.runQuery(string.Concat(new object[] { "INSERT INTO messenger_friendrequests(userid_to,userid_from,requestid) VALUES ('", userID, "','", this.userID, "','", num8, "')" }));
                            userManager.getUser(userID).sendData(string.Concat(new object[] { "BDI", this._Username, Convert.ToChar(2), this.userID, Convert.ToChar(2) }));
                        }
                        return;

                    case "@e":
                        if (this.Messenger != null)
                        {
                            int i = Encoding.decodeVL64(currentPacket.Substring(2));
                            currentPacket = currentPacket.Substring(Encoding.encodeVL64(i).Length + 2);
                            int num10 = 0;
                            StringBuilder builder = new StringBuilder();
                            virtualBuddy buddy = new virtualBuddy(this.userID);
                            for (int j = 0; j < i; j++)
                            {
                                if (currentPacket == "")
                                {
                                    return;
                                }
                                int num12 = Encoding.decodeVL64(currentPacket);
                                int num13 = DB.runRead(string.Concat(new object[] { "SELECT userid_from FROM messenger_friendrequests WHERE userid_to = '", this.userID, "' AND requestid = '", num12, "'" }), null);
                                if (num13 == 0)
                                {
                                    return;
                                }
                                virtualBuddy buddy2 = new virtualBuddy(num13);
                                builder.Append(buddy2.ToString(true));
                                num10++;
                                this.Messenger.addBuddy(buddy2, false);
                                if (userManager.containsUser(num13))
                                {
                                    userManager.getUser(num13).Messenger.addBuddy(buddy, true);
                                }
                                DB.runQuery(string.Concat(new object[] { "INSERT INTO messenger_friendships(userid,friendid) VALUES ('", num13, "','", this.userID, "')" }));
                                DB.runQuery(string.Concat(new object[] { "DELETE FROM messenger_friendrequests WHERE userid_to = '", this.userID, "' AND requestid = '", num12, "' LIMIT 1" }));
                                currentPacket = currentPacket.Substring(Encoding.encodeVL64(num12).Length);
                            }
                            if (num10 > 0)
                            {
                                this.sendData("@MHI" + Encoding.encodeVL64(num10) + builder.ToString());
                            }
                        }
                        return;

                    case "@f":
                        if (this.Messenger != null)
                        {
                            int num14 = Encoding.decodeVL64(currentPacket.Substring(2));
                            currentPacket = currentPacket.Substring(Encoding.encodeVL64(num14).Length + 2);
                            for (int k = 0; k < num14; k++)
                            {
                                if (currentPacket == "")
                                {
                                    return;
                                }
                                int num16 = Encoding.decodeVL64(currentPacket);
                                DB.runQuery(string.Concat(new object[] { "DELETE FROM messenger_friendrequests WHERE userid_to = '", this.userID, "' AND requestid = '", num16, "' LIMIT 1" }));
                                currentPacket = currentPacket.Substring(Encoding.encodeVL64(num16).Length);
                            }
                        }
                        return;

                    case "@h":
                        if (this.Messenger != null)
                        {
                            int iD = Encoding.decodeVL64(currentPacket.Substring(3));
                            this.Messenger.removeBuddy(iD);
                            if (userManager.containsUser(iD))
                            {
                                userManager.getUser(iD).Messenger.removeBuddy(this.userID);
                            }
                            DB.runQuery(string.Concat(new object[] { "DELETE FROM messenger_friendships WHERE (userid = '", this.userID, "' AND friendid = '", iD, "') OR (userid = '", iD, "' AND friendid = '", this.userID, "') LIMIT 1" }));
                        }
                        return;

                    case "@a":
                        if (this.Messenger != null)
                        {
                            int num18 = Encoding.decodeVL64(currentPacket.Substring(2));
                            string str7 = stringManager.filterSwearwords(currentPacket.Substring(Encoding.encodeVL64(num18).Length + 4));
                            if (!this.Messenger.containsOnlineBuddy(num18))
                            {
                                this.sendData("DE" + Encoding.encodeVL64(5) + Encoding.encodeVL64(this.userID));
                                return;
                            }
                            userManager.getUser(num18).sendData(string.Concat(new object[] { "BF", Encoding.encodeVL64(this.userID), str7, Convert.ToChar(2) }));
                        }
                        return;

                    case "@O":
                        if (this.Messenger != null)
                        {
                            this.sendData("@M" + this.Messenger.getUpdates());
                        }
                        return;

                    case "DF":
                        if (this.Messenger != null)
                        {
                            int num19 = Encoding.decodeVL64(currentPacket.Substring(2));
                            int num20 = -1;
                            if (!this.Messenger.hasFriendship(num19))
                            {
                                num20 = 0;
                            }
                            else if (!userManager.containsUser(num19))
                            {
                                num20 = 1;
                            }
                            else
                            {
                                virtualUser user = userManager.getUser(num19);
                                if (user._roomID <= 0)
                                {
                                    num20 = 2;
                                }
                                else if (!user._inPublicroom)
                                {
                                    this.sendData("D^H" + Encoding.encodeVL64(user._roomID));
                                }
                                else
                                {
                                    this.sendData("D^I" + Encoding.encodeVL64(user._roomID));
                                }
                            }
                            if (num20 != -1)
                            {
                                this.sendData("E]" + Encoding.encodeVL64(num20));
                            }
                        }
                        return;

                    case "@b":
                        if ((this.Messenger != null) && (this.roomUser != null))
                        {
                            int num21 = Encoding.decodeVL64(currentPacket.Substring(2));
                            int[] numArray = new int[num21];
                            currentPacket = currentPacket.Substring(Encoding.encodeVL64(num21).Length + 2);
                            for (int m = 0; m < num21; m++)
                            {
                                if (currentPacket == "")
                                {
                                    return;
                                }
                                int num23 = Encoding.decodeVL64(currentPacket);
                                if (this.Messenger.hasFriendship(num23) && userManager.containsUser(num23))
                                {
                                    numArray[m] = num23;
                                }
                                currentPacket = currentPacket.Substring(Encoding.encodeVL64(num23).Length);
                            }
                            string str8 = currentPacket.Substring(2);
                            string data = string.Concat(new object[] { "BG", Encoding.encodeVL64(this.userID), str8, Convert.ToChar(2) });
                            for (int n = 0; n < num21; n++)
                            {
                                userManager.getUser(numArray[n]).sendData(data);
                            }
                        }
                        return;

                    case "@i":
                    {
                        string str10 = DB.Stripslash(currentPacket.Substring(4));
                        if (DB.checkExists("SELECT * FROM users WHERE name = '" + str10 + "'"))
                        {
                            int num25 = DB.runRead("SELECT id FROM users WHERE name = '" + str10 + "'", 0);
                            string str11 = DB.runRead("SELECT name FROM users WHERE id = '" + num25 + "'");
                            string str12 = DB.runRead("SELECT lastvisit FROM users WHERE id = '" + num25 + "'");
                            this.sendData(string.Concat(new object[] { "Fs", Encoding.encodeVL64(num25), "H", str11, Convert.ToChar(2), Convert.ToChar(2), "HH", Convert.ToChar(2), "H", Convert.ToChar(2), str12, Convert.ToChar(2) }));
                        }
                        if (!DB.checkExists("SELECT * FROM users WHERE name = '" + str10 + "'"))
                        {
                            this.sendData("FsHH");
                        }
                        return;
                    }
                    case "BV":
                    {
                        this.sendData("Dj" + Encoding.encodeVL64(this._health) + Encoding.encodeVL64(this._hunger));
                        int num26 = Encoding.decodeVL64(currentPacket.Substring(2, 1));
                        int num27 = Encoding.decodeVL64(currentPacket.Substring(3));
                        string str13 = DB.runReadUnsafe(string.Concat(new object[] { "SELECT name FROM room_categories WHERE id = '", num27, "' AND (access_rank_min <= ", this._Rank, " OR access_rank_hideforlower = '0')" }));
                        if (!(str13 == ""))
                        {
                            int num28 = DB.runRead("SELECT type FROM room_categories WHERE id = '" + num27 + "'", null);
                            int num29 = DB.runRead("SELECT parent FROM room_categories WHERE id = '" + num27 + "'", null);
                            StringBuilder builder2 = new StringBuilder(string.Concat(new object[] { @"C\", Encoding.encodeVL64(num26), Encoding.encodeVL64(num27), Encoding.encodeVL64(num28), str13, Convert.ToChar(2), Encoding.encodeVL64(0), Encoding.encodeVL64(0x2710), Encoding.encodeVL64(num29) }));
                            string str14 = "";
                            if (num28 == 0)
                            {
                                if (num26 == 1)
                                {
                                    str14 = "AND visitors_now < visitors_max ORDER BY id ASC";
                                }
                                else
                                {
                                    str14 = "ORDER BY id ASC";
                                }
                            }
                            else if (num26 == 1)
                            {
                                str14 = "AND visitors_now < visitors_max ORDER BY visitors_now DESC LIMIT 30";
                            }
                            else
                            {
                                str14 = "ORDER BY visitors_now DESC LIMIT " + Config.Navigator_openCategory_maxResults;
                            }
                            int[] numArray2 = DB.runReadColumn(string.Concat(new object[] { "SELECT id FROM rooms WHERE category = '", num27, "' ", str14 }), 0, null);
                            if (num28 == 2)
                            {
                                builder2.Append(Encoding.encodeVL64(numArray2.Length));
                            }
                            if (numArray2.Length > 0)
                            {
                                bool flag = false;
                                int[] numArray3 = DB.runReadColumn(string.Concat(new object[] { "SELECT state FROM rooms WHERE category = '", num27, "' ", str14 }), 0, null);
                                int[] numArray4 = DB.runReadColumn(string.Concat(new object[] { "SELECT showname FROM rooms WHERE category = '", num27, "' ", str14 }), 0, null);
                                int[] numArray5 = DB.runReadColumn(string.Concat(new object[] { "SELECT visitors_now FROM rooms WHERE category = '", num27, "' ", str14 }), 0, null);
                                int[] numArray6 = DB.runReadColumn(string.Concat(new object[] { "SELECT visitors_max FROM rooms WHERE category = '", num27, "' ", str14 }), 0, null);
                                string[] strArray4 = DB.runReadColumn(string.Concat(new object[] { "SELECT name FROM rooms WHERE category = '", num27, "' ", str14 }), 0);
                                string[] strArray5 = DB.runReadColumn(string.Concat(new object[] { "SELECT description FROM rooms WHERE category = '", num27, "' ", str14 }), 0);
                                string[] strArray6 = DB.runReadColumn(string.Concat(new object[] { "SELECT owner FROM rooms WHERE category = '", num27, "' ", str14 }), 0);
                                string[] strArray7 = null;
                                if (num28 == 0)
                                {
                                    strArray7 = DB.runReadColumn(string.Concat(new object[] { "SELECT ccts FROM rooms WHERE category = '", num27, "' ", str14 }), 0);
                                }
                                else
                                {
                                    flag = rankManager.containsRight(this._Rank, "fuse_enter_locked_rooms");
                                }
                                for (int num30 = 0; num30 < numArray2.Length; num30++)
                                {
                                    if (num28 == 0)
                                    {
                                        builder2.Append(string.Concat(new object[] { Encoding.encodeVL64(numArray2[num30]), Encoding.encodeVL64(1), strArray4[num30], Convert.ToChar(2), Encoding.encodeVL64(numArray5[num30]), Encoding.encodeVL64(numArray6[num30]), Encoding.encodeVL64(num27), strArray5[num30], Convert.ToChar(2), Encoding.encodeVL64(numArray2[num30]), Encoding.encodeVL64(0), strArray7[num30], Convert.ToChar(2), "HI" }));
                                    }
                                    else if ((numArray4[num30] != 0) || flag)
                                    {
                                        builder2.Append(string.Concat(new object[] { Encoding.encodeVL64(numArray2[num30]), strArray4[num30], Convert.ToChar(2), strArray6[num30], Convert.ToChar(2), roomManager.getRoomState(numArray3[num30]), Convert.ToChar(2), Encoding.encodeVL64(numArray5[num30]), Encoding.encodeVL64(numArray6[num30]), strArray5[num30], Convert.ToChar(2) }));
                                    }
                                }
                            }
                            int[] numArray7 = DB.runReadColumn(string.Concat(new object[] { "SELECT id FROM room_categories WHERE parent = '", num27, "' AND (access_rank_min <= ", this._Rank, " OR access_rank_hideforlower = '0') ORDER BY id ASC" }), 0, null);
                            if (numArray7.Length > 0)
                            {
                                for (int num31 = 0; num31 < numArray7.Length; num31++)
                                {
                                    int num32 = DB.runReadUnsafe("SELECT SUM(visitors_now) FROM rooms WHERE category = '" + numArray7[num31] + "'", null);
                                    int num33 = DB.runReadUnsafe("SELECT SUM(visitors_max) FROM rooms WHERE category = '" + numArray7[num31] + "'", null);
                                    if (((num33 <= 0) || (num26 != 1)) || (num32 < num33))
                                    {
                                        string str15 = DB.runRead("SELECT name FROM room_categories WHERE id = '" + numArray7[num31] + "'");
                                        builder2.Append(string.Concat(new object[] { Encoding.encodeVL64(numArray7[num31]), Encoding.encodeVL64(0), str15, Convert.ToChar(2), Encoding.encodeVL64(num32), Encoding.encodeVL64(num33), Encoding.encodeVL64(num27) }));
                                    }
                                }
                            }
                            this.sendData(builder2.ToString());
                            return;
                        }
                        return;
                    }
                    case "BW":
                    {
                        StringBuilder builder3 = new StringBuilder();
                        int[] numArray8 = DB.runReadColumn("SELECT id FROM room_categories WHERE type = '2' AND parent > 0 AND access_rank_min <= " + this._Rank + " ORDER BY id ASC", 0, null);
                        string[] strArray8 = DB.runReadColumn("SELECT name FROM room_categories WHERE type = '2' AND parent > 0 AND access_rank_min <= " + this._Rank + " ORDER BY id ASC", 0);
                        for (int num34 = 0; num34 < numArray8.Length; num34++)
                        {
                            builder3.Append(Encoding.encodeVL64(numArray8[num34]) + strArray8[num34] + Convert.ToChar(2));
                        }
                        this.sendData("C]" + Encoding.encodeVL64(numArray8.Length) + builder3.ToString());
                        return;
                    }
                    case "DH":
                    {
                        this.sendData("Dj" + Encoding.encodeVL64(this._health) + Encoding.encodeVL64(this._hunger));
                        string str16 = "";
                        for (int num35 = 0; num35 <= 3; num35++)
                        {
                            string[] strArray9 = DB.runReadRow("SELECT id,name,owner,description,state,visitors_now,visitors_max FROM rooms WHERE NOT(owner IS NULL) ORDER BY RAND()");
                            if (strArray9.Length == 0)
                            {
                                return;
                            }
                            obj2 = str16;
                            str16 = string.Concat(new object[] { obj2, Encoding.encodeVL64(int.Parse(strArray9[0])), strArray9[1], Convert.ToChar(2), strArray9[2], Convert.ToChar(2), roomManager.getRoomState(int.Parse(strArray9[4])), Convert.ToChar(2), Encoding.encodeVL64(int.Parse(strArray9[5])), Encoding.encodeVL64(int.Parse(strArray9[6])), strArray9[3], Convert.ToChar(2) });
                        }
                        this.sendData("E_" + Encoding.encodeVL64(3) + str16);
                        return;
                    }
                    case "@P":
                    {
                        string[] strArray10 = DB.runReadColumn("SELECT id FROM rooms WHERE owner = '" + this._Username + "' ORDER BY id ASC", 0);
                        if (strArray10.Length <= 0)
                        {
                            this.sendData("@y" + this._Username);
                            return;
                        }
                        StringBuilder builder4 = new StringBuilder();
                        for (int num36 = 0; num36 < strArray10.Length; num36++)
                        {
                            string[] strArray11 = DB.runReadRow("SELECT name,description,state,showname,visitors_now,visitors_max FROM rooms WHERE id = '" + strArray10[num36] + "'");
                            builder4.Append(string.Concat(new object[] { 
                                strArray10[num36], Convert.ToChar(9), strArray11[0], Convert.ToChar(9), this._Username, Convert.ToChar(9), roomManager.getRoomState(int.Parse(strArray11[2])), Convert.ToChar(9), "x", Convert.ToChar(9), strArray11[4], Convert.ToChar(9), strArray11[5], Convert.ToChar(9), "null", Convert.ToChar(9), 
                                strArray11[1], Convert.ToChar(9), strArray11[1], Convert.ToChar(9), Convert.ToChar(13)
                             }));
                        }
                        this.sendData("@P" + builder4.ToString());
                        return;
                    }
                    case "@Q":
                    {
                        bool flag2 = rankManager.containsRight(this._Rank, "fuse_see_all_roomowners");
                        string str17 = DB.Stripslash(currentPacket.Substring(2));
                        string[] strArray12 = DB.runReadColumn("SELECT id FROM rooms WHERE NOT(owner IS NULL) AND (owner = '" + str17 + "' OR name LIKE '%" + str17 + "%') ORDER BY id ASC", Config.Navigator_roomSearch_maxResults);
                        if (strArray12.Length <= 0)
                        {
                            this.sendData("@z");
                            return;
                        }
                        StringBuilder builder5 = new StringBuilder();
                        for (int num37 = 0; num37 < strArray12.Length; num37++)
                        {
                            string[] strArray13 = DB.runReadRow("SELECT name,owner,description,state,showname,visitors_now,visitors_max FROM rooms WHERE id = '" + strArray12[num37] + "'");
                            if (((strArray13[4] == "0") && (strArray13[1] != this._Username)) && !flag2)
                            {
                                strArray13[1] = "-";
                            }
                            builder5.Append(string.Concat(new object[] { 
                                strArray12[num37], Convert.ToChar(9), strArray13[0], Convert.ToChar(9), strArray13[1], Convert.ToChar(9), roomManager.getRoomState(int.Parse(strArray13[3])), Convert.ToChar(9), "x", Convert.ToChar(9), strArray13[5], Convert.ToChar(9), strArray13[6], Convert.ToChar(9), "null", Convert.ToChar(9), 
                                strArray13[2], Convert.ToChar(9), Convert.ToChar(13)
                             }));
                        }
                        this.sendData("@w" + builder5.ToString());
                        return;
                    }
                    case "@U":
                    {
                        int num38 = int.Parse(currentPacket.Substring(2));
                        string[] strArray14 = DB.runReadRow("SELECT name,owner,description,model,state,superusers,showname,category,visitors_now,visitors_max FROM rooms WHERE id = '" + num38 + "' AND NOT(owner IS NULL)");
                        if (strArray14.Length > 0)
                        {
                            StringBuilder builder6 = new StringBuilder(Encoding.encodeVL64(int.Parse(strArray14[5])) + Encoding.encodeVL64(int.Parse(strArray14[4])) + Encoding.encodeVL64(num38));
                            if (!(strArray14[6] == "0") || !rankManager.containsRight(this._Rank, "fuse_see_all_roomowners"))
                            {
                                builder6.Append(strArray14[1]);
                            }
                            else
                            {
                                builder6.Append("-");
                            }
                            builder6.Append(string.Concat(new object[] { Convert.ToChar(2), "model_", strArray14[3], Convert.ToChar(2), strArray14[0], Convert.ToChar(2), strArray14[2], Convert.ToChar(2), Encoding.encodeVL64(int.Parse(strArray14[6])) }));
                            if (DB.checkExists("SELECT id FROM room_categories WHERE id = '" + strArray14[7] + "' AND trading = '1'"))
                            {
                                builder6.Append("I");
                            }
                            else
                            {
                                builder6.Append("H");
                            }
                            builder6.Append(Encoding.encodeVL64(int.Parse(strArray14[8])) + Encoding.encodeVL64(int.Parse(strArray14[9])));
                            this.sendData("@v" + builder6.ToString());
                        }
                        return;
                    }
                    case "@R":
                    {
                        int[] numArray9 = DB.runReadColumn("SELECT roomid FROM users_favourites WHERE userid = '" + this.userID + "' ORDER BY roomid DESC", Config.Navigator_Favourites_maxRooms, null);
                        if (numArray9.Length > 0)
                        {
                            int num39 = 0;
                            int num40 = 0;
                            bool flag3 = rankManager.containsRight(this._Rank, "fuse_enter_locked_rooms");
                            StringBuilder builder7 = new StringBuilder();
                            for (int num41 = 0; num41 < numArray9.Length; num41++)
                            {
                                string[] strArray15 = DB.runReadRow("SELECT name,owner,state,showname,visitors_now,visitors_max,description FROM rooms WHERE id = '" + numArray9[num41] + "'");
                                if (strArray15.Length == 0)
                                {
                                    if (num40 > 0)
                                    {
                                        num39++;
                                    }
                                    DB.runQuery(string.Concat(new object[] { "DELETE FROM users_favourites WHERE userid = '", this.userID, "' AND roomid = '", numArray9[num41], "' LIMIT 1" }));
                                }
                                else if (strArray15[1] == "")
                                {
                                    int num42 = DB.runRead("SELECT category FROM rooms WHERE id = '" + numArray9[num41] + "'", null);
                                    string str18 = DB.runRead("SELECT ccts FROM rooms WHERE id = '" + numArray9[num41] + "'");
                                    builder7.Append(string.Concat(new object[] { Encoding.encodeVL64(numArray9[num41]), "I", strArray15[0], Convert.ToChar(2), Encoding.encodeVL64(int.Parse(strArray15[4])), Encoding.encodeVL64(int.Parse(strArray15[5])), Encoding.encodeVL64(num42), strArray15[6], Convert.ToChar(2), Encoding.encodeVL64(numArray9[num41]), "H", str18, Convert.ToChar(2), "HI" }));
                                }
                                else
                                {
                                    if (((strArray15[3] == "0") && (this._Username != strArray15[1])) && !flag3)
                                    {
                                        strArray15[1] = "-";
                                    }
                                    builder7.Append(string.Concat(new object[] { Encoding.encodeVL64(numArray9[num41]), strArray15[0], Convert.ToChar(2), strArray15[1], Convert.ToChar(2), roomManager.getRoomState(int.Parse(strArray15[2])), Convert.ToChar(2), Encoding.encodeVL64(int.Parse(strArray15[4])), Encoding.encodeVL64(int.Parse(strArray15[5])), strArray15[6], Convert.ToChar(2) }));
                                    num40++;
                                }
                            }
                            this.sendData(string.Concat(new object[] { "@}HHJ", Convert.ToChar(2), "HHH", Encoding.encodeVL64(num40 - num39), builder7.ToString() }));
                        }
                        return;
                    }
                    case "@S":
                    {
                        int num43 = Encoding.decodeVL64(currentPacket.Substring(3));
                        if (DB.checkExists("SELECT id FROM rooms WHERE id = '" + num43 + "'") && !DB.checkExists(string.Concat(new object[] { "SELECT userid FROM users_favourites WHERE userid = '", this.userID, "' AND roomid = '", num43, "'" })))
                        {
                            if (DB.runReadUnsafe("SELECT COUNT(userid) FROM users_favourites WHERE userid = '" + this.userID + "'", null) >= Config.Navigator_Favourites_maxRooms)
                            {
                                this.sendData("@anav_error_toomanyfavrooms");
                                return;
                            }
                            DB.runQuery(string.Concat(new object[] { "INSERT INTO users_favourites(userid,roomid) VALUES ('", this.userID, "','", num43, "')" }));
                        }
                        return;
                    }
                    case "@T":
                    {
                        int num44 = Encoding.decodeVL64(currentPacket.Substring(3));
                        DB.runQuery(string.Concat(new object[] { "DELETE FROM users_favourites WHERE userid = '", this.userID, "' AND roomid = '", num44, "' LIMIT 1" }));
                        return;
                    }
                    case "EA":
                        this.sendData("Ep" + Encoding.encodeVL64(eventManager.categoryAmount));
                        return;

                    case "EY":
                        if ((!this._inPublicroom && (this.roomUser != null)) && !this._hostsEvent)
                        {
                            this.sendData("EoI");
                            return;
                        }
                        this.sendData("EoH");
                        return;

                    case "D{":
                    {
                        int categoryID = Encoding.decodeVL64(currentPacket.Substring(2));
                        if (eventManager.categoryOK(categoryID))
                        {
                            this.sendData("Eb" + Encoding.encodeVL64(categoryID));
                        }
                        return;
                    }
                    case "E^":
                    {
                        int num46 = Encoding.decodeVL64(currentPacket.Substring(2));
                        if ((num46 >= 1) && (num46 <= 11))
                        {
                            this.sendData("Eq" + Encoding.encodeVL64(num46) + eventManager.getEvents(num46));
                        }
                        return;
                    }
                    case "EZ":
                        if ((this._isOwner && !this._hostsEvent) && (!this._inPublicroom && (this.roomUser != null)))
                        {
                            int num47 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (!eventManager.categoryOK(num47))
                            {
                                return;
                            }
                            int length = Encoding.encodeVL64(num47).Length;
                            int num49 = Encoding.decodeB64(currentPacket.Substring(length + 2, 2));
                            string name = currentPacket.Substring(length + 4, num49);
                            string description = currentPacket.Substring((length + num49) + 6);
                            this._hostsEvent = true;
                            eventManager.createEvent(num47, this.userID, this._roomID, name, description);
                            this.Room.sendData("Er" + eventManager.getEvent(this._roomID));
                        }
                        return;

                    case @"E\":
                        if ((this._hostsEvent && this._isOwner) && (!this._inPublicroom && (this.roomUser != null)))
                        {
                            int num50 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (!eventManager.categoryOK(num50))
                            {
                                return;
                            }
                            int num51 = Encoding.encodeVL64(num50).Length;
                            int num52 = Encoding.decodeB64(currentPacket.Substring(num51 + 2, 2));
                            string str21 = currentPacket.Substring(num51 + 4, num52);
                            string str22 = currentPacket.Substring((num51 + num52) + 6);
                            eventManager.editEvent(num50, this._roomID, str21, str22);
                            this.Room.sendData("Er" + eventManager.getEvent(this._roomID));
                        }
                        return;

                    case "E[":
                        if ((this._hostsEvent && this._isOwner) && (!this._inPublicroom && (this.roomUser != null)))
                        {
                            this._hostsEvent = false;
                            eventManager.removeEvent(this._roomID);
                            this.Room.sendData("Er-1");
                        }
                        return;

                    case "@]":
                    {
                        string[] strArray16 = currentPacket.Split(new char[] { '/' });
                        if (DB.runRead("SELECT COUNT(id) FROM rooms WHERE owner = '" + this._Username + "'", null) >= Config.Navigator_createRoom_maxRooms)
                        {
                            this.sendData("@aError creating a private room");
                            return;
                        }
                        strArray16[2] = stringManager.filterSwearwords(strArray16[2]);
                        strArray16[3] = strArray16[3].Substring(6, 1);
                        strArray16[4] = roomManager.getRoomState(strArray16[4]).ToString();
                        if (!(strArray16[5] != "0") || !(strArray16[5] != "1"))
                        {
                            DB.runQuery("INSERT INTO rooms (name,owner,model,state,showname) VALUES ('" + DB.Stripslash(strArray16[2]) + "','" + this._Username + "','" + strArray16[3] + "','" + strArray16[4] + "','" + strArray16[5] + "')");
                            string str23 = DB.runRead("SELECT MAX(id) FROM rooms WHERE owner = '" + this._Username + "'");
                            this.sendData(string.Concat(new object[] { "@{", str23, Convert.ToChar(13), strArray16[2] }));
                            return;
                        }
                        return;
                    }
                    case "@Y":
                    {
                        int num53 = 0;
                        if (!(currentPacket.Substring(2, 1) == "/"))
                        {
                            num53 = int.Parse(currentPacket.Substring(2).Split(new char[] { '/' })[0]);
                        }
                        else
                        {
                            num53 = int.Parse(currentPacket.Split(new char[] { '/' })[1]);
                        }
                        int num54 = 0;
                        int num55 = 0x19;
                        string[] strArray17 = currentPacket.Split(new char[] { Convert.ToChar(13) });
                        string str24 = "";
                        string str25 = "";
                        for (int num56 = 1; num56 < strArray17.Length; num56++)
                        {
                            string str26 = strArray17[num56].Split(new char[] { '=' })[0];
                            string text = strArray17[num56].Substring(str26.Length + 1);
                            str113 = str26;
                            if (str113 == null)
                            {
                                return;
                            }
                            if (!(str113 == "description"))
                            {
                                if (!(str113 == "allsuperuser"))
                                {
                                    if (!(str113 == "maxvisitors"))
                                    {
                                        if (!(str113 == "password"))
                                        {
                                            return;
                                        }
                                        goto Label_42D2;
                                    }
                                    goto Label_42B7;
                                }
                            }
                            else
                            {
                                str24 = DB.Stripslash(stringManager.filterSwearwords(text));
                                continue;
                            }
                            num54 = int.Parse(text);
                            if ((num54 != 0) && (num54 != 1))
                            {
                                num54 = 0;
                            }
                            continue;
                        Label_42B7:
                            num55 = int.Parse(text);
                            if ((num55 < 10) || (num55 > 0x19))
                            {
                                num55 = 0x19;
                            }
                            continue;
                        Label_42D2:
                            str25 = DB.Stripslash(text);
                        }
                        DB.runQuery(string.Concat(new object[] { "UPDATE rooms SET description = '", str24, "',superusers = '", num54, "',visitors_max = '", num55, "',password = '", str25, "' WHERE id = '", num53, "' AND owner = '", this._Username, "' LIMIT 1" }));
                        return;
                    }
                    case "@X":
                    {
                        string[] strArray18 = currentPacket.Substring(2).Split(new char[] { '/' });
                        int num57 = int.Parse(strArray18[0]);
                        string str28 = DB.Stripslash(stringManager.filterSwearwords(strArray18[1]));
                        string str29 = strArray18[2];
                        if ((str29 != "1") && (str29 != "0"))
                        {
                            str29 = "1";
                        }
                        int num58 = roomManager.getRoomState(strArray18[2]);
                        DB.runQuery(string.Concat(new object[] { "UPDATE rooms SET name = '", str28, "',state = '", num58, "',showname = '", str29, "' WHERE id = '", num57, "' AND owner = '", this._Username, "' LIMIT 1" }));
                        return;
                    }
                    case "BX":
                    {
                        int num59 = Encoding.decodeVL64(currentPacket.Substring(2));
                        string s = DB.runRead(string.Concat(new object[] { "SELECT category FROM rooms WHERE id = '", num59, "' AND owner = '", this._Username, "'" }));
                        if (s != "")
                        {
                            this.sendData("C^" + Encoding.encodeVL64(num59) + Encoding.encodeVL64(int.Parse(s)));
                        }
                        return;
                    }
                    case "BY":
                    {
                        int num60 = Encoding.decodeVL64(currentPacket.Substring(2));
                        int num61 = Encoding.decodeVL64(currentPacket.Substring(Encoding.encodeVL64(num60).Length + 2));
                        if (DB.checkExists(string.Concat(new object[] { "SELECT id FROM room_categories WHERE id = '", num61, "' AND type = '2' AND parent > 0 AND access_rank_min <= ", this._Rank })))
                        {
                            DB.runQuery(string.Concat(new object[] { "UPDATE rooms SET category = '", num61, "' WHERE id = '", num60, "' AND owner = '", this._Username, "' LIMIT 1" }));
                        }
                        return;
                    }
                    case "@W":
                    {
                        int roomID = int.Parse(currentPacket.Substring(2));
                        if (DB.checkExists(string.Concat(new object[] { "SELECT id FROM rooms WHERE id = '", roomID, "' AND owner = '", this._Username, "'" })))
                        {
                            DB.runQuery("DELETE FROM room_rights WHERE roomid = '" + roomID + "'");
                            DB.runQuery("DELETE FROM rooms WHERE id = '" + roomID + "' LIMIT 1");
                            DB.runQuery("DELETE FROM room_votes WHERE roomid = '" + roomID + "'");
                            DB.runQuery("DELETE FROM room_bans WHERE roomid = '" + roomID + "' LIMIT 1");
                            DB.runQuery("DELETE FROM furniture WHERE roomid = '" + roomID + "'");
                            DB.runQuery("DELETE FROM furniture_moodlight WHERE roomid = '" + roomID + "'");
                        }
                        if (roomManager.containsRoom(roomID))
                        {
                            roomManager.getRoom(roomID).kickUsers(byte.Parse("9"), "This room has been deleted");
                        }
                        return;
                    }
                    case "BZ":
                    {
                        int num63 = Encoding.decodeVL64(currentPacket.Substring(2));
                        if (!roomManager.containsRoom(num63))
                        {
                            this.sendData("C_");
                            return;
                        }
                        this.sendData("C_" + roomManager.getRoom(num63).Userlist);
                        return;
                    }
                    case "@u":
                        if ((this.Room == null) || (this.roomUser == null))
                        {
                            if (this.gamePlayer != null)
                            {
                                this.leaveGame();
                            }
                            return;
                        }
                        this.Room.removeUser(this.roomUser.roomUID, false, "");
                        return;

                    case "Bv":
                        Config.Rooms_LoadAvertisement_img = "";
                        if (!(Config.Rooms_LoadAvertisement_img == ""))
                        {
                            this.sendData(string.Concat(new object[] { "DB", Config.Rooms_LoadAvertisement_img, Convert.ToChar(9), Config.Rooms_LoadAvertisement_uri }));
                            return;
                        }
                        this.sendData("DB0");
                        return;

                    case "@B":
                    {
                        int num64 = Encoding.decodeVL64(currentPacket.Substring(3));
                        bool flag4 = currentPacket.Substring(2, 1) == "A";
                        this.sendData("@S");
                        this.sendData("Bfhttp://www.otaku-studios.com/");
                        if ((this.gamePlayer == null) || (this.gamePlayer.Game == null))
                        {
                            if ((this.Room != null) && (this.roomUser != null))
                            {
                                this.Room.removeUser(this.roomUser.roomUID, false, "");
                            }
                            if (this._teleporterID == 0)
                            {
                                bool flag5 = rankManager.containsRight(this._Rank, "fuse_enter_locked_rooms");
                                int num65 = DB.runRead("SELECT state FROM rooms WHERE id = '" + num64 + "'", null);
                                if (((num65 == 3) && !this._clubMember) && !flag5)
                                {
                                    this.sendData("C`Kc");
                                    return;
                                }
                                if ((num65 == 4) && !flag5)
                                {
                                    this.sendData("BK" + stringManager.getString("room_stafflocked"));
                                    return;
                                }
                                int num66 = DB.runRead("SELECT SUM(visitors_now) FROM rooms WHERE id = '" + num64 + "'", null);
                                if (num66 > 0)
                                {
                                    int num67 = DB.runRead("SELECT SUM(visitors_max) FROM rooms WHERE id = '" + num64 + "'", null);
                                    if ((num66 >= num67) && !rankManager.containsRight(this._Rank, "fuse_enter_full_rooms"))
                                    {
                                        if (!flag4)
                                        {
                                            this.sendData("C`I");
                                            return;
                                        }
                                        this.sendData("BK" + stringManager.getString("room_full"));
                                        return;
                                    }
                                }
                            }
                            this._roomID = num64;
                            this._inPublicroom = flag4;
                            this._ROOMACCESS_PRIMARY_OK = true;
                            if (flag4)
                            {
                                string str31 = DB.runRead("SELECT model FROM rooms WHERE id = '" + num64 + "'");
                                this.sendData(string.Concat(new object[] { "AE", str31, " ", num64 }));
                                this._ROOMACCESS_SECONDARY_OK = true;
                            }
                            return;
                        }
                        if (!this.gamePlayer.enteringGame)
                        {
                            this.leaveGame();
                            return;
                        }
                        this.Room.removeUser(this.roomUser.roomUID, false, "");
                        this.sendData(string.Concat(new object[] { "AE", this.gamePlayer.Game.Lobby.Type, "_arena_", this.gamePlayer.Game.mapID, " ", num64 }));
                        this.sendData("Cs" + this.gamePlayer.Game.getMap());
                        this.gamePlayer.Game.getMap();
                        return;
                    }
                    case "@v":
                        this.sendData("@S");
                        return;

                    case "@y":
                        if (!this._inPublicroom)
                        {
                            this._isRoomStaff = false;
                            if (DB.checkExists("SELECT * FROM jobs_employers WHERE room = '" + this._roomID + "'"))
                            {
                                string str32 = DB.runRead("SELECT name FROM jobs_employers WHERE room = '" + this._roomID + "'");
                                string str33 = DB.runRead("SELECT job FROM users WHERE name = '" + this._Username + "'");
                                if (DB.checkExists("SELECT * FROM jobs WHERE id = '" + str33 + "' AND employer = '" + str32 + "'"))
                                {
                                    this._isRoomStaff = true;
                                }
                            }
                            this._isOwner = DB.checkExists(string.Concat(new object[] { "SELECT id FROM rooms WHERE id = '", this._roomID, "' AND owner = '", this._Username, "'" }));
                            if (!this._isOwner)
                            {
                                this._hasRights = DB.checkExists(string.Concat(new object[] { "SELECT userid FROM room_rights WHERE roomid = '", this._roomID, "' AND userid = '", this.userID, "'" }));
                            }
                            if (!this._hasRights)
                            {
                                this._hasRights = DB.checkExists("SELECT id FROM rooms WHERE id = '" + this._roomID + "' AND superusers = '1'");
                            }
                            if (((this._teleporterID == 0) && !this._isOwner) && !rankManager.containsRight(this._Rank, "fuse_enter_locked_rooms"))
                            {
                                int num68 = DB.runRead("SELECT state FROM rooms WHERE id = '" + this._roomID + "'", null);
                                if (!this._ROOMACCESS_PRIMARY_OK && (num68 != 2))
                                {
                                    return;
                                }
                                if (DB.checkExists(string.Concat(new object[] { "SELECT roomid FROM room_bans WHERE roomid = '", this._roomID, "' AND userid = '", this.userID, "'" })))
                                {
                                    if (DateTime.Compare(DateTime.Parse(DB.runRead(string.Concat(new object[] { "SELECT ban_expire FROM room_bans WHERE roomid = '", this._roomID, "' AND userid = '", this.userID, "'" }))), DateTime.Now) > 0)
                                    {
                                        this.sendData("C`PA");
                                        this.sendData("@R");
                                        return;
                                    }
                                    DB.runQuery(string.Concat(new object[] { "DELETE FROM room_bans WHERE roomid = '", this._roomID, "' AND userid = '", this.userID, "' LIMIT 1" }));
                                }
                                switch (num68)
                                {
                                    case 1:
                                        if (!roomManager.containsRoom(this._roomID))
                                        {
                                            this.sendData("BC");
                                            return;
                                        }
                                        roomManager.getRoom(this._roomID).sendDataToRights("A[" + this._Username);
                                        this.sendData("A[");
                                        return;

                                    case 2:
                                    {
                                        string str34 = "";
                                        try
                                        {
                                            str34 = currentPacket.Split(new char[] { '/' })[1];
                                        }
                                        catch
                                        {
                                        }
                                        string str35 = DB.runRead("SELECT password FROM rooms WHERE id = '" + this._roomID + "'");
                                        if (str34 != str35)
                                        {
                                            this.sendData("@aIncorrect flat password");
                                            return;
                                        }
                                        break;
                                    }
                                }
                            }
                            this._ROOMACCESS_SECONDARY_OK = true;
                            this.sendData("@i");
                        }
                        return;

                    case "Ab":
                        if (this._hasRights || !rankManager.containsRight(this.roomUser.User._Rank, "fuse_enter_locked_rooms"))
                        {
                            string userName = currentPacket.Substring(4, Encoding.decodeB64(currentPacket.Substring(2, 2)));
                            bool flag6 = currentPacket.Substring(currentPacket.Length - 1) == "A";
                            virtualUser user2 = userManager.getUser(userName);
                            if (user2 != null)
                            {
                                if (user2._roomID != this._roomID)
                                {
                                    return;
                                }
                                if (flag6)
                                {
                                    user2._ROOMACCESS_SECONDARY_OK = true;
                                    this.Room.sendDataToRights("@i" + userName + Convert.ToChar(2));
                                    user2.sendData("@i");
                                    return;
                                }
                                user2.sendData("BC");
                                user2._roomID = 0;
                                user2._inPublicroom = false;
                                user2._ROOMACCESS_PRIMARY_OK = false;
                                user2._ROOMACCESS_SECONDARY_OK = false;
                                user2._isOwner = false;
                                user2._hasRights = false;
                                user2.Room = null;
                                user2.roomUser = null;
                            }
                            return;
                        }
                        return;

                    case "@{":
                        if (this._ROOMACCESS_SECONDARY_OK && !this._inPublicroom)
                        {
                            string str37 = "model_" + DB.runRead("SELECT model FROM rooms WHERE id = '" + this._roomID + "'");
                            this.sendData(string.Concat(new object[] { "AE", str37, " ", this._roomID }));
                            int num69 = DB.runRead("SELECT wallpaper FROM rooms WHERE id = '" + this._roomID + "'", null);
                            int num70 = DB.runRead("SELECT floor FROM rooms WHERE id = '" + this._roomID + "'", null);
                            string str38 = DB.runRead("SELECT landscape FROM rooms WHERE id = '" + this._roomID + "'");
                            if (num69 > 0)
                            {
                                this.sendData("@nwallpaper/" + num69);
                            }
                            if (num70 > 0)
                            {
                                this.sendData("@nfloor/" + num70);
                            }
                            this.sendData("@nlandscape/" + str38);
                            if (!this._isOwner)
                            {
                                this._isOwner = rankManager.containsRight(this._Rank, "fuse_any_room_controller");
                            }
                            if (this._isOwner)
                            {
                                this._hasRights = true;
                                this.sendData("@o");
                            }
                            if (this._hasRights)
                            {
                                this.sendData("@j");
                            }
                            int num71 = -1;
                            if (DB.checkExists(string.Concat(new object[] { "SELECT userid FROM room_votes WHERE userid = '", this.userID, "' AND roomid = '", this._roomID, "'" })))
                            {
                                num71 = DB.runRead("SELECT SUM(vote) FROM room_votes WHERE roomid = '" + this._roomID + "'", null);
                                if (num71 < 0)
                                {
                                    num71 = 0;
                                }
                            }
                            this.sendData("EY" + Encoding.encodeVL64(num71));
                            this.sendData("Er" + eventManager.getEvent(this._roomID));
                        }
                        return;

                    case "A~":
                    {
                        if (!this._inPublicroom || !DB.checkExists("SELECT roomid FROM room_ads WHERE roomid = '" + this._roomID + "'"))
                        {
                            this.sendData("CP0");
                            return;
                        }
                        string str39 = DB.runRead("SELECT img FROM room_ads WHERE roomid = '" + this._roomID + "'");
                        string str40 = DB.runRead("SELECT uri FROM room_ads WHERE roomid = '" + this._roomID + "'");
                        this.sendData(string.Concat(new object[] { "CP", str39, Convert.ToChar(9), str40 }));
                        return;
                    }
                    case "@|":
                        if (!this._ROOMACCESS_SECONDARY_OK)
                        {
                            if (((this.gamePlayer != null) && this.gamePlayer.enteringGame) && ((this.gamePlayer.teamID != -1) && (this.gamePlayer.Game != null)))
                            {
                                this.sendData("@_" + this.gamePlayer.Game.Heightmap);
                                this.sendData("Cs" + this.gamePlayer.Game.getPlayers());
                                this.gamePlayer.Game.getPlayers();
                            }
                            this.gamePlayer.enteringGame = false;
                            return;
                        }
                        if (!roomManager.containsRoom(this._roomID))
                        {
                            this.Room = new virtualRoom(this._roomID, this._inPublicroom);
                            roomManager.addRoom(this._roomID, this.Room);
                        }
                        else
                        {
                            this.Room = roomManager.getRoom(this._roomID);
                        }
                        this.sendData("@_" + this.Room.Heightmap);
                        this.sendData(@"@\" + this.Room.dynamicUnits);
                        return;

                    case "@}":
                        if (this._ROOMACCESS_SECONDARY_OK && (this.Room != null))
                        {
                            this.sendData("@^" + this.Room.PublicroomItems);
                            this.sendData("@`" + this.Room.Flooritems);
                        }
                        return;

                    case "@~":
                        if (this._ROOMACCESS_SECONDARY_OK && (this.Room != null))
                        {
                            this.sendData("Du" + this.Room.Groups);
                            if (this.Room.Lobby != null)
                            {
                                this.sendData(string.Concat(new object[] { "CgH", this.Room.Lobby.Rank.Title, Convert.ToChar(2), Encoding.encodeVL64(this.Room.Lobby.Rank.minPoints), Encoding.encodeVL64(this.Room.Lobby.Rank.maxPoints) }));
                                this.sendData("Cz" + this.Room.Lobby.playerRanks);
                            }
                            this.sendData("DiH");
                            if (!this._receivedSpriteIndex)
                            {
                                this.sendData("Dg[SEshelves_norja\x0002X~Dshelves_polyfon\x0002YmAshelves_silo\x0002XQHtable_polyfon_small\x0002YmAchair_polyfon\x0002ZbBtable_norja_med\x0002Y_Itable_silo_med\x0002X~Dtable_plasto_4leg\x0002Y_Itable_plasto_round\x0002Y_Itable_plasto_bigsquare\x0002Y_Istand_polyfon_z\x0002ZbBchair_silo\x0002X~Dsofa_silo\x0002X~Dcouch_norja\x0002X~Dchair_norja\x0002X~Dtable_polyfon_med\x0002YmAdoormat_love\x0002ZbBdoormat_plain\x0002Z[Msofachair_polyfon\x0002X~Dsofa_polyfon\x0002Z[Msofachair_silo\x0002X~Dchair_plasty\x0002X~Dchair_plasto\x0002YmAtable_plasto_square\x0002Y_Ibed_polyfon\x0002X~Dbed_polyfon_one\x0002[dObed_trad_one\x0002YmAbed_trad\x0002YmAbed_silo_one\x0002YmAbed_silo_two\x0002YmAtable_silo_small\x0002X~Dbed_armas_two\x0002YmAbed_budget_one\x0002XQHbed_budget\x0002XQHshelves_armas\x0002YmAbench_armas\x0002YmAtable_armas\x0002YmAsmall_table_armas\x0002ZbBsmall_chair_armas\x0002YmAfireplace_armas\x0002YmAlamp_armas\x0002YmAbed_armas_one\x0002YmAcarpet_standard\x0002Y_Icarpet_armas\x0002YmAcarpet_polar\x0002Y_Ifireplace_polyfon\x0002Y_Itable_plasto_4leg*1\x0002Y_Itable_plasto_bigsquare*1\x0002Y_Itable_plasto_round*1\x0002Y_Itable_plasto_square*1\x0002Y_Ichair_plasto*1\x0002YmAcarpet_standard*1\x0002Y_Idoormat_plain*1\x0002Z[Mtable_plasto_4leg*2\x0002Y_Itable_plasto_bigsquare*2\x0002Y_Itable_plasto_round*2\x0002Y_Itable_plasto_square*2\x0002Y_Ichair_plasto*2\x0002YmAdoormat_plain*2\x0002Z[Mcarpet_standard*2\x0002Y_Itable_plasto_4leg*3\x0002Y_Itable_plasto_bigsquare*3\x0002Y_Itable_plasto_round*3\x0002Y_Itable_plasto_square*3\x0002Y_Ichair_plasto*3\x0002YmAcarpet_standard*3\x0002Y_Idoormat_plain*3\x0002Z[Mtable_plasto_4leg*4\x0002Y_Itable_plasto_bigsquare*4\x0002Y_Itable_plasto_round*4\x0002Y_Itable_plasto_square*4\x0002Y_Ichair_plasto*4\x0002YmAcarpet_standard*4\x0002Y_Idoormat_plain*4\x0002Z[Mdoormat_plain*6\x0002Z[Mdoormat_plain*5\x0002Z[Mcarpet_standard*5\x0002Y_Itable_plasto_4leg*5\x0002Y_Itable_plasto_bigsquare*5\x0002Y_Itable_plasto_round*5\x0002Y_Itable_plasto_square*5\x0002Y_Ichair_plasto*5\x0002YmAtable_plasto_4leg*6\x0002Y_Itable_plasto_bigsquare*6\x0002Y_Itable_plasto_round*6\x0002Y_Itable_plasto_square*6\x0002Y_Ichair_plasto*6\x0002YmAtable_plasto_4leg*7\x0002Y_Itable_plasto_bigsquare*7\x0002Y_Itable_plasto_round*7\x0002Y_Itable_plasto_square*7\x0002Y_Ichair_plasto*7\x0002YmAtable_plasto_4leg*8\x0002Y_Itable_plasto_bigsquare*8\x0002Y_Itable_plasto_round*8\x0002Y_Itable_plasto_square*8\x0002Y_Ichair_plasto*8\x0002YmAtable_plasto_4leg*9\x0002Y_Itable_plasto_bigsquare*9\x0002Y_Itable_plasto_round*9\x0002Y_Itable_plasto_square*9\x0002Y_Ichair_plasto*9\x0002YmAcarpet_standard*6\x0002Y_Ichair_plasty*1\x0002X~Dpizza\x0002YmAdrinks\x0002YmAchair_plasty*2\x0002X~Dchair_plasty*3\x0002X~Dchair_plasty*4\x0002X~Dbar_polyfon\x0002Y_Iplant_cruddy\x0002YmAbottle\x0002YmAbardesk_polyfon\x0002X~Dbardeskcorner_polyfon\x0002X~Dfloortile\x0002Hbar_armas\x0002Y_Ibartable_armas\x0002YmAbar_chair_armas\x0002YmAcarpet_soft\x0002Z@Kcarpet_soft*1\x0002Z@Kcarpet_soft*2\x0002Z@Kcarpet_soft*3\x0002Z@Kcarpet_soft*4\x0002Z@Kcarpet_soft*5\x0002Z@Kcarpet_soft*6\x0002Z@Kred_tv\x0002Y_Iwood_tv\x0002YmAcarpet_polar*1\x0002Y_Ichair_plasty*5\x0002X~Dcarpet_polar*2\x0002Y_Icarpet_polar*3\x0002Y_Icarpet_polar*4\x0002Y_Ichair_plasty*6\x0002X~Dtable_polyfon\x0002YmAsmooth_table_polyfon\x0002YmAsofachair_polyfon_girl\x0002X~Dbed_polyfon_girl_one\x0002[dObed_polyfon_girl\x0002X~Dsofa_polyfon_girl\x0002Z[Mbed_budgetb_one\x0002XQHbed_budgetb\x0002XQHplant_pineapple\x0002YmAplant_fruittree\x0002Y_Iplant_small_cactus\x0002Y_Iplant_bonsai\x0002Y_Iplant_big_cactus\x0002Y_Iplant_yukka\x0002Y_Icarpet_standard*7\x0002Y_Icarpet_standard*8\x0002Y_Icarpet_standard*9\x0002Y_Icarpet_standard*a\x0002Y_Icarpet_standard*b\x0002Y_Iplant_sunflower\x0002Y_Iplant_rose\x0002Y_Itv_luxus\x0002Y_Ibath\x0002Z\\Bsink\x0002Y_Itoilet\x0002YmAduck\x0002YmAtile\x0002YmAtoilet_red\x0002YmAtoilet_yell\x0002YmAtile_red\x0002YmAtile_yell\x0002YmApresent_gen\x0002[~Npresent_gen1\x0002[~Npresent_gen2\x0002[~Npresent_gen3\x0002[~Npresent_gen4\x0002[~Npresent_gen5\x0002[~Npresent_gen6\x0002[~Nbar_basic\x0002Y_Ishelves_basic\x0002XQHsoft_sofachair_norja\x0002X~Dsoft_sofa_norja\x0002X~Dlamp_basic\x0002XQHlamp2_armas\x0002YmAfridge\x0002Y_Idoor\x0002Yc[doorB\x0002Yc[doorC\x0002Yc[pumpkin\x0002YmAskullcandle\x0002YmAdeadduck\x0002YmAdeadduck2\x0002YmAdeadduck3\x0002YmAmenorah\x0002YmApudding\x0002YmAham\x0002YmAturkey\x0002YmAxmasduck\x0002Y_Ihouse\x0002YmAtriplecandle\x0002YmAtree3\x0002YmAtree4\x0002YmAtree5\x0002X~Dham2\x0002YmAwcandleset\x0002YmArcandleset\x0002YmAstatue\x0002YmAheart\x0002Y_Ivaleduck\x0002YmAheartsofa\x0002X~Dthrone\x0002YmAsamovar\x0002Y_Igiftflowers\x0002Y_Ihabbocake\x0002YmAhologram\x0002YmAeasterduck\x0002Y_Ibunny\x0002YmAbasket\x0002Y_Ibirdie\x0002YmAedice\x0002X~Dclub_sofa\x0002Z[Mprize1\x0002YmAprize2\x0002YmAprize3\x0002YmAdivider_poly3\x0002X~Ddivider_arm1\x0002YmAdivider_arm2\x0002YmAdivider_arm3\x0002YmAdivider_nor1\x0002X~Ddivider_silo1\x0002X~Ddivider_nor2\x0002X~Ddivider_silo2\x0002Z[Mdivider_nor3\x0002X~Ddivider_silo3\x0002X~Dtypingmachine\x0002YmAspyro\x0002YmAredhologram\x0002YmAcamera\x0002Hjoulutahti\x0002YmAhyacinth1\x0002YmAhyacinth2\x0002YmAchair_plasto*10\x0002YmAchair_plasto*11\x0002YmAbardeskcorner_polyfon*12\x0002X~Dbardeskcorner_polyfon*13\x0002X~Dchair_plasto*12\x0002YmAchair_plasto*13\x0002YmAchair_plasto*14\x0002YmAtable_plasto_4leg*14\x0002Y_Imocchamaster\x0002Y_Icarpet_legocourt\x0002YmAbench_lego\x0002YmAlegotrophy\x0002YmAvalentinescreen\x0002YmAedicehc\x0002YmArare_daffodil_rug\x0002YmArare_beehive_bulb\x0002Y_Ihcsohva\x0002YmAhcamme\x0002YmArare_elephant_statue\x0002YmArare_fountain\x0002Y_Irare_stand\x0002YmArare_globe\x0002YmArare_hammock\x0002YmArare_elephant_statue*1\x0002YmArare_elephant_statue*2\x0002YmArare_fountain*1\x0002Y_Irare_fountain*2\x0002Y_Irare_fountain*3\x0002Y_Irare_beehive_bulb*1\x0002Y_Irare_beehive_bulb*2\x0002Y_Irare_xmas_screen\x0002Y_Irare_parasol*1\x0002XMVrare_parasol*2\x0002XMVrare_parasol*3\x0002XMVtree1\x0002X~Dtree2\x0002ZmBwcandle\x0002YxBrcandle\x0002YxBsoft_jaggara_norja\x0002YmAhouse2\x0002YmAdjesko_turntable\x0002YmAmd_sofa\x0002Z[Mmd_limukaappi\x0002Y_Itable_plasto_4leg*10\x0002Y_Itable_plasto_4leg*15\x0002Y_Itable_plasto_bigsquare*14\x0002Y_Itable_plasto_bigsquare*15\x0002Y_Itable_plasto_round*14\x0002Y_Itable_plasto_round*15\x0002Y_Itable_plasto_square*14\x0002Y_Itable_plasto_square*15\x0002Y_Ichair_plasto*15\x0002YmAchair_plasty*7\x0002X~Dchair_plasty*8\x0002X~Dchair_plasty*9\x0002X~Dchair_plasty*10\x0002X~Dchair_plasty*11\x0002X~Dchair_plasto*16\x0002YmAtable_plasto_4leg*16\x0002Y_Ihockey_score\x0002Y_Ihockey_light\x0002YmAdoorD\x0002Yc[prizetrophy2*3\x0002Yd[prizetrophy3*3\x0002Yd[prizetrophy4*3\x0002Yd[prizetrophy5*3\x0002Yd[prizetrophy6*3\x0002Yd[prizetrophy*1\x0002Yd[prizetrophy2*1\x0002Yd[prizetrophy3*1\x0002Yd[prizetrophy4*1\x0002Yd[prizetrophy5*1\x0002Yd[prizetrophy6*1\x0002Yd[prizetrophy*2\x0002Yd[prizetrophy2*2\x0002Yd[prizetrophy3*2\x0002Yd[prizetrophy4*2\x0002Yd[prizetrophy5*2\x0002Yd[prizetrophy6*2\x0002Yd[prizetrophy*3\x0002Yd[rare_parasol*0\x0002XMVhc_lmp\x0002[fBhc_tbl\x0002YmAhc_chr\x0002YmAhc_dsk\x0002XQHnest\x0002Hpetfood1\x0002ZvCpetfood2\x0002ZvCpetfood3\x0002ZvCwaterbowl*4\x0002XICwaterbowl*5\x0002XICwaterbowl*2\x0002XICwaterbowl*1\x0002XICwaterbowl*3\x0002XICtoy1\x0002XICtoy1*1\x0002XICtoy1*2\x0002XICtoy1*3\x0002XICtoy1*4\x0002XICgoodie1\x0002Yc[goodie1*1\x0002Yc[goodie1*2\x0002Yc[goodie2\x0002Yc[prizetrophy7*3\x0002Yd[prizetrophy7*1\x0002Yd[prizetrophy7*2\x0002Yd[scifiport*0\x0002Y_Iscifiport*9\x0002Y_Iscifiport*8\x0002Y_Iscifiport*7\x0002Y_Iscifiport*6\x0002Y_Iscifiport*5\x0002Y_Iscifiport*4\x0002Y_Iscifiport*3\x0002Y_Iscifiport*2\x0002Y_Iscifiport*1\x0002Y_Iscifirocket*9\x0002Y_Iscifirocket*8\x0002Y_Iscifirocket*7\x0002Y_Iscifirocket*6\x0002Y_Iscifirocket*5\x0002Y_Iscifirocket*4\x0002Y_Iscifirocket*3\x0002Y_Iscifirocket*2\x0002Y_Iscifirocket*1\x0002Y_Iscifirocket*0\x0002Y_Iscifidoor*10\x0002Y_Iscifidoor*9\x0002Y_Iscifidoor*8\x0002Y_Iscifidoor*7\x0002Y_Iscifidoor*6\x0002Y_Iscifidoor*5\x0002Y_Iscifidoor*4\x0002Y_Iscifidoor*3\x0002Y_Iscifidoor*2\x0002Y_Iscifidoor*1\x0002Y_Ipillow*5\x0002YmApillow*8\x0002YmApillow*0\x0002YmApillow*1\x0002YmApillow*2\x0002YmApillow*7\x0002YmApillow*9\x0002YmApillow*4\x0002YmApillow*6\x0002YmApillow*3\x0002YmAmarquee*1\x0002Y_Imarquee*2\x0002Y_Imarquee*7\x0002Y_Imarquee*a\x0002Y_Imarquee*8\x0002Y_Imarquee*9\x0002Y_Imarquee*5\x0002Y_Imarquee*4\x0002Y_Imarquee*6\x0002Y_Imarquee*3\x0002Y_Iwooden_screen*1\x0002Y_Iwooden_screen*2\x0002Y_Iwooden_screen*7\x0002Y_Iwooden_screen*0\x0002Y_Iwooden_screen*8\x0002Y_Iwooden_screen*5\x0002Y_Iwooden_screen*9\x0002Y_Iwooden_screen*4\x0002Y_Iwooden_screen*6\x0002Y_Iwooden_screen*3\x0002Y_Ipillar*6\x0002Y_Ipillar*1\x0002Y_Ipillar*9\x0002Y_Ipillar*0\x0002Y_Ipillar*8\x0002Y_Ipillar*2\x0002Y_Ipillar*5\x0002Y_Ipillar*4\x0002Y_Ipillar*7\x0002Y_Ipillar*3\x0002Y_Irare_dragonlamp*4\x0002Y_Irare_dragonlamp*0\x0002Y_Irare_dragonlamp*5\x0002Y_Irare_dragonlamp*2\x0002Y_Irare_dragonlamp*8\x0002Y_Irare_dragonlamp*9\x0002Y_Irare_dragonlamp*7\x0002Y_Irare_dragonlamp*6\x0002Y_Irare_dragonlamp*1\x0002Y_Irare_dragonlamp*3\x0002Y_Irare_icecream*1\x0002Y_Irare_icecream*7\x0002Y_Irare_icecream*8\x0002Y_Irare_icecream*2\x0002Y_Irare_icecream*6\x0002Y_Irare_icecream*9\x0002Y_Irare_icecream*3\x0002Y_Irare_icecream*0\x0002Y_Irare_icecream*4\x0002Y_Irare_icecream*5\x0002Y_Irare_fan*7\x0002YxBrare_fan*6\x0002YxBrare_fan*9\x0002YxBrare_fan*3\x0002YxBrare_fan*0\x0002YxBrare_fan*4\x0002YxBrare_fan*5\x0002YxBrare_fan*1\x0002YxBrare_fan*8\x0002YxBrare_fan*2\x0002YxBqueue_tile1*3\x0002X~Dqueue_tile1*6\x0002X~Dqueue_tile1*4\x0002X~Dqueue_tile1*9\x0002X~Dqueue_tile1*8\x0002X~Dqueue_tile1*5\x0002X~Dqueue_tile1*7\x0002X~Dqueue_tile1*2\x0002X~Dqueue_tile1*1\x0002X~Dqueue_tile1*0\x0002X~Dticket\x0002Hrare_snowrug\x0002X~Dcn_lamp\x0002ZxIcn_sofa\x0002YmAsporttrack1*1\x0002YmAsporttrack1*3\x0002YmAsporttrack1*2\x0002YmAsporttrack2*1\x0002[~Nsporttrack2*2\x0002[~Nsporttrack2*3\x0002[~Nsporttrack3*1\x0002YmAsporttrack3*2\x0002YmAsporttrack3*3\x0002YmAfootylamp\x0002X~Dbarchair_silo\x0002X~Ddivider_nor4*4\x0002X~Dtraffic_light*1\x0002ZxItraffic_light*2\x0002ZxItraffic_light*3\x0002ZxItraffic_light*4\x0002ZxItraffic_light*6\x0002ZxIrubberchair*1\x0002X~Drubberchair*2\x0002X~Drubberchair*3\x0002X~Drubberchair*4\x0002X~Drubberchair*5\x0002X~Drubberchair*6\x0002X~Dbarrier*1\x0002X~Dbarrier*2\x0002X~Dbarrier*3\x0002X~Drubberchair*7\x0002X~Drubberchair*8\x0002X~Dtable_norja_med*2\x0002Y_Itable_norja_med*3\x0002Y_Itable_norja_med*4\x0002Y_Itable_norja_med*5\x0002Y_Itable_norja_med*6\x0002Y_Itable_norja_med*7\x0002Y_Itable_norja_med*8\x0002Y_Itable_norja_med*9\x0002Y_Icouch_norja*2\x0002X~Dcouch_norja*3\x0002X~Dcouch_norja*4\x0002X~Dcouch_norja*5\x0002X~Dcouch_norja*6\x0002X~Dcouch_norja*7\x0002X~Dcouch_norja*8\x0002X~Dcouch_norja*9\x0002X~Dshelves_norja*2\x0002X~Dshelves_norja*3\x0002X~Dshelves_norja*4\x0002X~Dshelves_norja*5\x0002X~Dshelves_norja*6\x0002X~Dshelves_norja*7\x0002X~Dshelves_norja*8\x0002X~Dshelves_norja*9\x0002X~Dchair_norja*2\x0002X~Dchair_norja*3\x0002X~Dchair_norja*4\x0002X~Dchair_norja*5\x0002X~Dchair_norja*6\x0002X~Dchair_norja*7\x0002X~Dchair_norja*8\x0002X~Dchair_norja*9\x0002X~Ddivider_nor1*2\x0002X~Ddivider_nor1*3\x0002X~Ddivider_nor1*4\x0002X~Ddivider_nor1*5\x0002X~Ddivider_nor1*6\x0002X~Ddivider_nor1*7\x0002X~Ddivider_nor1*8\x0002X~Ddivider_nor1*9\x0002X~Dsoft_sofa_norja*2\x0002X~Dsoft_sofa_norja*3\x0002X~Dsoft_sofa_norja*4\x0002X~Dsoft_sofa_norja*5\x0002X~Dsoft_sofa_norja*6\x0002X~Dsoft_sofa_norja*7\x0002X~Dsoft_sofa_norja*8\x0002X~Dsoft_sofa_norja*9\x0002X~Dsoft_sofachair_norja*2\x0002X~Dsoft_sofachair_norja*3\x0002X~Dsoft_sofachair_norja*4\x0002X~Dsoft_sofachair_norja*5\x0002X~Dsoft_sofachair_norja*6\x0002X~Dsoft_sofachair_norja*7\x0002X~Dsoft_sofachair_norja*8\x0002X~Dsoft_sofachair_norja*9\x0002X~Dsofachair_silo*2\x0002X~Dsofachair_silo*3\x0002X~Dsofachair_silo*4\x0002X~Dsofachair_silo*5\x0002X~Dsofachair_silo*6\x0002X~Dsofachair_silo*7\x0002X~Dsofachair_silo*8\x0002X~Dsofachair_silo*9\x0002X~Dtable_silo_small*2\x0002X~Dtable_silo_small*3\x0002X~Dtable_silo_small*4\x0002X~Dtable_silo_small*5\x0002X~Dtable_silo_small*6\x0002X~Dtable_silo_small*7\x0002X~Dtable_silo_small*8\x0002X~Dtable_silo_small*9\x0002X~Ddivider_silo1*2\x0002X~Ddivider_silo1*3\x0002X~Ddivider_silo1*4\x0002X~Ddivider_silo1*5\x0002X~Ddivider_silo1*6\x0002X~Ddivider_silo1*7\x0002X~Ddivider_silo1*8\x0002X~Ddivider_silo1*9\x0002X~Ddivider_silo3*2\x0002X~Ddivider_silo3*3\x0002X~Ddivider_silo3*4\x0002X~Ddivider_silo3*5\x0002X~Ddivider_silo3*6\x0002X~Ddivider_silo3*7\x0002X~Ddivider_silo3*8\x0002X~Ddivider_silo3*9\x0002X~Dtable_silo_med*2\x0002X~Dtable_silo_med*3\x0002X~Dtable_silo_med*4\x0002X~Dtable_silo_med*5\x0002X~Dtable_silo_med*6\x0002X~Dtable_silo_med*7\x0002X~Dtable_silo_med*8\x0002X~Dtable_silo_med*9\x0002X~Dsofa_silo*2\x0002X~Dsofa_silo*3\x0002X~Dsofa_silo*4\x0002X~Dsofa_silo*5\x0002X~Dsofa_silo*6\x0002X~Dsofa_silo*7\x0002X~Dsofa_silo*8\x0002X~Dsofa_silo*9\x0002X~Dsofachair_polyfon*2\x0002X~Dsofachair_polyfon*3\x0002X~Dsofachair_polyfon*4\x0002X~Dsofachair_polyfon*6\x0002X~Dsofachair_polyfon*7\x0002X~Dsofachair_polyfon*8\x0002X~Dsofachair_polyfon*9\x0002X~Dsofa_polyfon*2\x0002Z[Msofa_polyfon*3\x0002Z[Msofa_polyfon*4\x0002Z[Msofa_polyfon*6\x0002Z[Msofa_polyfon*7\x0002Z[Msofa_polyfon*8\x0002Z[Msofa_polyfon*9\x0002Z[Mbed_polyfon*2\x0002X~Dbed_polyfon*3\x0002X~Dbed_polyfon*4\x0002X~Dbed_polyfon*6\x0002X~Dbed_polyfon*7\x0002X~Dbed_polyfon*8\x0002X~Dbed_polyfon*9\x0002X~Dbed_polyfon_one*2\x0002[dObed_polyfon_one*3\x0002[dObed_polyfon_one*4\x0002[dObed_polyfon_one*6\x0002[dObed_polyfon_one*7\x0002[dObed_polyfon_one*8\x0002[dObed_polyfon_one*9\x0002[dObardesk_polyfon*2\x0002X~Dbardesk_polyfon*3\x0002X~Dbardesk_polyfon*4\x0002X~Dbardesk_polyfon*5\x0002X~Dbardesk_polyfon*6\x0002X~Dbardesk_polyfon*7\x0002X~Dbardesk_polyfon*8\x0002X~Dbardesk_polyfon*9\x0002X~Dbardeskcorner_polyfon*2\x0002X~Dbardeskcorner_polyfon*3\x0002X~Dbardeskcorner_polyfon*4\x0002X~Dbardeskcorner_polyfon*5\x0002X~Dbardeskcorner_polyfon*6\x0002X~Dbardeskcorner_polyfon*7\x0002X~Dbardeskcorner_polyfon*8\x0002X~Dbardeskcorner_polyfon*9\x0002X~Ddivider_poly3*2\x0002X~Ddivider_poly3*3\x0002X~Ddivider_poly3*4\x0002X~Ddivider_poly3*5\x0002X~Ddivider_poly3*6\x0002X~Ddivider_poly3*7\x0002X~Ddivider_poly3*8\x0002X~Ddivider_poly3*9\x0002X~Dchair_silo*2\x0002X~Dchair_silo*3\x0002X~Dchair_silo*4\x0002X~Dchair_silo*5\x0002X~Dchair_silo*6\x0002X~Dchair_silo*7\x0002X~Dchair_silo*8\x0002X~Dchair_silo*9\x0002X~Ddivider_nor3*2\x0002X~Ddivider_nor3*3\x0002X~Ddivider_nor3*4\x0002X~Ddivider_nor3*5\x0002X~Ddivider_nor3*6\x0002X~Ddivider_nor3*7\x0002X~Ddivider_nor3*8\x0002X~Ddivider_nor3*9\x0002X~Ddivider_nor2*2\x0002X~Ddivider_nor2*3\x0002X~Ddivider_nor2*4\x0002X~Ddivider_nor2*5\x0002X~Ddivider_nor2*6\x0002X~Ddivider_nor2*7\x0002X~Ddivider_nor2*8\x0002X~Ddivider_nor2*9\x0002X~Dsilo_studydesk\x0002X~Dsolarium_norja\x0002Y_Isolarium_norja*1\x0002Y_Isolarium_norja*2\x0002Y_Isolarium_norja*3\x0002Y_Isolarium_norja*5\x0002Y_Isolarium_norja*6\x0002Y_Isolarium_norja*7\x0002Y_Isolarium_norja*8\x0002Y_Isolarium_norja*9\x0002Y_Isandrug\x0002X~Drare_moonrug\x0002YmAchair_china\x0002YmAchina_table\x0002YmAsleepingbag*1\x0002YmAsleepingbag*2\x0002YmAsleepingbag*3\x0002YmAsleepingbag*4\x0002YmAsafe_silo\x0002Y_Isleepingbag*7\x0002YmAsleepingbag*9\x0002YmAsleepingbag*5\x0002YmAsleepingbag*10\x0002YmAsleepingbag*6\x0002YmAsleepingbag*8\x0002YmAchina_shelve\x0002X~Dtraffic_light*5\x0002ZxIdivider_nor4*2\x0002X~Ddivider_nor4*3\x0002X~Ddivider_nor4*5\x0002X~Ddivider_nor4*6\x0002X~Ddivider_nor4*7\x0002X~Ddivider_nor4*8\x0002X~Ddivider_nor4*9\x0002X~Ddivider_nor5*2\x0002X~Ddivider_nor5*3\x0002X~Ddivider_nor5*4\x0002X~Ddivider_nor5*5\x0002X~Ddivider_nor5*6\x0002X~Ddivider_nor5*7\x0002X~Ddivider_nor5*8\x0002X~Ddivider_nor5*9\x0002X~Ddivider_nor5\x0002X~Ddivider_nor4\x0002X~Dwall_china\x0002YmAcorner_china\x0002YmAbarchair_silo*2\x0002X~Dbarchair_silo*3\x0002X~Dbarchair_silo*4\x0002X~Dbarchair_silo*5\x0002X~Dbarchair_silo*6\x0002X~Dbarchair_silo*7\x0002X~Dbarchair_silo*8\x0002X~Dbarchair_silo*9\x0002X~Dsafe_silo*2\x0002Y_Isafe_silo*3\x0002Y_Isafe_silo*4\x0002Y_Isafe_silo*5\x0002Y_Isafe_silo*6\x0002Y_Isafe_silo*7\x0002Y_Isafe_silo*8\x0002Y_Isafe_silo*9\x0002Y_Iglass_shelf\x0002Y_Iglass_chair\x0002Y_Iglass_stool\x0002Y_Iglass_sofa\x0002Y_Iglass_table\x0002Y_Iglass_table*2\x0002Y_Iglass_table*3\x0002Y_Iglass_table*4\x0002Y_Iglass_table*5\x0002Y_Iglass_table*6\x0002Y_Iglass_table*7\x0002Y_Iglass_table*8\x0002Y_Iglass_table*9\x0002Y_Iglass_chair*2\x0002Y_Iglass_chair*3\x0002Y_Iglass_chair*4\x0002Y_Iglass_chair*5\x0002Y_Iglass_chair*6\x0002Y_Iglass_chair*7\x0002Y_Iglass_chair*8\x0002Y_Iglass_chair*9\x0002Y_Iglass_sofa*2\x0002Y_Iglass_sofa*3\x0002Y_Iglass_sofa*4\x0002Y_Iglass_sofa*5\x0002Y_Iglass_sofa*6\x0002Y_Iglass_sofa*7\x0002Y_Iglass_sofa*8\x0002Y_Iglass_sofa*9\x0002Y_Iglass_stool*2\x0002Y_Iglass_stool*4\x0002Y_Iglass_stool*5\x0002Y_Iglass_stool*6\x0002Y_Iglass_stool*7\x0002Y_Iglass_stool*8\x0002Y_Iglass_stool*3\x0002Y_Iglass_stool*9\x0002Y_ICF_10_coin_gold\x0002ZvCCF_1_coin_bronze\x0002ZvCCF_20_moneybag\x0002ZvCCF_50_goldbar\x0002ZvCCF_5_coin_silver\x0002ZvChc_crpt\x0002YmAhc_tv\x0002Z\\Bgothgate\x0002X~Dgothiccandelabra\x0002YxBgothrailing\x0002X~Dgoth_table\x0002YmAhc_bkshlf\x0002YmAhc_btlr\x0002Y_Ihc_crtn\x0002YmAhc_djset\x0002YmAhc_frplc\x0002ZbBhc_lmpst\x0002YmAhc_machine\x0002YmAhc_rllr\x0002XQHhc_rntgn\x0002X~Dhc_trll\x0002YmAgothic_chair*1\x0002X~Dgothic_sofa*1\x0002X~Dgothic_stool*1\x0002X~Dgothic_chair*2\x0002X~Dgothic_sofa*2\x0002X~Dgothic_stool*2\x0002X~Dgothic_chair*3\x0002X~Dgothic_sofa*3\x0002X~Dgothic_stool*3\x0002X~Dgothic_chair*4\x0002X~Dgothic_sofa*4\x0002X~Dgothic_stool*4\x0002X~Dgothic_chair*5\x0002X~Dgothic_sofa*5\x0002X~Dgothic_stool*5\x0002X~Dgothic_chair*6\x0002X~Dgothic_sofa*6\x0002X~Dgothic_stool*6\x0002X~Dval_cauldron\x0002X~Dsound_machine\x0002X~Dromantique_pianochair*3\x0002Y_Iromantique_pianochair*5\x0002Y_Iromantique_pianochair*2\x0002Y_Iromantique_pianochair*4\x0002Y_Iromantique_pianochair*1\x0002Y_Iromantique_divan*3\x0002Y_Iromantique_divan*5\x0002Y_Iromantique_divan*2\x0002Y_Iromantique_divan*4\x0002Y_Iromantique_divan*1\x0002Y_Iromantique_chair*3\x0002Y_Iromantique_chair*5\x0002Y_Iromantique_chair*2\x0002Y_Iromantique_chair*4\x0002Y_Iromantique_chair*1\x0002Y_Irare_parasol\x0002Y_Iplant_valentinerose*3\x0002XICplant_valentinerose*5\x0002XICplant_valentinerose*2\x0002XICplant_valentinerose*4\x0002XICplant_valentinerose*1\x0002XICplant_mazegate\x0002YeCplant_maze\x0002ZcCplant_bulrush\x0002XICpetfood4\x0002Y_Icarpet_valentine\x0002Z|Egothic_carpet\x0002XICgothic_carpet2\x0002Z|Egothic_chair\x0002X~Dgothic_sofa\x0002X~Dgothic_stool\x0002X~Dgrand_piano*3\x0002Z|Egrand_piano*5\x0002Z|Egrand_piano*2\x0002Z|Egrand_piano*4\x0002Z|Egrand_piano*1\x0002Z|Etheatre_seat\x0002Z@Kromantique_tray2\x0002Y_Iromantique_tray1\x0002Y_Iromantique_smalltabl*3\x0002Y_Iromantique_smalltabl*5\x0002Y_Iromantique_smalltabl*2\x0002Y_Iromantique_smalltabl*4\x0002Y_Iromantique_smalltabl*1\x0002Y_Iromantique_mirrortabl\x0002Y_Iromantique_divider*3\x0002Z[Mromantique_divider*2\x0002Z[Mromantique_divider*4\x0002Z[Mromantique_divider*1\x0002Z[Mjp_tatami2\x0002[dWjp_tatami\x0002YGGhabbowood_chair\x0002YGGjp_bamboo\x0002YGGjp_irori\x0002XQHjp_pillow\x0002YGGsound_set_1\x0002[dWsound_set_2\x0002[dWsound_set_3\x0002[dWsound_set_4\x0002[dWsound_set_5\x0002[dWsound_set_6\x0002[dWsound_set_7\x0002[dWsound_set_8\x0002[dWsound_set_9\x0002[dWsound_machine*1\x0002Yc[spotlight\x0002Y_Isound_machine*2\x0002Yc[sound_machine*3\x0002Yc[sound_machine*4\x0002Yc[sound_machine*5\x0002Yc[sound_machine*6\x0002Yc[sound_machine*7\x0002Yc[rom_lamp\x0002Z|Erclr_sofa\x0002XQHrclr_garden\x0002XQHrclr_chair\x0002Z|Esound_set_28\x0002[dWsound_set_27\x0002[dWsound_set_26\x0002[dWsound_set_25\x0002[dWsound_set_24\x0002[dWsound_set_23\x0002[dWsound_set_22\x0002[dWsound_set_21\x0002[dWsound_set_20\x0002[dWsound_set_19\x0002[dWsound_set_18\x0002[dWsound_set_17\x0002[dWsound_set_16\x0002[dWsound_set_15\x0002[dWsound_set_14\x0002[dWsound_set_13\x0002[dWsound_set_12\x0002[dWsound_set_11\x0002[dWsound_set_10\x0002[dWrope_divider\x0002XQHromantique_clock\x0002Y_Irare_icecream_campaign\x0002Y_Ipura_mdl5*1\x0002Yc[pura_mdl5*2\x0002Yc[pura_mdl5*3\x0002Yc[pura_mdl5*4\x0002Yc[pura_mdl5*5\x0002Yc[pura_mdl5*6\x0002Yc[pura_mdl5*7\x0002Yc[pura_mdl5*8\x0002Yc[pura_mdl5*9\x0002Yc[pura_mdl4*1\x0002XQHpura_mdl4*2\x0002XQHpura_mdl4*3\x0002XQHpura_mdl4*4\x0002XQHpura_mdl4*5\x0002XQHpura_mdl4*6\x0002XQHpura_mdl4*7\x0002XQHpura_mdl4*8\x0002XQHpura_mdl4*9\x0002XQHpura_mdl3*1\x0002XQHpura_mdl3*2\x0002XQHpura_mdl3*3\x0002XQHpura_mdl3*4\x0002XQHpura_mdl3*5\x0002XQHpura_mdl3*6\x0002XQHpura_mdl3*7\x0002XQHpura_mdl3*8\x0002XQHpura_mdl3*9\x0002XQHpura_mdl2*1\x0002XQHpura_mdl2*2\x0002XQHpura_mdl2*3\x0002XQHpura_mdl2*4\x0002XQHpura_mdl2*5\x0002XQHpura_mdl2*6\x0002XQHpura_mdl2*7\x0002XQHpura_mdl2*8\x0002XQHpura_mdl2*9\x0002XQHpura_mdl1*1\x0002XQHpura_mdl1*2\x0002XQHpura_mdl1*3\x0002XQHpura_mdl1*4\x0002XQHpura_mdl1*5\x0002XQHpura_mdl1*6\x0002XQHpura_mdl1*7\x0002XQHpura_mdl1*8\x0002XQHpura_mdl1*9\x0002XQHjp_lantern\x0002XQHchair_basic*1\x0002XQHchair_basic*2\x0002XQHchair_basic*3\x0002XQHchair_basic*4\x0002XQHchair_basic*5\x0002XQHchair_basic*6\x0002XQHchair_basic*7\x0002XQHchair_basic*8\x0002XQHchair_basic*9\x0002XQHbed_budget*1\x0002XQHbed_budget*2\x0002XQHbed_budget*3\x0002XQHbed_budget*4\x0002XQHbed_budget*5\x0002XQHbed_budget*6\x0002XQHbed_budget*7\x0002XQHbed_budget*8\x0002XQHbed_budget*9\x0002XQHbed_budget_one*1\x0002XQHbed_budget_one*2\x0002XQHbed_budget_one*3\x0002XQHbed_budget_one*4\x0002XQHbed_budget_one*5\x0002XQHbed_budget_one*6\x0002XQHbed_budget_one*7\x0002XQHbed_budget_one*8\x0002XQHbed_budget_one*9\x0002XQHjp_drawer\x0002XQHtile_stella\x0002Z[Mtile_marble\x0002Z[Mtile_brown\x0002Z[Msummer_grill*1\x0002Y_Isummer_grill*2\x0002Y_Isummer_grill*3\x0002Y_Isummer_grill*4\x0002Y_Isummer_chair*1\x0002Y_Isummer_chair*2\x0002Y_Isummer_chair*3\x0002Y_Isummer_chair*4\x0002Y_Isummer_chair*5\x0002Y_Isummer_chair*6\x0002Y_Isummer_chair*7\x0002Y_Isummer_chair*8\x0002Y_Isummer_chair*9\x0002Y_Isound_set_36\x0002[dWsound_set_35\x0002[dWsound_set_34\x0002[dWsound_set_33\x0002[dWsound_set_32\x0002[dWsound_set_31\x0002[dWsound_set_30\x0002[dWsound_set_29\x0002[dWsound_machine_pro\x0002Yc[rare_mnstr\x0002Y_Ione_way_door*1\x0002XQHone_way_door*2\x0002XQHone_way_door*3\x0002XQHone_way_door*4\x0002XQHone_way_door*5\x0002XQHone_way_door*6\x0002XQHone_way_door*7\x0002XQHone_way_door*8\x0002XQHone_way_door*9\x0002XQHexe_rug\x0002Z[Mexe_s_table\x0002ZGRsound_set_37\x0002[dWsummer_pool*1\x0002ZlIsummer_pool*2\x0002ZlIsummer_pool*3\x0002ZlIsummer_pool*4\x0002ZlIsong_disk\x0002Yc[jukebox*1\x0002Yc[carpet_soft_tut\x0002[~Nsound_set_44\x0002[dWsound_set_43\x0002[dWsound_set_42\x0002[dWsound_set_41\x0002[dWsound_set_40\x0002[dWsound_set_39\x0002[dWsound_set_38\x0002[dWgrunge_chair\x0002Z@Kgrunge_mattress\x0002Z@Kgrunge_radiator\x0002Z@Kgrunge_shelf\x0002Z@Kgrunge_sign\x0002Z@Kgrunge_table\x0002Z@Khabboween_crypt\x0002[uKhabboween_grass\x0002Z@Khal_cauldron\x0002Z@Khal_grave\x0002Z@Ksound_set_52\x0002[dWsound_set_51\x0002[dWsound_set_50\x0002[dWsound_set_49\x0002[dWsound_set_48\x0002[dWsound_set_47\x0002[dWsound_set_46\x0002[dWsound_set_45\x0002[dWxmas_icelamp\x0002Z[Mxmas_cstl_wall\x0002Z[Mxmas_cstl_twr\x0002Z[Mxmas_cstl_gate\x0002[~Ntree7\x0002Z[Mtree6\x0002Z[Msound_set_54\x0002[dWsound_set_53\x0002[dWsafe_silo_pb\x0002[dOplant_mazegate_snow\x0002Z[Mplant_maze_snow\x0002Z[Mchristmas_sleigh\x0002Z[Mchristmas_reindeer\x0002[~Nchristmas_poop\x0002Z[Mexe_bardesk\x0002Z[Mexe_chair\x0002Z[Mexe_chair2\x0002Z[Mexe_corner\x0002Z[Mexe_drinks\x0002Z[Mexe_sofa\x0002Z[Mexe_table\x0002Z[Msound_set_59\x0002[dWsound_set_58\x0002[dWsound_set_57\x0002[dWsound_set_56\x0002[dWsound_set_55\x0002[dWnoob_table*1\x0002[~Nnoob_table*2\x0002[~Nnoob_table*3\x0002[~Nnoob_table*4\x0002[~Nnoob_table*5\x0002[~Nnoob_table*6\x0002[~Nnoob_stool*1\x0002[~Nnoob_stool*2\x0002[~Nnoob_stool*3\x0002[~Nnoob_stool*4\x0002[~Nnoob_stool*5\x0002[~Nnoob_stool*6\x0002[~Nnoob_rug*1\x0002[~Nnoob_rug*2\x0002[~Nnoob_rug*3\x0002[~Nnoob_rug*4\x0002[~Nnoob_rug*5\x0002[~Nnoob_rug*6\x0002[~Nnoob_lamp*1\x0002[dOnoob_lamp*2\x0002[dOnoob_lamp*3\x0002[dOnoob_lamp*4\x0002[dOnoob_lamp*5\x0002[dOnoob_lamp*6\x0002[dOnoob_chair*1\x0002[~Nnoob_chair*2\x0002[~Nnoob_chair*3\x0002[~Nnoob_chair*4\x0002[~Nnoob_chair*5\x0002[~Nnoob_chair*6\x0002[~Nexe_globe\x0002[~Nexe_plant\x0002Z[Mval_teddy*1\x0002[dOval_teddy*2\x0002[dOval_teddy*3\x0002[dOval_teddy*4\x0002[dOval_teddy*5\x0002[dOval_teddy*6\x0002[dOval_randomizer\x0002[dOval_choco\x0002[dOteleport_door\x0002Yc[sound_set_61\x0002[dWsound_set_60\x0002[dWfortune\x0002[dOsw_table\x0002ZIPsw_raven\x0002[cQsw_chest\x0002ZIPsand_cstl_wall\x0002ZIPsand_cstl_twr\x0002ZIPsand_cstl_gate\x0002ZIPgrunge_candle\x0002ZIPgrunge_bench\x0002ZIPgrunge_barrel\x0002ZIPrclr_lamp\x0002ZGRprizetrophy9*1\x0002Yd[prizetrophy8*1\x0002Yd[nouvelle_trax\x0002Yc[md_rug\x0002ZGRjp_tray6\x0002ZGRjp_tray5\x0002ZGRjp_tray4\x0002ZGRjp_tray3\x0002ZGRjp_tray2\x0002ZGRjp_tray1\x0002ZGRarabian_teamk\x0002ZGRarabian_snake\x0002ZGRarabian_rug\x0002ZGRarabian_pllw\x0002ZGRarabian_divdr\x0002ZGRarabian_chair\x0002ZGRarabian_bigtb\x0002ZGRarabian_tetbl\x0002ZGRarabian_tray1\x0002ZGRarabian_tray2\x0002ZGRarabian_tray3\x0002ZGRarabian_tray4\x0002ZGRsound_set_64\x0002[dWsound_set_63\x0002[dWsound_set_62\x0002[dWjukebox_ptv*1\x0002Yc[calippo\x0002ZAStraxsilver\x0002Yc[traxgold\x0002Yc[traxbronze\x0002Yc[bench_puffet\x0002YATCFC_500_goldbar\x0002ZvCCFC_200_moneybag\x0002ZvCCFC_10_coin_bronze\x0002ZvCCFC_100_coin_gold\x0002ZvCCFC_50_coin_silver\x0002ZvCjp_table\x0002XMVjp_rare\x0002XMVjp_katana3\x0002XMVjp_katana2\x0002XMVjp_katana1\x0002XMVfootylamp_campaign\x0002XMVtiki_waterfall\x0002[dWtiki_tray4\x0002[dWtiki_tray3\x0002[dWtiki_tray2\x0002[dWtiki_tray1\x0002[dWtiki_tray0\x0002[dWtiki_toucan\x0002[dWtiki_torch\x0002[dWtiki_statue\x0002[dWtiki_sand\x0002[dWtiki_parasol\x0002[dWtiki_junglerug\x0002[dWtiki_corner\x0002[dWtiki_bflies\x0002[dWtiki_bench\x0002[dWtiki_bardesk\x0002[dWtampax_rug\x0002[dWsound_set_70\x0002[dWsound_set_69\x0002[dWsound_set_68\x0002[dWsound_set_67\x0002[dWsound_set_66\x0002[dWsound_set_65\x0002[dWnoob_rug_tradeable*1\x0002[dWnoob_rug_tradeable*2\x0002[dWnoob_rug_tradeable*3\x0002[dWnoob_rug_tradeable*4\x0002[dWnoob_rug_tradeable*5\x0002[dWnoob_rug_tradeable*6\x0002[dWnoob_plant\x0002[dWnoob_lamp_tradeable*1\x0002[dWnoob_lamp_tradeable*2\x0002[dWnoob_lamp_tradeable*3\x0002[dWnoob_lamp_tradeable*4\x0002[dWnoob_lamp_tradeable*5\x0002[dWnoob_lamp_tradeable*6\x0002[dWnoob_chair_tradeable*1\x0002[dWnoob_chair_tradeable*2\x0002[dWnoob_chair_tradeable*3\x0002[dWnoob_chair_tradeable*4\x0002[dWnoob_chair_tradeable*5\x0002[dWnoob_chair_tradeable*6\x0002[dWjp_teamaker\x0002[dWsvnr_uk\x0002[`_svnr_nl\x0002XhXsvnr_it\x0002XhXsvnr_de\x0002[gXsvnr_aus\x0002[gXdiner_tray_7\x0002[gXdiner_tray_6\x0002[gXdiner_tray_5\x0002[gXdiner_tray_4\x0002[gXdiner_tray_3\x0002[gXdiner_tray_2\x0002[gXdiner_tray_1\x0002[gXdiner_tray_0\x0002[gXdiner_sofa_2*1\x0002[gXdiner_sofa_2*2\x0002[gXdiner_sofa_2*3\x0002[gXdiner_sofa_2*4\x0002[gXdiner_sofa_2*5\x0002[gXdiner_sofa_2*6\x0002[gXdiner_sofa_2*7\x0002[gXdiner_sofa_2*8\x0002[gXdiner_sofa_2*9\x0002[gXdiner_shaker\x0002[gXdiner_rug\x0002[gXdiner_gumvendor*1\x0002[gXdiner_gumvendor*2\x0002[gXdiner_gumvendor*3\x0002[gXdiner_gumvendor*4\x0002[gXdiner_gumvendor*5\x0002[gXdiner_gumvendor*6\x0002[gXdiner_gumvendor*7\x0002[gXdiner_gumvendor*8\x0002[gXdiner_gumvendor*9\x0002[gXdiner_cashreg*1\x0002[gXdiner_cashreg*2\x0002[gXdiner_cashreg*3\x0002[gXdiner_cashreg*4\x0002[gXdiner_cashreg*5\x0002[gXdiner_cashreg*6\x0002[gXdiner_cashreg*7\x0002[gXdiner_cashreg*8\x0002[gXdiner_cashreg*9\x0002[gXdiner_table_2*1\x0002XiZdiner_table_2*2diner_table_2*2\x0002XiZdiner_table_2*3\x0002XiZdiner_table_2*4\x0002XiZdiner_table_2*5\x0002XiZdiner_table_2*6\x0002XiZdiner_table_2*7\x0002XiZdiner_table_2*8\x0002XiZdiner_table_2*9\x0002XiZdiner_table_1*1\x0002XiZdiner_table_1*2\x0002XiZdiner_table_1*3\x0002XiZdiner_table_1*4\x0002XiZdiner_table_1*5\x0002XiZdiner_table_1*6\x0002XiZdiner_table_1*7\x0002XiZdiner_table_1*8\x0002XiZdiner_table_1*9\x0002XiZdiner_sofa_1*1\x0002XiZdiner_sofa_1*2\x0002XiZdiner_sofa_1*3\x0002XiZdiner_sofa_1*4\x0002XiZdiner_sofa_1*5\x0002XiZdiner_sofa_1*6\x0002XiZdiner_sofa_1*7\x0002XiZdiner_sofa_1*8\x0002XiZdiner_sofa_1*9\x0002XiZdiner_chair*1\x0002XiZdiner_chair*2\x0002XiZdiner_chair*3\x0002XiZdiner_chair*4\x0002XiZdiner_chair*5\x0002XiZdiner_chair*6\x0002XiZdiner_chair*7\x0002XiZdiner_chair*8\x0002XiZdiner_chair*9\x0002XiZdiner_bardesk_gate*1\x0002XiZdiner_bardesk_gate*2\x0002XiZdiner_bardesk_gate*3\x0002XiZdiner_bardesk_gate*4\x0002XiZdiner_bardesk_gate*5\x0002XiZdiner_bardesk_gate*6\x0002XiZdiner_bardesk_gate*7\x0002XiZdiner_bardesk_gate*8\x0002XiZdiner_bardesk_gate*9\x0002XiZdiner_bardesk_corner*1\x0002XiZdiner_bardesk_corner*2\x0002XiZdiner_bardesk_corner*3\x0002XiZdiner_bardesk_corner*4\x0002XiZdiner_bardesk_corner*5\x0002XiZdiner_bardesk_corner*6\x0002XiZdiner_bardesk_corner*7\x0002XiZdiner_bardesk_corner*8\x0002XiZdiner_bardesk_corner*9\x0002XiZdiner_bardesk*1\x0002XiZdiner_bardesk*2\x0002XiZdiner_bardesk*3\x0002XiZdiner_bardesk*4\x0002XiZdiner_bardesk*5\x0002XiZdiner_bardesk*6\x0002XiZdiner_bardesk*7\x0002XiZdiner_bardesk*8\x0002XiZdiner_bardesk*9\x0002XiZads_dave_cns\x0002XiZeasy_carpet\x0002Yc[easy_bowl2\x0002Yc[greek_corner\x0002Yc[greek_gate\x0002Yc[greek_pillars\x0002Yc[greek_seat\x0002Yc[greektrophy*1\x0002[P\\greektrophy*2\x0002[P\\greektrophy*3\x0002[P\\greek_block\x0002Xt[hcc_table\x0002Y`]hcc_shelf\x0002Y`]hcc_sofa\x0002Y`]hcc_minibar\x0002Y`]hcc_chair\x0002Y`]det_divider\x0002Y`]netari_carpet\x0002Y`]det_body\x0002Y`]hcc_stool\x0002Y`]hcc_sofachair\x0002Y`]hcc_crnr\x0002Xw]hcc_dvdr\x0002Xw]sob_carpet\x0002[`_igor_seat\x0002[`_ads_igorbrain\x0002Y_aads_igorswitch\x0002Y_aads_711*1\x0002Y_aads_711*2\x0002Y_aads_711*3\x0002Y_aads_711*4\x0002Y_aads_igorraygun\x0002Y_ahween08_sink\x0002Y[chween08_curtain\x0002Y[chween08_bath\x0002Y[chween08_defibs\x0002Y[chween08_bbag\x0002Y[chween08_curtain2\x0002Y[chween08_defibs2\x0002Y[chween08_bed\x0002Y[chween08_sink2\x0002Y[chween08_bed2\x0002Y[chween08_bath2\x0002Y[chween08_manhole\x0002Y[chween08_trll\x0002Y[cPRpost.it\x0002Hpost.it.vd\x0002Hphoto\x0002HChess\x0002HTicTacToe\x0002HBattleShip\x0002HPoker\x0002Hwallpaper\x0002Hfloor\x0002Hposter\x0002Z@Kgothicfountain\x0002YxBhc_wall_lamp\x0002ZbBindustrialfan\x0002Z`Btorch\x0002Z\\Bval_heart\x0002XBCwallmirror\x0002Z|Ejp_ninjastars\x0002XQHhabw_mirror\x0002XQHhabbowheel\x0002Z[Mguitar_skull\x0002Z@Kguitar_v\x0002Z@Kxmas_light\x0002[~Nhrella_poster_3\x0002[\x007fNhrella_poster_2\x0002ZIPhrella_poster_1\x0002[\x007fNsw_swords\x0002ZIPsw_stone\x0002ZIPsw_hole\x0002ZIProomdimmer\x0002Yc[md_logo_wall\x0002ZGRmd_can\x0002ZGRjp_sheet3\x0002ZGRjp_sheet2\x0002ZGRjp_sheet1\x0002ZGRarabian_swords\x0002ZGRarabian_wndw\x0002ZGRtiki_wallplnt\x0002[dWtiki_surfboard\x0002[dWtampax_wall\x0002[dWwindow_single_default\x0002[gXwindow_double_default\x0002[gXnoob_window_double\x0002[dWwindow_triple\x0002[gXwindow_square\x0002[gXwindow_romantic_wide\x0002[gXwindow_romantic_narrow\x0002[gXwindow_grunge\x0002[gXwindow_golden\x0002[gXwindow_chinese_wide\x0002[gXwindow_chinese_narrow\x0002YA\\window_basic\x0002[gXwindow_70s_wide\x0002[gXwindow_70s_narrow\x0002[gXads_sunnyd\x0002YlXwindow_diner2\x0002XiZwindow_diner\x0002XiZdiner_walltable\x0002XiZads_dave_wall\x0002XiZwindow_hole\x0002Yc[easy_poster\x0002Yc[ads_nokia_logo\x0002Yc[ads_nokia_phone\x0002Yc[landscape\x0002XV^window_skyscraper\x0002[j\\netari_poster\x0002Y`]det_bhole\x0002Y`]ads_campguitar\x0002Xw]hween08_rad\x0002Y[chween08_wndwb\x0002Y[chween08_wndw\x0002Y[chween08_bio\x0002Y[chw_08_xray\x0002Y[c");
                                this._receivedSpriteIndex = true;
                            }
                            int num72 = DB.runRead("SELECT ach_room_visits FROM users WHERE id = '" + this.userID + "'", 0) + 1;
                            DB.runQuery(string.Concat(new object[] { "UPDATE users SET ach_room_visits = '", num72, "' WHERE id = '", this.userID, "' LIMIT 1" }));
                            if (num72 <= 30)
                            {
                                if (num72 > 0x1d)
                                {
                                    if (!DB.checkExists("SELECT badgeid FROM users_badges WHERE userid = '" + this.userID + "' AND badgeid = 'ACH_RoomEntry3'"))
                                    {
                                        DB.runQuery("UPDATE users_badges SET badgeid = 'ACH_RoomEntry3' WHERE badgeid = 'ACH_RoomEntry2' AND userid = '" + this.userID + "'");
                                        this.refreshBadges();
                                        return;
                                    }
                                    return;
                                }
                                if (num72 > 14)
                                {
                                    if (!DB.checkExists("SELECT badgeid FROM users_badges WHERE userid = '" + this.userID + "' AND badgeid = 'ACH_RoomEntry2'"))
                                    {
                                        DB.runQuery("UPDATE users_badges SET badgeid = 'ACH_RoomEntry2' WHERE badgeid = 'ACH_RoomEntry1' AND userid = '" + this.userID + "'");
                                        this.refreshBadges();
                                        return;
                                    }
                                    return;
                                }
                                if ((num72 <= 4) || DB.checkExists("SELECT badgeid FROM users_badges WHERE userid = '" + this.userID + "' AND badgeid = 'ACH_RoomEntry1'"))
                                {
                                    return;
                                }
                                DB.runQuery("INSERT INTO users_badges (userid, badgeid, iscurrent) VALUES ('" + this.userID + "', 'ACH_RoomEntry1', '0')");
                                this.refreshBadges();
                            }
                        }
                        return;

                    case "@\x007f":
                        if (this._ROOMACCESS_SECONDARY_OK && (this.Room != null))
                        {
                            this.sendData("@m" + this.Room.Wallitems);
                        }
                        return;

                    case "A@":
                        if ((this._ROOMACCESS_SECONDARY_OK && (this.Room != null)) && (this.roomUser == null))
                        {
                            this.sendData("@b" + this.Room.dynamicStatuses);
                            this.Room.addUser(this);
                        }
                        return;

                    case "CH":
                    {
                        int num73 = 0;
                        string message = "";
                        int num74 = 0;
                        string note = "";
                        string str43 = "";
                        str113 = currentPacket.Substring(2, 2);
                        if (str113 != null)
                        {
                            if (str113 == "HH")
                            {
                                if (!rankManager.containsRight(this._Rank, "fuse_alert"))
                                {
                                    this.sendData("BK" + stringManager.getString("modtool_accesserror"));
                                    return;
                                }
                                num73 = Encoding.decodeB64(currentPacket.Substring(4, 2));
                                message = currentPacket.Substring(6, num73).Replace(Convert.ToChar(1).ToString(), " ");
                                num74 = Encoding.decodeB64(currentPacket.Substring(num73 + 6, 2));
                                note = currentPacket.Substring(num73 + 8, num74);
                                str43 = currentPacket.Substring((num73 + num74) + 10);
                                if ((message != "") && (str43 != ""))
                                {
                                    virtualUser user3 = userManager.getUser(str43);
                                    if (user3 == null)
                                    {
                                        this.sendData("BK" + stringManager.getString("modtool_actionfail") + "\r" + stringManager.getString("modtool_usernotfound"));
                                        return;
                                    }
                                    user3.sendData("B!" + message + Convert.ToChar(2));
                                    staffManager.addStaffMessage("alert", this.userID, user3.userID, message, note);
                                }
                                return;
                            }
                            if (str113 == "HI")
                            {
                                if (!rankManager.containsRight(this._Rank, "fuse_kick"))
                                {
                                    this.sendData("BK" + stringManager.getString("modtool_accesserror"));
                                    return;
                                }
                                num73 = Encoding.decodeB64(currentPacket.Substring(4, 2));
                                message = currentPacket.Substring(6, num73).Replace(Convert.ToChar(1).ToString(), " ");
                                num74 = Encoding.decodeB64(currentPacket.Substring(num73 + 6, 2));
                                note = currentPacket.Substring(num73 + 8, num74);
                                str43 = currentPacket.Substring((num73 + num74) + 10);
                                if ((message != "") && (str43 != ""))
                                {
                                    virtualUser user4 = userManager.getUser(str43);
                                    if (user4 == null)
                                    {
                                        this.sendData("BK" + stringManager.getString("modtool_actionfail") + "\r" + stringManager.getString("modtool_usernotfound"));
                                        return;
                                    }
                                    if ((user4.Room == null) || (user4.roomUser == null))
                                    {
                                        return;
                                    }
                                    if (user4._Rank < this._Rank)
                                    {
                                        user4.Room.removeUser(user4.roomUser.roomUID, true, message);
                                        staffManager.addStaffMessage("kick", this.userID, user4.userID, message, note);
                                        return;
                                    }
                                    this.sendData("BK" + stringManager.getString("modtool_actionfail") + "\r" + stringManager.getString("modtool_rankerror"));
                                }
                                return;
                            }
                            if (str113 == "HJ")
                            {
                                if (!rankManager.containsRight(this._Rank, "fuse_ban"))
                                {
                                    this.sendData("BK" + stringManager.getString("modtool_accesserror"));
                                    return;
                                }
                                int num75 = 0;
                                int hours = 0;
                                bool flag7 = currentPacket.Substring(currentPacket.Length - 1, 1) == "I";
                                num73 = Encoding.decodeB64(currentPacket.Substring(4, 2));
                                message = currentPacket.Substring(6, num73).Replace(Convert.ToChar(1).ToString(), " ");
                                num74 = Encoding.decodeB64(currentPacket.Substring(num73 + 6, 2));
                                note = currentPacket.Substring(num73 + 8, num74);
                                num75 = Encoding.decodeB64(currentPacket.Substring((num73 + num74) + 8, 2));
                                str43 = currentPacket.Substring((num73 + num74) + 10, num75);
                                hours = Encoding.decodeVL64(currentPacket.Substring(((num73 + num74) + num75) + 10));
                                if (((message != "") && (str43 != "")) && (hours != 0))
                                {
                                    string[] strArray19 = DB.runReadRow("SELECT id,rank,ipaddress_last FROM users WHERE name = '" + DB.Stripslash(str43) + "'");
                                    if (strArray19.Length == 0)
                                    {
                                        this.sendData("BK" + stringManager.getString("modtool_actionfail") + "\r" + stringManager.getString("modtool_usernotfound"));
                                        return;
                                    }
                                    if (byte.Parse(strArray19[1]) >= this._Rank)
                                    {
                                        this.sendData("BK" + stringManager.getString("modtool_actionfail") + "\r" + stringManager.getString("modtool_rankerror"));
                                        return;
                                    }
                                    int targetID = int.Parse(strArray19[0]);
                                    string str44 = "";
                                    staffManager.addStaffMessage("ban", this.userID, targetID, message, note);
                                    if (flag7 && rankManager.containsRight(this._Rank, "fuse_superban"))
                                    {
                                        userManager.setBan(strArray19[2], hours, message);
                                        str44 = userManager.generateBanReport(strArray19[2]);
                                    }
                                    else
                                    {
                                        userManager.setBan(targetID, hours, message);
                                        str44 = userManager.generateBanReport(targetID);
                                    }
                                    this.sendData("BK" + str44);
                                }
                                return;
                            }
                            if (str113 == "IH")
                            {
                                if (!rankManager.containsRight(this._Rank, "fuse_room_alert"))
                                {
                                    this.sendData("BK" + stringManager.getString("modtool_accesserror"));
                                    return;
                                }
                                if ((this.Room != null) && (this.roomUser != null))
                                {
                                    num73 = Encoding.decodeB64(currentPacket.Substring(4, 2));
                                    message = currentPacket.Substring(6, num73).Replace(Convert.ToChar(1).ToString(), " ");
                                    num74 = Encoding.decodeB64(currentPacket.Substring(num73 + 6, 2));
                                    note = currentPacket.Substring(num73 + 8, num74);
                                    if (!(message != ""))
                                    {
                                        return;
                                    }
                                    this.Room.sendData("B!" + message + Convert.ToChar(2));
                                    staffManager.addStaffMessage("ralert", this.userID, this._roomID, message, note);
                                }
                                return;
                            }
                            if (str113 == "II")
                            {
                                if (!rankManager.containsRight(this._Rank, "fuse_room_kick"))
                                {
                                    this.sendData("BK" + stringManager.getString("modtool_accesserror"));
                                    return;
                                }
                                if ((this.Room != null) && (this.roomUser != null))
                                {
                                    num73 = Encoding.decodeB64(currentPacket.Substring(4, 2));
                                    message = currentPacket.Substring(6, num73).Replace(Convert.ToChar(1).ToString(), " ");
                                    num74 = Encoding.decodeB64(currentPacket.Substring(num73 + 6, 2));
                                    note = currentPacket.Substring(num73 + 8, num74);
                                    if (!(message != ""))
                                    {
                                        return;
                                    }
                                    this.Room.kickUsers(this._Rank, message);
                                    staffManager.addStaffMessage("rkick", this.userID, this._roomID, message, note);
                                }
                                return;
                            }
                        }
                        return;
                    }
                    case "Cm":
                    {
                        string[] strArray20 = DB.runReadRow("SELECT id, date, message, picked_up FROM cms_help WHERE username = '" + this._Username + "' AND picked_up = '0'");
                        if (strArray20.Length != 0)
                        {
                            this.sendData(string.Concat(new object[] { "D\x007fI", strArray20[0], Convert.ToChar(2), strArray20[1], Convert.ToChar(2), strArray20[2], Convert.ToChar(2) }));
                            return;
                        }
                        this.sendData("D\x007fH");
                        return;
                    }
                    case "Cn":
                    {
                        int num78 = DB.runRead("SELECT id FROM cms_help WHERE username = '" + this._Username + "' AND picked_up = '0'", null);
                        DB.runQuery("DELETE FROM cms_help WHERE picked_up = '0' AND username = '" + this._Username + "' LIMIT 1");
                        this.sendData("D\x007fH");
                        userManager.sendToRank(Config.Minimum_CFH_Rank, true, string.Concat(new object[] { "BT", Encoding.encodeVL64(num78), Convert.ToChar(2), "IUser Deleted!", Convert.ToChar(2), "User Deleted!", Convert.ToChar(2), "User Deleted!", Convert.ToChar(2), Encoding.encodeVL64(0), Convert.ToChar(2), Convert.ToChar(2), "H", Convert.ToChar(2), Encoding.encodeVL64(0) }));
                        return;
                    }
                    case "AV":
                        if (!DB.checkExists("SELECT id FROM cms_help WHERE username = '" + this._Username + "' AND picked_up = '0'"))
                        {
                            int num79 = Encoding.decodeB64(currentPacket.Substring(2, 2));
                            if (num79 != 0)
                            {
                                string query = currentPacket.Substring(4, num79);
                                DB.runQuery(string.Concat(new object[] { "INSERT INTO cms_help (username,ip,message,date,picked_up,subject,roomid) VALUES ('", this._Username, "','", this.connectionSocket.RemoteEndPoint.ToString().Split(new char[] { char.Parse(":") })[0], "','", DB.Stripslash(query), "','", DateTime.Now, "','0','CFH message [hotel]','", this._roomID.ToString(), "')" }));
                                int num80 = DB.runRead("SELECT id FROM cms_help WHERE username = '" + this._Username + "' AND picked_up = '0'", null);
                                string str46 = DB.runRead("SELECT name FROM rooms WHERE id = '" + this._roomID + "'");
                                this.sendData("EAH");
                                userManager.sendToRank(Config.Minimum_CFH_Rank, true, string.Concat(new object[] { 
                                    "BT", Encoding.encodeVL64(num80), Convert.ToChar(2), "ISent: ", DateTime.Now, Convert.ToChar(2), this._Username, Convert.ToChar(2), query, Convert.ToChar(2), Encoding.encodeVL64(this._roomID), Convert.ToChar(2), str46, Convert.ToChar(2), "I", Convert.ToChar(2), 
                                    Encoding.encodeVL64(this._roomID)
                                 }));
                            }
                            return;
                        }
                        return;

                    case "CG":
                        if (rankManager.containsRight(this._Rank, "fuse_receive_calls_for_help"))
                        {
                            int num81 = Encoding.decodeVL64(currentPacket.Substring(4, Encoding.decodeB64(currentPacket.Substring(2, 2))));
                            string str47 = currentPacket.Substring(Encoding.decodeB64(currentPacket.Substring(2, 2)) + 6);
                            string str48 = DB.runRead("SELECT username FROM cms_help WHERE id = '" + num81 + "'");
                            if (str48 == null)
                            {
                                this.sendData("BK" + stringManager.getString("cfh_fail"));
                                return;
                            }
                            virtualUser user5 = userManager.getUser(userManager.getUserID(str48));
                            if (user5._isLoggedIn)
                            {
                                user5.sendData("DR" + str47 + Convert.ToChar(2));
                                DB.runQuery(string.Concat(new object[] { "UPDATE cms_help SET picked_up = '", this._Username, "' WHERE id = '", num81, "' LIMIT 1" }));
                            }
                            return;
                        }
                        return;

                    case "CF":
                        if (rankManager.containsRight(this._Rank, "fuse_receive_calls_for_help"))
                        {
                            int num83 = Encoding.decodeVL64(currentPacket.Substring(4, Encoding.decodeB64(currentPacket.Substring(2, 2))));
                            string[] strArray21 = DB.runReadRow("SELECT username,message,date,picked_up,roomid FROM cms_help WHERE id = '" + num83 + "'");
                            if (strArray21.Length != 0)
                            {
                                if (strArray21[3] == "1")
                                {
                                    this.sendData("BK" + stringManager.getString("cfh_picked_up"));
                                    return;
                                }
                                DB.runQuery("DELETE FROM cms_help WHERE id = '" + num83 + "' LIMIT 1");
                                userManager.sendToRank(Config.Minimum_CFH_Rank, true, string.Concat(new object[] { "BT", Encoding.encodeVL64(num83), Convert.ToChar(2), "HStaff Deleted!", Convert.ToChar(2), "Staff Deleted!", Convert.ToChar(2), "Staff Deleted!", Convert.ToChar(2), Encoding.encodeVL64(0), Convert.ToChar(2), Convert.ToChar(2), "H", Convert.ToChar(2), Encoding.encodeVL64(0) }));
                            }
                            return;
                        }
                        return;

                    case "@p":
                    {
                        int num84 = Encoding.decodeVL64(currentPacket.Substring(4));
                        if (DB.checkExists("SELECT id FROM cms_help WHERE id = '" + num84 + "'"))
                        {
                            string[] strArray22 = DB.runReadRow("SELECT picked_up,username,message,roomid FROM cms_help WHERE id = '" + num84 + "'");
                            string str49 = DB.runRead("SELECT name FROM rooms WHERE id = '" + strArray22[3] + "'");
                            if (strArray22[0] == "1")
                            {
                                this.sendData("BK" + stringManager.getString("cfh_picked_up"));
                            }
                            else
                            {
                                userManager.sendToRank(Config.Minimum_CFH_Rank, true, string.Concat(new object[] { 
                                    "BT", Encoding.encodeVL64(num84), Convert.ToChar(2), "IPicked up: ", DateTime.Now, Convert.ToChar(2), strArray22[1], Convert.ToChar(2), strArray22[2], Convert.ToChar(2), Encoding.encodeVL64(int.Parse(strArray22[3])), Convert.ToChar(2), str49, Convert.ToChar(2), "I", Convert.ToChar(2), 
                                    Encoding.encodeVL64(int.Parse(strArray22[3]))
                                 }));
                            }
                            DB.runQuery("UPDATE cms_help SET picked_up = '1' WHERE id = '" + num84 + "' LIMIT 1");
                            return;
                        }
                        this.sendData(stringManager.getString("cfh_deleted"));
                        return;
                    }
                    case "EC":
                        if (rankManager.containsRight(this._Rank, "fuse_receive_calls_for_help"))
                        {
                            int num85 = Encoding.decodeB64(currentPacket.Substring(2, 2));
                            int num87 = DB.runRead("SELECT roomid FROM cms_help WHERE id = '" + Encoding.decodeVL64(currentPacket.Substring(4, num85)) + "'", null);
                            if (num87 != 0)
                            {
                                if (roomManager.getRoom(num87).isPublicroom)
                                {
                                    this.sendData("D^I" + Encoding.encodeVL64(num87));
                                    return;
                                }
                                this.sendData("D^H" + Encoding.encodeVL64(num87));
                            }
                            return;
                        }
                        return;

                    case "AO":
                        if (((this.Room != null) && (this.roomUser != null)) && (!this.statusManager.containsStatus("sit") && !this.statusManager.containsStatus("lay")))
                        {
                            int num88 = int.Parse(currentPacket.Substring(2).Split(new char[] { ' ' })[0]);
                            int num89 = int.Parse(currentPacket.Split(new char[] { ' ' })[1]);
                            this.roomUser.Z1 = Rotation.Calculate(this.roomUser.X, this.roomUser.Y, num88, num89);
                            this.roomUser.Z2 = this.roomUser.Z1;
                            this.roomUser.Refresh();
                        }
                        return;

                    case "AK":
                        if (((this.Room != null) && (this.roomUser != null)) && !this.roomUser.walkLock)
                        {
                            int num90 = Encoding.decodeB64(currentPacket.Substring(2, 2));
                            int num91 = Encoding.decodeB64(currentPacket.Substring(4, 2));
                            if (this._alcohol > 5)
                            {
                                num90 += new Random().Next(-2, 2);
                            }
                            if (this.roomUser.SPECIAL_TELEPORTABLE)
                            {
                                this.roomUser.X = num90;
                                this.roomUser.Y = num91;
                                this.roomUser.goalX = -1;
                                this.Room.Refresh(this.roomUser);
                                this.refreshAppearance(false, false, true);
                                return;
                            }
                            this._hunger++;
                            if (this._hunger > 100)
                            {
                                this._hunger = 100;
                                this._health--;
                                if (this._health < 1)
                                {
                                    this.KillUser();
                                }
                            }
                            this.roomUser.goalX = num90;
                            this.roomUser.goalY = num91;
                        }
                        return;

                    case "As":
                        if (((this.Room != null) && (this.roomUser != null)) && !this.roomUser.walkDoor)
                        {
                            this.roomUser.walkDoor = true;
                            this.roomUser.goalX = this.Room.doorX;
                            this.roomUser.goalY = this.Room.doorY;
                        }
                        return;

                    case "At":
                        if ((this.Room != null) || ((this.roomUser != null) && this.Room.hasSwimmingPool))
                        {
                            virtualRoom.squareTrigger trigger = this.Room.getTrigger(this.roomUser.X, this.roomUser.Y);
                            if (!(trigger.Object == "curtains1") && !(trigger.Object == "curtains2"))
                            {
                                return;
                            }
                            string str50 = DB.Stripslash(currentPacket.Substring(2));
                            this.roomUser.SwimOutfit = str50;
                            this.Room.sendData(@"@\" + this.roomUser.detailsString);
                            this.Room.sendSpecialCast(trigger.Object, "open");
                            this.roomUser.walkLock = false;
                            this.roomUser.goalX = trigger.goalX;
                            this.roomUser.goalY = trigger.goalY;
                            DB.runQuery(string.Concat(new object[] { "UPDATE users SET figure_swim = '", str50, "' WHERE id = '", this.userID, "' LIMIT 1" }));
                        }
                        return;

                    case "B^":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            string str51 = currentPacket.Split(new char[] { '^' })[1];
                            int num92 = Encoding.decodeB64(str51.Substring(1, 2));
                            string str52 = DB.Stripslash(str51.Substring(3, num92));
                            int num93 = num92;
                            num92 = Encoding.decodeB64(str51.Substring(4 + num93, 2));
                            string str53 = DB.Stripslash(str51.Substring(6 + num93, num92));
                            num93 += num92;
                            num92 = Encoding.decodeB64(str51.Substring(7 + num93, 2));
                            string str54 = DB.Stripslash(str51.Substring(9 + num93, num92));
                            num93 += num92;
                            num92 = Encoding.decodeB64(str51.Substring(11 + num93, 2));
                            string str55 = DB.Stripslash(str51.Substring(13 + num93, num92));
                            num93 += num92;
                            num92 = Encoding.decodeB64(str51.Substring(15 + num93, 2));
                            string str56 = DB.Stripslash(str51.Substring(0x11 + num93, num92));
                            string str57 = "Cd" + this.roomUser.userID + Convert.ToChar(2);
                            int num94 = 0;
                            DB.runQuery("UPDATE users_badges SET iscurrent = '0' WHERE userid = '" + this.roomUser.userID + "'");
                            if (str52 != "")
                            {
                                DB.runQuery(string.Concat(new object[] { "UPDATE users_badges SET iscurrent = '1' WHERE userid = '", this.roomUser.userID, "' AND badgeid = '", str52, "'" }));
                                num94++;
                            }
                            if (str53 != "")
                            {
                                DB.runQuery(string.Concat(new object[] { "UPDATE users_badges SET iscurrent = '2' WHERE userid = '", this.roomUser.userID, "' AND badgeid = '", str53, "'" }));
                                num94++;
                            }
                            if (str54 != "")
                            {
                                DB.runQuery(string.Concat(new object[] { "UPDATE users_badges SET iscurrent = '3' WHERE userid = '", this.roomUser.userID, "' AND badgeid = '", str54, "'" }));
                                num94++;
                            }
                            if (str55 != "")
                            {
                                DB.runQuery(string.Concat(new object[] { "UPDATE users_badges SET iscurrent = '4' WHERE userid = '", this.roomUser.userID, "' AND badgeid = '", str55, "'" }));
                                num94++;
                            }
                            if (str56 != "")
                            {
                                DB.runQuery(string.Concat(new object[] { "UPDATE users_badges SET iscurrent = '5' WHERE userid = '", this.roomUser.userID, "' AND badgeid = '", str56, "'" }));
                                num94++;
                            }
                            string str58 = Encoding.encodeVL64(num94);
                            str57 = str57 + str58 + str58;
                            if (str52 != "")
                            {
                                num94--;
                                str58 = Encoding.encodeVL64(num94);
                                obj2 = str57;
                                str57 = string.Concat(new object[] { obj2, str52, Convert.ToChar(2), str58 });
                            }
                            if (str53 != "")
                            {
                                num94--;
                                str58 = Encoding.encodeVL64(num94);
                                obj2 = str57;
                                str57 = string.Concat(new object[] { obj2, str53, Convert.ToChar(2), str58 });
                            }
                            if (str54 != "")
                            {
                                num94--;
                                str58 = Encoding.encodeVL64(num94);
                                obj2 = str57;
                                str57 = string.Concat(new object[] { obj2, str54, Convert.ToChar(2), str58 });
                            }
                            if (str55 != "")
                            {
                                num94--;
                                str58 = Encoding.encodeVL64(num94);
                                obj2 = str57;
                                str57 = string.Concat(new object[] { obj2, str55, Convert.ToChar(2), str58 });
                            }
                            if (str56 != "")
                            {
                                num94--;
                                str58 = Encoding.encodeVL64(num94);
                                str57 = str57 + str56 + Convert.ToChar(2);
                            }
                            this.Room.sendData(str57);
                        }
                        return;

                    case "DG":
                    {
                        int num95 = Encoding.decodeVL64(currentPacket.Substring(2));
                        string[] strArray23 = DB.runReadColumn("SELECT tag FROM cms_tags WHERE ownerid = '" + num95 + "'", 20);
                        StringBuilder builder8 = new StringBuilder(Encoding.encodeVL64(num95) + Encoding.encodeVL64(strArray23.Length));
                        for (int num96 = 0; num96 < strArray23.Length; num96++)
                        {
                            builder8.Append(strArray23[num96] + Convert.ToChar(2));
                        }
                        this.sendData("E^" + builder8.ToString());
                        return;
                    }
                    case "Es":
                        this.Room.sendData("Fx" + currentPacket.Substring(2));
                        return;

                    case "Cg":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            int num97 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (!DB.checkExists("SELECT id FROM groups_details WHERE id = '" + num97 + "'"))
                            {
                                return;
                            }
                            string str59 = DB.runRead("SELECT name FROM groups_details WHERE id = '" + num97 + "'");
                            string str60 = DB.runRead("SELECT description FROM groups_details WHERE id = '" + num97 + "'");
                            int num98 = DB.runRead("SELECT roomid FROM groups_details WHERE id = '" + num97 + "'", null);
                            string str61 = "";
                            if (num98 <= 0)
                            {
                                num98 = -1;
                            }
                            else
                            {
                                str61 = DB.runRead("SELECT name FROM rooms WHERE id = '" + num98 + "'");
                            }
                            this.sendData(string.Concat(new object[] { "Dw", Encoding.encodeVL64(num97), str59, Convert.ToChar(2), str60, Convert.ToChar(2), Encoding.encodeVL64(num98), str61, Convert.ToChar(2) }));
                        }
                        return;

                    case "AX":
                        if (this.statusManager != null)
                        {
                            string str62 = currentPacket.Substring(2);
                            if (!(str62 == "CarryItem"))
                            {
                                if (str62 == "Dance")
                                {
                                    this.statusManager.removeStatus("dance");
                                    this.statusManager.Refresh();
                                }
                                return;
                            }
                            this.statusManager.dropCarrydItem();
                        }
                        return;

                    case "A^":
                        if (((this.Room != null) && (this.roomUser != null)) && !this.statusManager.containsStatus("wave"))
                        {
                            this.statusManager.removeStatus("dance");
                            this.statusManager.handleStatus("wave", "", Config.Statuses_Wave_waveDuration);
                        }
                        return;

                    case "A]":
                        if (((this.Room != null) && (this.roomUser != null)) && (!this.statusManager.containsStatus("sit") && !this.statusManager.containsStatus("lay")))
                        {
                            this.statusManager.dropCarrydItem();
                            if (currentPacket.Length != 2)
                            {
                                if (!rankManager.containsRight(this._Rank, "fuse_use_club_dance"))
                                {
                                    return;
                                }
                                int num99 = Encoding.decodeVL64(currentPacket.Substring(2));
                                if ((num99 < 0) || (num99 > 4))
                                {
                                    return;
                                }
                                this.statusManager.addStatus("dance", num99.ToString());
                            }
                            else
                            {
                                this.statusManager.addStatus("dance", "");
                            }
                            this.statusManager.Refresh();
                        }
                        return;

                    case "AP":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            string str63 = currentPacket.Substring(2);
                            if (!this.statusManager.containsStatus("lay") && !str63.Contains("/"))
                            {
                                try
                                {
                                    int num100 = int.Parse(str63);
                                    if ((num100 < 1) || (num100 > 0x24))
                                    {
                                        return;
                                    }
                                }
                                catch
                                {
                                    if ((!this._inPublicroom && (str63 != "Water")) && ((str63 != "Milk") && (str63 != "Juice")))
                                    {
                                        return;
                                    }
                                }
                                this.statusManager.carryItem(str63);
                                return;
                            }
                        }
                        return;

                    case "Ah":
                        if (((this.Room != null) && (this.roomUser != null)) && (!this.statusManager.containsStatus("sit") && !this.statusManager.containsStatus("lay")))
                        {
                            if (currentPacket.Length != 2)
                            {
                                string str64 = currentPacket.Substring(2);
                                this.statusManager.handleStatus("sign", str64, Config.Statuses_Wave_waveDuration);
                            }
                            else
                            {
                                this.statusManager.addStatus("sign", "");
                            }
                            this.statusManager.Refresh();
                        }
                        return;

                    case "Cl":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            int startIndex = 2;
                            int num102 = Encoding.decodeVL64(currentPacket.Substring(startIndex));
                            if (!DB.checkExists(string.Concat(new object[] { "SELECT aid FROM poll_results WHERE uid = '", this.userID, "' AND pid = '", num102, "'" })))
                            {
                                startIndex += Encoding.encodeVL64(num102).Length;
                                int num103 = Encoding.decodeVL64(currentPacket.Substring(startIndex));
                                startIndex += Encoding.encodeVL64(num103).Length;
                                if (DB.checkExists("SELECT type FROM poll_questions WHERE qid = '" + num103 + "' AND type = '3'"))
                                {
                                    int num104 = Encoding.decodeB64(currentPacket.Substring(startIndex, 2));
                                    startIndex += 2;
                                    string str65 = DB.Stripslash(currentPacket.Substring(startIndex, num104));
                                    DB.runQuery(string.Concat(new object[] { "INSERT INTO poll_results (pid,qid,aid,answers,uid) VALUES ('", num102, "','", num103, "','0','", str65, "','", this.userID, "')" }));
                                    return;
                                }
                                int num105 = Encoding.decodeVL64(currentPacket.Substring(startIndex));
                                startIndex += Encoding.encodeVL64(num105).Length;
                                int[] numArray10 = new int[num105];
                                for (int num106 = 0; num106 < num105; num106++)
                                {
                                    numArray10[num106] = Encoding.decodeVL64(currentPacket.Substring(startIndex));
                                    startIndex += Encoding.encodeVL64(numArray10[num106]).Length;
                                }
                                foreach (int num107 in numArray10)
                                {
                                    DB.runQuery(string.Concat(new object[] { "INSERT INTO poll_results (pid,qid,aid,answers,uid) VALUES ('", num102, "','", num103, "','", num107, "',' ','", this.userID, "')" }));
                                }
                            }
                            return;
                        }
                        return;

                    case "@t":
                    case "@w":
                    {
                        string str66 = currentPacket.Substring(4);
                        if (!(str66.Substring(0, 1) == ":") || !this.isSpeechCommand(str66.Substring(1)))
                        {
                            if (((!this._isMuted && (this.Room != null)) && (this.roomUser != null)) || ((this.Room == null) && (this.gamePlayer != null)))
                            {
                                userManager.addChatMessage(this._Username, this._roomID, str66);
                                str66 = stringManager.filterSwearwords(str66);
                                if (this._alcohol > 5)
                                {
                                    str66 = stringManager.DrunkenTalk(str66);
                                }
                                if (currentPacket.Substring(1, 1) == "w")
                                {
                                    if (this.gamePlayer == null)
                                    {
                                        this._hunger++;
                                        if (this._hunger > 100)
                                        {
                                            this._hunger = 100;
                                            this._health--;
                                            if (this._health < 1)
                                            {
                                                this.KillUser();
                                            }
                                        }
                                        this.Room.sendShout(this.roomUser, str66);
                                    }
                                    else
                                    {
                                        this.gamePlayer.Game.sendData(string.Concat(new object[] { "Ei", Encoding.encodeVL64(this.gamePlayer.roomUID), "H", Convert.ToChar(1), "@Z", Encoding.encodeVL64(this.gamePlayer.roomUID), str66, Convert.ToChar(2) }));
                                    }
                                }
                                else if (this.gamePlayer == null)
                                {
                                    this._hunger++;
                                    if (this._hunger > 100)
                                    {
                                        this._hunger = 100;
                                        this._health--;
                                        if (this._health < 1)
                                        {
                                            this.KillUser();
                                        }
                                    }
                                    this.Room.sendSaying(this.roomUser, str66);
                                }
                                else
                                {
                                    this.gamePlayer.Game.sendData(string.Concat(new object[] { "Ei", Encoding.encodeVL64(this.gamePlayer.roomUID), "H", Convert.ToChar(1), "@X", Encoding.encodeVL64(this.gamePlayer.roomUID), str66, Convert.ToChar(2) }));
                                }
                                this.statusManager.handleStatus("talk", "", str66.Length * 150);
                            }
                        }
                        else if (this.roomUser.isTyping)
                        {
                            this.Room.sendData("Ei" + Encoding.encodeVL64(this.roomUser.roomUID) + "H");
                            this.roomUser.isTyping = false;
                        }
                        Thread.Sleep(200);
                        return;
                    }
                    case "@x":
                    {
                        string receiver = currentPacket.Substring(4).Split(new char[] { ' ' })[0];
                        string str68 = currentPacket.Substring(receiver.Length + 5);
                        if ((!this._isMuted && (this.Room != null)) && (this.roomUser != null))
                        {
                            if ((!(receiver == "") || !(str68.Substring(0, 1) == ":")) || !this.isSpeechCommand(str68.Substring(1)))
                            {
                                userManager.addChatMessage(this._Username, this._roomID, str68);
                                str68 = stringManager.filterSwearwords(str68);
                                this.Room.sendWhisper(this.roomUser, receiver, str68);
                            }
                            else if (this.roomUser.isTyping)
                            {
                                this.Room.sendData("Ei" + Encoding.encodeVL64(this.roomUser.roomUID) + "H");
                                this.roomUser.isTyping = false;
                            }
                            this.statusManager.handleStatus("talk", "", str68.Length * 150);
                        }
                        return;
                    }
                    case "D}":
                        if ((!this._isMuted && (this.Room != null)) && (this.roomUser != null))
                        {
                            this.Room.sendData("Ei" + Encoding.encodeVL64(this.roomUser.roomUID) + "I");
                            this.roomUser.isTyping = true;
                        }
                        return;

                    case "D~":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            this.Room.sendData("Ei" + Encoding.encodeVL64(this.roomUser.roomUID) + "H");
                            this.roomUser.isTyping = false;
                        }
                        return;

                    case "A`":
                        if (((this.Room != null) && (this.roomUser != null)) && (!this._inPublicroom && this._isOwner))
                        {
                            string str69 = currentPacket.Substring(2);
                            if (userManager.containsUser(str69))
                            {
                                virtualUser user6 = userManager.getUser(str69);
                                if (((user6._roomID != this._roomID) || user6._hasRights) || user6._isOwner)
                                {
                                    return;
                                }
                                DB.runQuery(string.Concat(new object[] { "INSERT INTO room_rights(roomid,userid) VALUES ('", this._roomID, "','", user6.userID, "')" }));
                                user6._hasRights = true;
                                user6.statusManager.addStatus("flatctrl", "onlyfurniture");
                                user6.roomUser.Refresh();
                                user6.sendData("@j");
                            }
                            return;
                        }
                        return;

                    case "Aa":
                        if (((this.Room != null) && (this.roomUser != null)) && (!this._inPublicroom && this._isOwner))
                        {
                            string str70 = currentPacket.Substring(2);
                            if (userManager.containsUser(str70))
                            {
                                virtualUser user7 = userManager.getUser(str70);
                                if (((user7._roomID != this._roomID) || !user7._hasRights) || user7._isOwner)
                                {
                                    return;
                                }
                                DB.runQuery(string.Concat(new object[] { "DELETE FROM room_rights WHERE roomid = '", this._roomID, "' AND userid = '", user7.userID, "' LIMIT 1" }));
                                user7._hasRights = false;
                                user7.statusManager.removeStatus("flatctrl");
                                user7.roomUser.Refresh();
                                user7.sendData("@k");
                            }
                            return;
                        }
                        return;

                    case "A_":
                        if (((this.Room != null) && (this.roomUser != null)) && (!this._inPublicroom && this._hasRights))
                        {
                            string str71 = currentPacket.Substring(2);
                            if (userManager.containsUser(str71))
                            {
                                virtualUser user8 = userManager.getUser(str71);
                                if (user8._roomID != this._roomID)
                                {
                                    return;
                                }
                                if (user8._isOwner && ((user8._Rank > this._Rank) || rankManager.containsRight(user8._Rank, "fuse_any_room_controller")))
                                {
                                    return;
                                }
                                user8.roomUser.walkLock = true;
                                user8.roomUser.walkDoor = true;
                                user8.roomUser.goalX = this.Room.doorX;
                                user8.roomUser.goalY = this.Room.doorY;
                            }
                            return;
                        }
                        return;

                    case "E@":
                        if ((this._hasRights && !this._inPublicroom) && ((this.Room != null) && (this.roomUser != null)))
                        {
                            string str72 = currentPacket.Substring(2);
                            if (userManager.containsUser(str72))
                            {
                                virtualUser user9 = userManager.getUser(str72);
                                if (user9._roomID != this._roomID)
                                {
                                    return;
                                }
                                if (user9._isOwner && ((user9._Rank > this._Rank) || rankManager.containsRight(user9._Rank, "fuse_any_room_controller")))
                                {
                                    return;
                                }
                                string str73 = DateTime.Now.AddMinutes((double) Config.Rooms_roomBan_banDuration).ToString();
                                DB.runQuery(string.Concat(new object[] { "INSERT INTO room_bans (roomid,userid,ban_expire) VALUES ('", this._roomID, "','", user9.userID, "','", str73, "')" }));
                                user9.roomUser.walkLock = true;
                                user9.roomUser.walkDoor = true;
                                user9.roomUser.goalX = this.Room.doorX;
                                user9.roomUser.goalY = this.Room.doorY;
                            }
                            return;
                        }
                        return;

                    case "DE":
                        if ((!this._inPublicroom && (this.Room != null)) && (this.roomUser != null))
                        {
                            int num108 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (((num108 == 1) || (num108 == -1)) && !DB.checkExists(string.Concat(new object[] { "SELECT userid FROM room_votes WHERE userid = '", this.userID, "' AND roomid = '", this._roomID, "'" })))
                            {
                                DB.runQuery(string.Concat(new object[] { "INSERT INTO room_votes (userid,roomid,vote) VALUES ('", this.userID, "','", this._roomID, "','", num108, "')" }));
                                int voteAmount = DB.runRead("SELECT SUM(vote) FROM room_votes WHERE roomid = '" + this._roomID + "'", null);
                                if (voteAmount < 0)
                                {
                                    voteAmount = 0;
                                }
                                this.roomUser.hasVoted = true;
                                this.Room.sendNewVoteAmount(voteAmount);
                            }
                            return;
                        }
                        return;

                    case "Ae":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            this.sendData("A~" + catalogueManager.getPageIndex(this._Rank));
                        }
                        return;

                    case "Af":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            Encoding.decodeVL64(currentPacket.Substring(2, 3));
                            string pageName = currentPacket.Split(new char[] { '/' })[1];
                            this.sendData("A\x007f" + catalogueManager.getPage(pageName, this._Rank) + "H");
                        }
                        return;

                    case "Ad":
                    {
                        string[] strArray24 = currentPacket.Split(new char[] { Convert.ToChar(13) });
                        string str76 = strArray24[1];
                        string str77 = strArray24[3];
                        int num110 = DB.runRead(string.Concat(new object[] { "SELECT indexid FROM catalogue_pages WHERE indexname = '", DB.Stripslash(str76), "' AND minrank <= ", this._Rank }), null);
                        int templateID = DB.runRead("SELECT tid FROM catalogue_items WHERE name_cct = '" + DB.Stripslash(str77) + "'", null);
                        int num112 = DB.runRead(string.Concat(new object[] { "SELECT catalogue_cost FROM catalogue_items WHERE catalogue_id_page = '", num110, "' AND tid = '", templateID, "'" }), null);
                        if ((num112 != 0) && (num112 <= this._Credits))
                        {
                            int receiverID = this.userID;
                            int presentBoxID = 0;
                            int num115 = 0;
                            if (strArray24[5] == "1")
                            {
                                string str78 = strArray24[6];
                                if (str78 != this._Username)
                                {
                                    int num116 = DB.runRead("SELECT id FROM users WHERE name = '" + DB.Stripslash(str78) + "'", null);
                                    if (num116 <= 0)
                                    {
                                        this.sendData("AL" + str78);
                                        return;
                                    }
                                    receiverID = num116;
                                }
                                string str80 = DB.runRead("SELECT tid FROM catalogue_items WHERE name_cct = '" + ("present_gen" + new Random().Next(1, 7)) + "'");
                                string str81 = DB.Stripslash(stringManager.filterSwearwords(strArray24[7]));
                                DB.runQuery(string.Concat(new object[] { "INSERT INTO furniture(tid,ownerid,var) VALUES ('", str80, "','", receiverID, "','!", str81, "')" }));
                                presentBoxID = catalogueManager.lastItemID;
                                num115 = -1;
                            }
                            this._Credits -= num112;
                            this.sendData("@F" + this._Credits);
                            DB.runQuery(string.Concat(new object[] { "UPDATE users SET credits = '", this._Credits, "' WHERE id = '", this.userID, "' LIMIT 1" }));
                            if (stringManager.getStringPart(str77, 0, 4) == "deal")
                            {
                                int num117 = int.Parse(str77.Substring(4));
                                int[] numArray11 = DB.runReadColumn("SELECT tid FROM catalogue_deals WHERE id = '" + num117 + "'", 0, null);
                                int[] numArray12 = DB.runReadColumn("SELECT amount FROM catalogue_deals WHERE id = '" + num117 + "'", 0, null);
                                for (int num118 = 0; num118 < numArray11.Length; num118++)
                                {
                                    for (int num119 = 1; num119 <= numArray12[num118]; num119++)
                                    {
                                        DB.runQuery(string.Concat(new object[] { "INSERT INTO furniture(tid,ownerid,roomid) VALUES ('", numArray11[num118], "','", receiverID, "','", num115, "')" }));
                                        catalogueManager.handlePurchase(numArray11[num118], receiverID, num115, 0, presentBoxID, "");
                                    }
                                }
                            }
                            else
                            {
                                DB.runQuery(string.Concat(new object[] { "INSERT INTO furniture(tid,ownerid,roomid) VALUES ('", templateID, "','", receiverID, "','", num115, "')" }));
                                if ((catalogueManager.getTemplate(templateID).Sprite == "wallpaper") || (catalogueManager.getTemplate(templateID).Sprite == "floor"))
                                {
                                    int decorID = int.Parse(strArray24[4]);
                                    catalogueManager.handlePurchase(templateID, receiverID, 0, decorID, presentBoxID, "");
                                }
                                else if (catalogueManager.getTemplate(templateID).Sprite == "landscape")
                                {
                                    string landscapeID = strArray24[4];
                                    catalogueManager.handlePurchase(templateID, receiverID, 0, 0, presentBoxID, landscapeID);
                                }
                                else if (stringManager.getStringPart(str77, 0, 11) != "prizetrophy")
                                {
                                    if (stringManager.getStringPart(str77, 0, 11) == "greektrophy")
                                    {
                                        DB.Stripslash(stringManager.filterSwearwords(strArray24[4]));
                                        string str83 = this._Username + "\t" + DateTime.Today.ToShortDateString() + "\t" + strArray24[4];
                                        DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET var = '", str83, "' WHERE id = '", catalogueManager.lastItemID, "' LIMIT 1" }));
                                    }
                                    else
                                    {
                                        catalogueManager.handlePurchase(templateID, receiverID, num115, 0, presentBoxID, "");
                                    }
                                }
                            }
                            if (receiverID == this.userID)
                            {
                                this.refreshHand("last");
                                return;
                            }
                            if (userManager.containsUser(receiverID))
                            {
                                userManager.getUser(receiverID).refreshHand("last");
                            }
                            return;
                        }
                        this.sendData("AD");
                        return;
                    }
                    case "Ai":
                    {
                        string str84 = currentPacket.Substring(2);
                        int num121 = Encoding.decodeVL64(str84.Substring(0, 3));
                        string str85 = str84.Substring(3);
                        int num122 = 0;
                        int num123 = 0;
                        if (num121 == 1)
                        {
                            num122 = 2;
                            num123 = 1;
                        }
                        else if (num121 == 2)
                        {
                            num122 = 20;
                            num123 = 6;
                        }
                        else
                        {
                            return;
                        }
                        if (num123 > this._Credits)
                        {
                            this.sendData("AD");
                        }
                        else
                        {
                            int num124 = DB.runRead("SELECT id FROM users WHERE name = '" + DB.Stripslash(str85) + "'", null);
                            if (num124 <= 0)
                            {
                                this.sendData("AL" + str85);
                            }
                            else
                            {
                                this._Credits -= num123;
                                this.sendData("@F" + this._Credits);
                                DB.runQuery(string.Concat(new object[] { "UPDATE users SET credits = '", this._Credits, "' WHERE id = '", this.userID, "' LIMIT 1" }));
                                DB.runQuery(string.Concat(new object[] { "UPDATE users SET tickets = tickets+", num122, " WHERE id = '", num124, "' LIMIT 1" }));
                                if (userManager.containsUser(num124))
                                {
                                    virtualUser user10 = userManager.getUser(num124);
                                    user10._Tickets += num122;
                                    if (num124 == this.userID)
                                    {
                                        user10.refreshValueables(false, true);
                                    }
                                    else
                                    {
                                        user10.refreshValueables(true, true);
                                    }
                                }
                            }
                        }
                        return;
                    }
                    case "Ca":
                        if ((Config.enableRecycler && (this.Room != null)) && !recyclerManager.sessionExists(this.userID))
                        {
                            int itemCount = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (recyclerManager.rewardExists(itemCount))
                            {
                                recyclerManager.createSession(this.userID, itemCount);
                                currentPacket = currentPacket.Substring(Encoding.encodeVL64(itemCount).ToString().Length + 2);
                                for (int num126 = 0; num126 < itemCount; num126++)
                                {
                                    int num127 = Encoding.decodeVL64(currentPacket);
                                    if (DB.checkExists("SELECT id FROM furniture WHERE ownerid = '" + this.userID + "' AND roomid = '0'"))
                                    {
                                        DB.runQuery("UPDATE furniture SET roomid = '-2' WHERE id = '" + num127 + "' LIMIT 1");
                                        currentPacket = currentPacket.Substring(Encoding.encodeVL64(num127).ToString().Length);
                                    }
                                    else
                                    {
                                        recyclerManager.dropSession(this.userID, true);
                                        this.sendData("DpH");
                                        return;
                                    }
                                }
                                this.sendData("Dp" + recyclerManager.sessionString(this.userID));
                                this.refreshHand("update");
                            }
                            return;
                        }
                        return;

                    case "Cb":
                        if (!Config.enableRecycler || ((this.Room != null) && recyclerManager.sessionExists(this.userID)))
                        {
                            bool dropItems = currentPacket.Substring(2) == "I";
                            if (dropItems && recyclerManager.sessionReady(this.userID))
                            {
                                recyclerManager.rewardSession(this.userID);
                            }
                            recyclerManager.dropSession(this.userID, dropItems);
                            this.sendData("Dp" + recyclerManager.sessionString(this.userID));
                            if (dropItems)
                            {
                                this.refreshHand("last");
                                return;
                            }
                            this.refreshHand("new");
                        }
                        return;

                    case "AA":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            string mode = currentPacket.Substring(2);
                            this.refreshHand(mode);
                            return;
                        }
                        return;

                    case "LB":
                        if ((this.Room != null) && (this.roomUser != null))
                        {
                            string str87 = currentPacket.Substring(2);
                            this.refreshHand(str87);
                            return;
                        }
                        return;

                    case "AB":
                        if ((this._hasRights && !this._inPublicroom) && ((this.Room != null) && (this.roomUser != null)))
                        {
                            int num128 = int.Parse(currentPacket.Split(new char[] { '/' })[1]);
                            string str88 = currentPacket.Substring(2).Split(new char[] { '/' })[0];
                            switch (str88)
                            {
                                case "wallpaper":
                                case "floor":
                                case "landscape":
                                {
                                    if (catalogueManager.getTemplate(DB.runRead(string.Concat(new object[] { "SELECT tid FROM furniture WHERE id = '", num128, "' AND ownerid = '", this.userID, "' AND roomid = '0'" }), null)).Sprite != str88)
                                    {
                                        return;
                                    }
                                    string str89 = DB.runRead("SELECT var FROM furniture WHERE id = '" + num128 + "'");
                                    this.Room.sendData("@n" + str88 + "/" + str89);
                                    DB.runQuery(string.Concat(new object[] { "UPDATE rooms SET ", str88, " = '", str89, "' WHERE id = '", this._roomID, "' LIMIT 1" }));
                                    DB.runQuery("DELETE FROM furniture WHERE id = '" + num128 + "' LIMIT 1");
                                    break;
                                }
                            }
                            return;
                        }
                        return;

                    case "AZ":
                        if ((this._hasRights && !this._inPublicroom) && ((this.Room != null) && (this.roomUser != null)))
                        {
                            int itemID = int.Parse(currentPacket.Split(new char[] { ' ' })[0].Substring(2));
                            int num131 = DB.runRead(string.Concat(new object[] { "SELECT tid FROM furniture WHERE id = '", itemID, "' AND ownerid = '", this.userID, "' AND roomid = '0'" }), null);
                            if (num131 != 0)
                            {
                                if (catalogueManager.getTemplate(num131).typeID == 0)
                                {
                                    string wallPosition = currentPacket.Substring(itemID.ToString().Length + 3);
                                    string str91 = catalogueManager.wallPositionOK(wallPosition);
                                    if (str91 == wallPosition)
                                    {
                                        string str92 = DB.runRead("SELECT var FROM furniture WHERE id = '" + itemID + "'");
                                        if (stringManager.getStringPart(catalogueManager.getTemplate(num131).Sprite, 0, 7) == "post.it")
                                        {
                                            if (int.Parse(str92) > 1)
                                            {
                                                DB.runQuery("UPDATE furniture SET var = var - 1 WHERE id = '" + itemID + "' LIMIT 1");
                                            }
                                            else
                                            {
                                                DB.runQuery("DELETE FROM furniture WHERE id = '" + itemID + "' LIMIT 1");
                                            }
                                            DB.runQuery(string.Concat(new object[] { "INSERT INTO furniture(tid,ownerid) VALUES ('", num131, "','", this.userID, "')" }));
                                            itemID = catalogueManager.lastItemID;
                                            DB.runQuery("INSERT INTO furniture_stickies(id) VALUES ('" + itemID + "')");
                                            str92 = "FFFF33";
                                            DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET var = '", str92, "' WHERE id = '", itemID, "' LIMIT 1" }));
                                        }
                                        this.Room.wallItemManager.addItem(itemID, num131, str91, str92, true);
                                    }
                                    return;
                                }
                                string[] strArray25 = currentPacket.Split(new char[] { ' ' });
                                int num132 = int.Parse(strArray25[1]);
                                int num133 = int.Parse(strArray25[2]);
                                byte z = byte.Parse(strArray25[3]);
                                byte typeID = catalogueManager.getTemplate(num131).typeID;
                                this.Room.floorItemManager.placeItem(itemID, num131, num132, num133, typeID, z);
                            }
                            return;
                        }
                        return;

                    case "AC":
                        if ((this._isOwner && !this._inPublicroom) && ((this.Room != null) && (this.roomUser != null)))
                        {
                            int num136 = int.Parse(currentPacket.Split(new char[] { ' ' })[2]);
                            if (this.Room.floorItemManager.containsItem(num136))
                            {
                                this.Room.floorItemManager.removeItem(num136, this.userID);
                            }
                            else if (this.Room.wallItemManager.containsItem(num136) && (stringManager.getStringPart(this.Room.wallItemManager.getItem(num136).Sprite, 0, 7) != "post.it"))
                            {
                                this.Room.wallItemManager.removeItem(num136, this.userID);
                            }
                            else
                            {
                                return;
                            }
                            this.refreshHand("update");
                            return;
                        }
                        return;

                    case "AI":
                        if ((this._hasRights && !this._inPublicroom) && ((this.Room != null) && (this.roomUser != null)))
                        {
                            int num137 = int.Parse(currentPacket.Split(new char[] { ' ' })[0].Substring(2));
                            if (this.Room.floorItemManager.containsItem(num137))
                            {
                                string[] strArray26 = currentPacket.Split(new char[] { ' ' });
                                int num138 = int.Parse(strArray26[1]);
                                int num139 = int.Parse(strArray26[2]);
                                byte num140 = byte.Parse(strArray26[3]);
                                this.Room.floorItemManager.relocateItem(num137, num138, num139, num140);
                            }
                            return;
                        }
                        return;

                    case "CV":
                        if ((!this._inPublicroom && (this.Room != null)) && ((this.roomUser != null) && this._isOwner))
                        {
                            int num141 = int.Parse(currentPacket.Substring(4, Encoding.decodeB64(currentPacket.Substring(2, 2))));
                            int toStatus = Encoding.decodeVL64(currentPacket.Substring(num141.ToString().Length + 4));
                            this.Room.wallItemManager.toggleItemStatus(num141, toStatus);
                            return;
                        }
                        return;

                    case "AJ":
                        try
                        {
                            int num143 = int.Parse(currentPacket.Substring(4, Encoding.decodeB64(currentPacket.Substring(2, 2))));
                            if (this.Room.floorItemManager.containsItem(num143))
                            {
                                string sprite = this.Room.floorItemManager.getItem(num143).Sprite;
                                if (((sprite == "party_floor") || (sprite == "xmas08_icerug")) && !this._isOwner)
                                {
                                    return;
                                }
                            }
                            string str94 = DB.Stripslash(currentPacket.Substring(num143.ToString().Length + 6));
                            this.Room.floorItemManager.toggleItemStatus(num143, str94, this._hasRights);
                        }
                        catch
                        {
                        }
                        return;

                    case "AN":
                        if ((this._isOwner && !this._inPublicroom) && ((this.Room != null) && (this.roomUser != null)))
                        {
                            int num144 = int.Parse(currentPacket.Substring(2));
                            if (!this.Room.floorItemManager.containsItem(num144))
                            {
                                return;
                            }
                            int[] numArray13 = DB.runReadColumn("SELECT itemid FROM furniture_presents WHERE id = '" + num144 + "'", 0, null);
                            if (numArray13.Length > 0)
                            {
                                for (int num145 = 0; num145 < numArray13.Length; num145++)
                                {
                                    DB.runQuery("UPDATE furniture SET roomid = '0' WHERE id = '" + numArray13[num145] + "' LIMIT 1");
                                }
                                this.Room.floorItemManager.removeItem(num144, 0);
                                catalogueManager.itemTemplate template = catalogueManager.getTemplate(DB.runRead("SELECT tid FROM furniture WHERE id = '" + numArray13[numArray13.Length - 1] + "'", null));
                                if (template.typeID > 0)
                                {
                                    this.sendData(string.Concat(new object[] { "BA", template.Sprite, Convert.ToChar(13), template.Sprite, Convert.ToChar(13), template.Length, Convert.ToChar(30), template.Width, Convert.ToChar(30), template.Colour }));
                                }
                                else
                                {
                                    this.sendData(string.Concat(new object[] { "BA", template.Sprite, Convert.ToChar(13), template.Sprite, " ", template.Colour, Convert.ToChar(13) }));
                                }
                            }
                            DB.runQuery(string.Concat(new object[] { "DELETE FROM furniture_presents WHERE id = '", num144, "' LIMIT ", numArray13.Length }));
                            DB.runQuery("DELETE FROM furniture WHERE id = '" + num144 + "' LIMIT 1");
                            this.refreshHand("last");
                        }
                        return;

                    case "Bw":
                        if ((this._isOwner && !this._inPublicroom) && ((this.Room != null) && (this.roomUser != null)))
                        {
                            int num147 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (this.Room.floorItemManager.containsItem(num147))
                            {
                                string str95 = this.Room.floorItemManager.getItem(num147).Sprite;
                                if (str95.Substring(0, 3).ToLower() == "cf_")
                                {
                                    int num148 = 0;
                                    try
                                    {
                                        num148 = int.Parse(str95.Split(new char[] { '_' })[1]);
                                    }
                                    catch
                                    {
                                        return;
                                    }
                                    this.Room.floorItemManager.removeItem(num147, 0);
                                    this._Credits += num148;
                                    this.sendData("@F" + this._Credits);
                                    DB.runQuery(string.Concat(new object[] { "UPDATE users SET credits = '", this._Credits, "' WHERE id = '", this.userID, "' LIMIT 1" }));
                                }
                            }
                            return;
                        }
                        return;

                    case "AQ":
                        if ((!this._inPublicroom && (this.Room != null)) && (this.roomUser != null))
                        {
                            int num149 = int.Parse(currentPacket.Substring(2));
                            if (this.Room.floorItemManager.containsItem(num149))
                            {
                                floorItem item2 = this.Room.floorItemManager.getItem(num149);
                                if (((item2.Z != 2) || (this.roomUser.X == (item2.X + 1))) || (this.roomUser.Y == item2.Y))
                                {
                                    if (((item2.Z == 4) && (this.roomUser.X != item2.X)) && (this.roomUser.Y != (item2.Y + 1)))
                                    {
                                        return;
                                    }
                                    this.roomUser.goalX = -1;
                                    this.Room.moveUser(this.roomUser, item2.X, item2.Y, true);
                                }
                            }
                            return;
                        }
                        return;

                    case @"@\":
                        if ((!this._inPublicroom && (this.Room != null)) && (this.roomUser != null))
                        {
                            int num150 = int.Parse(currentPacket.Substring(2));
                            if (this.Room.floorItemManager.containsItem(num150))
                            {
                                floorItem item3 = this.Room.floorItemManager.getItem(num150);
                                if ((this.roomUser.X == item3.X) || (this.roomUser.Y == item3.Y))
                                {
                                    int num151 = DB.runRead("SELECT teleportid FROM furniture WHERE id = '" + num150 + "'", null);
                                    int num152 = DB.runRead("SELECT roomid FROM furniture WHERE id = '" + num151 + "'", null);
                                    if (num152 <= 0)
                                    {
                                        return;
                                    }
                                    new TeleporterUsageSleep(this.useTeleporter).BeginInvoke(item3, num151, num152, null, null);
                                }
                            }
                            return;
                        }
                        return;

                    case "AM":
                        if (((this.Room != null) && (this.roomUser != null)) && !this._inPublicroom)
                        {
                            int num153 = int.Parse(currentPacket.Substring(2));
                            if (this.Room.floorItemManager.containsItem(num153))
                            {
                                floorItem item4 = this.Room.floorItemManager.getItem(num153);
                                string str96 = item4.Sprite;
                                if ((((str96 == "edice") || (str96 == "edicehc")) || ((str96 == "slot") || (str96 == "rdice"))) && ((Math.Abs((int) (this.roomUser.X - item4.X)) <= 1) && (Math.Abs((int) (this.roomUser.Y - item4.Y)) <= 1)))
                                {
                                    item4.Var = "0";
                                    this.Room.sendData(string.Concat(new object[] { "AZ", num153, " ", num153 * 0x26 }));
                                    DB.runQuery("UPDATE furniture SET var = '0' WHERE id = '" + num153 + "' LIMIT 1");
                                }
                                if (str96 == "paperguy")
                                {
                                    this.sendData("D|IHey " + this._Username + ", would you like to buy a newspaper? It's got all the latest news and gossip in it!\r\rNOTE: This will charge you 1 credit (Currently free while in testing).\x0002");
                                }
                                if (!(str96 == "santa9000"))
                                {
                                    return;
                                }
                                this.sendData("D|JHey " + this._Username + ", would you like to take part in my christmas quiz?.\x0002");
                            }
                            return;
                        }
                        return;

                    case "AL":
                        if (((this.Room != null) && (this.roomUser != null)) && !this._inPublicroom)
                        {
                            int num154 = int.Parse(currentPacket.Substring(2));
                            if (this.Room.floorItemManager.containsItem(num154))
                            {
                                floorItem item5 = this.Room.floorItemManager.getItem(num154);
                                string str97 = item5.Sprite;
                                switch (str97)
                                {
                                    case "edice":
                                    case "edicehc":
                                    case "slot":
                                    case "rdice":
                                    case "food1":
                                    case "rock1":
                                        if (((str97 == "edice") || (str97 == "edicehc")) || (str97 == "rdice"))
                                        {
                                            if ((Math.Abs((int) (this.roomUser.X - item5.X)) <= 1) && (Math.Abs((int) (this.roomUser.Y - item5.Y)) <= 1))
                                            {
                                                this.Room.sendData("AZ" + num154);
                                                int num155 = new Random(DateTime.Now.Millisecond).Next(1, 7);
                                                this.Room.sendData(string.Concat(new object[] { "AZ", num154, " ", (num154 * 0x26) + num155 }), 0x7d0);
                                                item5.Var = num155.ToString();
                                                DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET var = '", num155, "' WHERE id = '", num154, "' LIMIT 1" }));
                                                return;
                                            }
                                            return;
                                        }
                                        if (str97 == "food1")
                                        {
                                            if (item5.Var != "2")
                                            {
                                                int num156 = 2;
                                                this.Room.sendData(string.Concat(new object[] { "AZ", num154, " ", (num154 * 0x26) + 2 }), 0x3e8);
                                                this._hunger -= 0x4b;
                                                if (this._hunger < 0)
                                                {
                                                    this._hunger = 0;
                                                }
                                                this.Room.sendShout(this.roomUser, "Om nom nom, mmmm!");
                                                item5.Var = num156.ToString();
                                                DB.runQuery("UPDATE furniture SET var = '2' WHERE id = '" + num154 + "' LIMIT 1");
                                                return;
                                            }
                                            return;
                                        }
                                        if (str97 == "rock1")
                                        {
                                            int num157 = item5.X;
                                            int num158 = item5.Y;
                                            if ((item5.X + 1) == this.roomUser.X)
                                            {
                                                this.Room.floorItemManager.relocateItem(num154, item5.X - 1, item5.Y, item5.Z);
                                                if (num157 == item5.X)
                                                {
                                                    this.Room.floorItemManager.relocateItem(num154, item5.X, item5.Y + 1, item5.Z);
                                                    if (num157 == item5.X)
                                                    {
                                                        this.Room.floorItemManager.relocateItem(num154, item5.X, item5.Y - 1, item5.Z);
                                                    }
                                                }
                                            }
                                            else if ((item5.X - 1) == this.roomUser.X)
                                            {
                                                this.Room.floorItemManager.relocateItem(num154, item5.X + 1, item5.Y, item5.Z);
                                                if (num157 == item5.X)
                                                {
                                                    this.Room.floorItemManager.relocateItem(num154, item5.X, item5.Y - 1, item5.Z);
                                                    if (num157 == item5.X)
                                                    {
                                                        this.Room.floorItemManager.relocateItem(num154, item5.X, item5.Y + 1, item5.Z);
                                                    }
                                                }
                                            }
                                            else if ((item5.Y + 1) == this.roomUser.Y)
                                            {
                                                this.Room.floorItemManager.relocateItem(num154, item5.X, item5.Y - 1, item5.Z);
                                                if (num158 == item5.Y)
                                                {
                                                    this.Room.floorItemManager.relocateItem(num154, item5.X + 1, item5.Y, item5.Z);
                                                    if (num158 == item5.Y)
                                                    {
                                                        this.Room.floorItemManager.relocateItem(num154, item5.X - 1, item5.Y, item5.Z);
                                                    }
                                                }
                                            }
                                            else if ((item5.Y - 1) == this.roomUser.Y)
                                            {
                                                this.Room.floorItemManager.relocateItem(num154, item5.X, item5.Y + 1, item5.Z);
                                                if (num158 == item5.Y)
                                                {
                                                    this.Room.floorItemManager.relocateItem(num154, item5.X - 1, item5.Y, item5.Z);
                                                    if (num158 == item5.Y)
                                                    {
                                                        this.Room.floorItemManager.relocateItem(num154, item5.X + 1, item5.Y, item5.Z);
                                                    }
                                                }
                                            }
                                            this._hunger += 5;
                                            this.Room.sendShout(this.roomUser, "Oof, hmph!");
                                            return;
                                        }
                                        if ((str97 == "slot") && (this._Credits > 0))
                                        {
                                            if ((Math.Abs((int) (this.roomUser.X - item5.X)) <= 1) && (Math.Abs((int) (this.roomUser.Y - item5.Y)) <= 1))
                                            {
                                                this._Credits--;
                                                this.Room.sendData("AZ" + num154);
                                                int num159 = new Random(DateTime.Now.Millisecond).Next(1, 150);
                                                if (num159 == 100)
                                                {
                                                    num159 = 6;
                                                    this._Credits += 70;
                                                }
                                                else if (((num159 == 0x19) || (num159 == 50)) || (num159 == 0x4b))
                                                {
                                                    num159 = 4;
                                                    this._Credits += 10;
                                                }
                                                else if ((((num159 == 10) || (num159 == 20)) || ((num159 == 30) || (num159 == 40))) || (((num159 == 60) || (num159 == 70)) || ((num159 == 80) || (num159 == 90))))
                                                {
                                                    num159 = 2;
                                                    this._Credits += 5;
                                                }
                                                else
                                                {
                                                    num159 = 1;
                                                }
                                                DB.runQuery(string.Concat(new object[] { "UPDATE users SET credits = '", this._Credits, "' WHERE id = '", this.userID, "' LIMIT 1" }));
                                                this.sendData("@F" + this._Credits);
                                                this.Room.sendData(string.Concat(new object[] { "AZ", num154, " ", (num154 * 0x26) + num159 }), 0x7d0);
                                                item5.Var = num159.ToString();
                                                DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET var = '", num159, "' WHERE id = '", num154, "' LIMIT 1" }));
                                                return;
                                            }
                                            return;
                                        }
                                        if (!(str97 == "slot") || (this._Credits >= 1))
                                        {
                                            return;
                                        }
                                        this.sendData("BKYou cannot afford to play on this machine.");
                                        break;
                                }
                            }
                            return;
                        }
                        return;

                    case "Cw":
                        if ((this._hasRights && (this.Room != null)) && ((this.roomUser != null) && !this._inPublicroom))
                        {
                            int num160 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (this.Room.wallItemManager.containsItem(num160))
                            {
                                wallItem item6 = this.Room.wallItemManager.getItem(num160);
                                if (!(item6.Sprite == "habbowheel"))
                                {
                                    return;
                                }
                                int num161 = new Random(DateTime.Now.Millisecond).Next(0, 10);
                                this.Room.sendData(string.Concat(new object[] { "AU", num160, Convert.ToChar(9), "habbowheel", Convert.ToChar(9), " ", item6.wallPosition, Convert.ToChar(9), "-1" }));
                                this.Room.sendData(string.Concat(new object[] { "AU", num160, Convert.ToChar(9), "habbowheel", Convert.ToChar(9), " ", item6.wallPosition, Convert.ToChar(9), num161 }), 0x109a);
                                DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET var = '", num161, "' WHERE id = '", num160, "' LIMIT 1" }));
                            }
                            return;
                        }
                        return;

                    case "Dz":
                        if (((this.Room != null) && (this.roomUser != null)) && !this._inPublicroom)
                        {
                            int num162 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (this.Room.floorItemManager.containsItem(num162) && (this.Room.floorItemManager.getItem(num162).Sprite == "val_randomizer"))
                            {
                                int num163 = new Random(DateTime.Now.Millisecond).Next(1, 5);
                                this.Room.sendData(string.Concat(new object[] { "AX", num162, Convert.ToChar(2), "123456789", Convert.ToChar(2) }));
                                this.Room.sendData(string.Concat(new object[] { "AX", num162, Convert.ToChar(2), num163, Convert.ToChar(2) }), 0x1388);
                                DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET var = '", num163, "' WHERE id = '", num162, "' LIMIT 1" }));
                            }
                            return;
                        }
                        return;

                    case "AS":
                        if (((this.Room != null) && (this.roomUser != null)) && !this._inPublicroom)
                        {
                            int num164 = int.Parse(currentPacket.Substring(2));
                            if (this.Room.wallItemManager.containsItem(num164))
                            {
                                string str98 = DB.runRead("SELECT text FROM furniture_stickies WHERE id = '" + num164 + "'");
                                this.sendData(string.Concat(new object[] { "@p", num164, Convert.ToChar(9), this.Room.wallItemManager.getItem(num164).Var, " ", str98 }));
                            }
                            return;
                        }
                        return;

                    case "AT":
                        if ((this._hasRights && (this.Room != null)) && ((this.roomUser != null) && !this._inPublicroom))
                        {
                            int num165 = int.Parse(currentPacket.Substring(2, currentPacket.IndexOf("/") - 2));
                            if (this.Room.wallItemManager.containsItem(num165))
                            {
                                wallItem item7 = this.Room.wallItemManager.getItem(num165);
                                string str99 = item7.Sprite;
                                switch (str99)
                                {
                                    case "post.it":
                                    case "post.it.vd":
                                    {
                                        string str100 = "FFFFFF";
                                        if (str99 == "post.it")
                                        {
                                            str100 = currentPacket.Substring((2 + num165.ToString().Length) + 1, 6);
                                            if (((str100 != "FFFF33") && (str100 != "FF9CFF")) && ((str100 != "9CFF9C") && (str100 != "9CCEFF")))
                                            {
                                                return;
                                            }
                                        }
                                        string str101 = currentPacket.Substring((2 + num165.ToString().Length) + 7);
                                        if (str101.Length > 0x2ac)
                                        {
                                            return;
                                        }
                                        if (str100 != item7.Var)
                                        {
                                            DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET var = '", str100, "' WHERE id = '", num165, "' LIMIT 1" }));
                                        }
                                        item7.Var = str100;
                                        this.Room.sendData(string.Concat(new object[] { "AU", num165, Convert.ToChar(9), str99, Convert.ToChar(9), " ", item7.wallPosition, Convert.ToChar(9), str100 }));
                                        str101 = DB.Stripslash(stringManager.filterSwearwords(str101)).Replace("/r", Convert.ToChar(13).ToString());
                                        DB.runQuery(string.Concat(new object[] { "UPDATE furniture_stickies SET text = '", str101, "' WHERE id = '", num165, "' LIMIT 1" }));
                                        break;
                                    }
                                }
                            }
                            return;
                        }
                        return;

                    case "AU":
                        if ((this._isOwner && (this.Room != null)) && ((this.roomUser != null) && !this._inPublicroom))
                        {
                            int num166 = int.Parse(currentPacket.Substring(2));
                            if (this.Room.wallItemManager.containsItem(num166) && (stringManager.getStringPart(this.Room.wallItemManager.getItem(num166).Sprite, 0, 7) == "post.it"))
                            {
                                this.Room.wallItemManager.removeItem(num166, 0);
                                DB.runQuery("DELETE FROM furniture_stickies WHERE id = '" + num166 + "' LIMIT 1");
                            }
                            return;
                        }
                        return;

                    case "Ct":
                        if ((this._isOwner && (this.Room != null)) && (this.Room.floorItemManager.soundMachineID > 0))
                        {
                            this.sendData("EB" + soundMachineManager.getMachineSongList(this.Room.floorItemManager.soundMachineID));
                        }
                        return;

                    case "Cu":
                        if ((this.Room != null) && (this.Room.floorItemManager.soundMachineID > 0))
                        {
                            this.sendData("EC" + soundMachineManager.getMachinePlaylist(this.Room.floorItemManager.soundMachineID));
                        }
                        return;

                    case "C]":
                        if ((this.Room != null) && (this.Room.floorItemManager.soundMachineID > 0))
                        {
                            int songID = Encoding.decodeVL64(currentPacket.Substring(2));
                            this.sendData("Dl" + soundMachineManager.getSong(songID));
                        }
                        return;

                    case "Cs":
                        if ((this._isOwner && (this.Room != null)) && (this.Room.floorItemManager.soundMachineID > 0))
                        {
                            int num168 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (num168 >= 6)
                            {
                                return;
                            }
                            currentPacket = currentPacket.Substring(Encoding.encodeVL64(num168).Length + 2);
                            DB.runQuery("DELETE FROM soundmachine_playlists WHERE machineid = '" + this.Room.floorItemManager.soundMachineID + "'");
                            for (int num169 = 0; num169 < num168; num169++)
                            {
                                int num170 = Encoding.decodeVL64(currentPacket);
                                DB.runQuery(string.Concat(new object[] { "INSERT INTO soundmachine_playlists(machineid,songid,pos) VALUES ('", this.Room.floorItemManager.soundMachineID, "','", num170, "','", num169, "')" }));
                                currentPacket = currentPacket.Substring(Encoding.encodeVL64(num170).Length);
                            }
                            this.Room.sendData("EC" + soundMachineManager.getMachinePlaylist(this.Room.floorItemManager.soundMachineID));
                        }
                        return;

                    case "C~":
                        if ((this._isOwner && (this.Room != null)) && (this.Room.floorItemManager.soundMachineID > 0))
                        {
                            int num171 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if ((this._Credits <= 0) || !DB.checkExists(string.Concat(new object[] { "SELECT id FROM soundmachine_songs WHERE id = '", num171, "' AND userid = '", this.userID, "' AND machineid = '", this.Room.floorItemManager.soundMachineID, "'" })))
                            {
                                this.sendData("AD");
                                return;
                            }
                            string[] strArray27 = DB.runReadRow("SELECT title,length FROM soundmachine_songs WHERE id = '" + num171 + "'");
                            DB.runRead("SELECT length FROM soundmachine_songs WHERE id = '" + num171 + "'", null);
                            string str102 = string.Concat(new object[] { Encoding.encodeVL64(num171), this._Username, Convert.ToChar(10), DateTime.Today.Day, Convert.ToChar(10), DateTime.Today.Month, Convert.ToChar(10), DateTime.Today.Year, Convert.ToChar(10), strArray27[1], Convert.ToChar(10), strArray27[0] });
                            DB.runQuery(string.Concat(new object[] { "INSERT INTO furniture(tid,ownerid,var) VALUES ('", Config.Soundmachine_burnToDisk_diskTemplateID, "','", this.userID, "','", str102, "')" }));
                            DB.runQuery("UPDATE soundmachine_songs SET burnt = '1' WHERE id = '" + num171 + "' LIMIT 1");
                            DB.runQuery("UPDATE users SET credits = credits - 1 WHERE id = '" + this.userID + "' LIMIT 1");
                            this._Credits--;
                            this.sendData("@F" + this._Credits);
                            this.sendData("EB" + soundMachineManager.getMachineSongList(this.Room.floorItemManager.soundMachineID));
                            this.refreshHand("last");
                        }
                        return;

                    case "Cx":
                        if ((this._isOwner && (this.Room != null)) && (this.Room.floorItemManager.soundMachineID > 0))
                        {
                            int num172 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (!DB.checkExists(string.Concat(new object[] { "SELECT id FROM soundmachine_songs WHERE id = '", num172, "' AND machineid = '", this.Room.floorItemManager.soundMachineID, "'" })))
                            {
                                return;
                            }
                            DB.runQuery("UPDATE soundmachine_songs SET machineid = '0' WHERE id = '" + num172 + "' AND burnt = '1'");
                            DB.runQuery("DELETE FROM soundmachine_songs WHERE id = '" + num172 + "' AND burnt = '0' LIMIT 1");
                            DB.runQuery(string.Concat(new object[] { "DELETE FROM soundmachine_playlists WHERE machineid = '", this.Room.floorItemManager.soundMachineID, "' AND songid = '", num172, "'" }));
                            this.Room.sendData("EC" + soundMachineManager.getMachinePlaylist(this.Room.floorItemManager.soundMachineID));
                        }
                        return;

                    case "Co":
                        if ((this._isOwner && (this.Room != null)) && (this.Room.floorItemManager.soundMachineID > 0))
                        {
                            this.songEditor = new virtualSongEditor(this.Room.floorItemManager.soundMachineID, this.userID);
                            this.songEditor.loadSoundsets();
                            this.sendData("Dm" + this.songEditor.getSoundsets());
                            this.sendData("Dn" + soundMachineManager.getHandSoundsets(this.userID));
                        }
                        return;

                    case "C[":
                        if (((this.songEditor != null) && this._isOwner) && ((this.Room != null) && (this.Room.floorItemManager.soundMachineID > 0)))
                        {
                            int num173 = Encoding.decodeVL64(currentPacket.Substring(2));
                            int slotID = Encoding.decodeVL64(currentPacket.Substring(Encoding.encodeVL64(num173).Length + 2));
                            if (((slotID <= 0) || (slotID >= 5)) || !this.songEditor.slotFree(slotID))
                            {
                                return;
                            }
                            this.songEditor.addSoundset(num173, slotID);
                            this.sendData("Dn" + soundMachineManager.getHandSoundsets(this.userID));
                            this.sendData("Dm" + this.songEditor.getSoundsets());
                        }
                        return;

                    case @"C\":
                        if (((this.songEditor != null) && this._isOwner) && ((this.Room != null) && (this.Room.floorItemManager.soundMachineID > 0)))
                        {
                            int num175 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (this.songEditor.slotFree(num175))
                            {
                                return;
                            }
                            this.songEditor.removeSoundset(num175);
                            this.sendData("Dm" + this.songEditor.getSoundsets());
                            this.sendData("Dn" + soundMachineManager.getHandSoundsets(this.userID));
                        }
                        return;

                    case "Cp":
                        if (((this.songEditor != null) && this._isOwner) && ((this.Room != null) && (this.Room.floorItemManager.soundMachineID > 0)))
                        {
                            int num176 = Encoding.decodeB64(currentPacket.Substring(2, 2));
                            string str103 = currentPacket.Substring(4, num176);
                            string str104 = currentPacket.Substring(num176 + 6);
                            int num177 = soundMachineManager.calculateSongLength(str104);
                            if (num177 == -1)
                            {
                                return;
                            }
                            str103 = DB.Stripslash(stringManager.filterSwearwords(str103));
                            str104 = DB.Stripslash(str104);
                            DB.runQuery(string.Concat(new object[] { "INSERT INTO soundmachine_songs (userid,machineid,title,length,data) VALUES ('", this.userID, "','", this.Room.floorItemManager.soundMachineID, "','", str103, "','", num177, "','", DB.Stripslash(str104), "')" }));
                            this.sendData("EB" + soundMachineManager.getMachineSongList(this.Room.floorItemManager.soundMachineID));
                            this.sendData(string.Concat(new object[] { "EK", Encoding.encodeVL64(this.Room.floorItemManager.soundMachineID), str103, Convert.ToChar(2) }));
                        }
                        return;

                    case "Cq":
                        if ((this._isOwner && (this.Room != null)) && (this.Room.floorItemManager.soundMachineID > 0))
                        {
                            int num178 = Encoding.decodeVL64(currentPacket.Substring(2));
                            this.sendData("Dl" + soundMachineManager.getSong(num178));
                            this.songEditor = new virtualSongEditor(this.Room.floorItemManager.soundMachineID, this.userID);
                            this.songEditor.loadSoundsets();
                            this.sendData("Dm" + this.songEditor.getSoundsets());
                            this.sendData("Dn" + soundMachineManager.getHandSoundsets(this.userID));
                        }
                        return;

                    case "Cr":
                        if (((this.songEditor != null) && this._isOwner) && ((this.Room != null) && (this.Room.floorItemManager.soundMachineID > 0)))
                        {
                            int num179 = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (!DB.checkExists(string.Concat(new object[] { "SELECT id FROM soundmachine_songs WHERE id = '", num179, "' AND userid = '", this.userID, "' AND machineid = '", this.Room.floorItemManager.soundMachineID, "'" })))
                            {
                                return;
                            }
                            int num180 = Encoding.encodeVL64(num179).Length;
                            int num181 = Encoding.decodeB64(currentPacket.Substring(num180 + 2, 2));
                            string str105 = currentPacket.Substring(num180 + 4, num181);
                            string str106 = currentPacket.Substring((num180 + num181) + 6);
                            int num182 = soundMachineManager.calculateSongLength(str106);
                            if (num182 == -1)
                            {
                                return;
                            }
                            str105 = DB.Stripslash(stringManager.filterSwearwords(str105));
                            str106 = DB.Stripslash(str106);
                            DB.runQuery(string.Concat(new object[] { "UPDATE soundmachine_songs SET title = '", str105, "',data = '", str106, "',length = '", num182, "' WHERE id = '", num179, "' LIMIT 1" }));
                            this.sendData("ES");
                            this.sendData("EB" + soundMachineManager.getMachineSongList(this.Room.floorItemManager.soundMachineID));
                            this.Room.sendData("EC" + soundMachineManager.getMachinePlaylist(this.Room.floorItemManager.soundMachineID));
                        }
                        return;

                    case "AG":
                        if (((this.Room != null) || (this.roomUser != null)) || (this._tradePartnerRoomUID == -1))
                        {
                            if (!Config.enableTrading)
                            {
                                this.sendData("BK" + stringManager.getString("trading_disabled"));
                                return;
                            }
                            int roomUID = int.Parse(currentPacket.Substring(2));
                            if (!this.Room.containsUser(roomUID))
                            {
                                return;
                            }
                            virtualUser user11 = this.Room.getUser(roomUID);
                            if (!user11.statusManager.containsStatus("trd"))
                            {
                                this._tradePartnerRoomUID = roomUID;
                                this.statusManager.addStatus("trd", "");
                                this.roomUser.Refresh();
                                user11._tradePartnerRoomUID = this.roomUser.roomUID;
                                user11.statusManager.addStatus("trd", "");
                                user11.roomUser.Refresh();
                                this.refreshTradeBoxes();
                                user11.refreshTradeBoxes();
                            }
                        }
                        return;

                    case "AH":
                        if (((this.Room != null) && (this.roomUser != null)) && ((this._tradePartnerRoomUID != -1) && this.Room.containsUser(this._tradePartnerRoomUID)))
                        {
                            int num184 = int.Parse(currentPacket.Substring(2));
                            if (DB.runRead(string.Concat(new object[] { "SELECT id FROM furniture WHERE id = '", num184, "' AND ownerid = '", this.userID, "' AND roomid = '0'" }), null) != 0)
                            {
                                this._tradeItems[this._tradeItemCount] = num184;
                                this._tradeItemCount++;
                                virtualUser user12 = this.Room.getUser(this._tradePartnerRoomUID);
                                this._tradeAccept = false;
                                user12._tradeAccept = false;
                                this.refreshTradeBoxes();
                                user12.refreshTradeBoxes();
                                return;
                            }
                        }
                        return;

                    case "AD":
                        if (((this.Room != null) && (this.roomUser != null)) && ((this._tradePartnerRoomUID != -1) && this.Room.containsUser(this._tradePartnerRoomUID)))
                        {
                            virtualUser user13 = this.Room.getUser(this._tradePartnerRoomUID);
                            this._tradeAccept = false;
                            user13._tradeAccept = false;
                            this.refreshTradeBoxes();
                            user13.refreshTradeBoxes();
                        }
                        return;

                    case "AE":
                        if (((this.Room != null) && (this.roomUser != null)) && ((this._tradePartnerRoomUID != -1) && this.Room.containsUser(this._tradePartnerRoomUID)))
                        {
                            virtualUser user14 = this.Room.getUser(this._tradePartnerRoomUID);
                            this._tradeAccept = true;
                            this.refreshTradeBoxes();
                            user14.refreshTradeBoxes();
                            if (!user14._tradeAccept)
                            {
                                return;
                            }
                            for (int num186 = 0; num186 < this._tradeItemCount; num186++)
                            {
                                if (this._tradeItems[num186] > 0)
                                {
                                    DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET ownerid = '", user14.userID, "',roomid = '0' WHERE id = '", this._tradeItems[num186], "' LIMIT 1" }));
                                }
                            }
                            for (int num187 = 0; num187 < user14._tradeItemCount; num187++)
                            {
                                if (user14._tradeItems[num187] > 0)
                                {
                                    DB.runQuery(string.Concat(new object[] { "UPDATE furniture SET ownerid = '", this.userID, "',roomid = '0' WHERE id = '", user14._tradeItems[num187], "' LIMIT 1" }));
                                }
                            }
                            this.abortTrade();
                        }
                        return;

                    case "AF":
                        if (((this.Room != null) && (this.roomUser != null)) && ((this._tradePartnerRoomUID != -1) && this.Room.containsUser(this._tradePartnerRoomUID)))
                        {
                            this.abortTrade();
                            this.refreshHand("update");
                        }
                        return;

                    case "B_":
                        if ((this.Room != null) && (this.Room.Lobby != null))
                        {
                            this.sendData("Ch" + this.Room.Lobby.gameList());
                        }
                        return;

                    case "B`":
                        if (((this.Room != null) && (this.roomUser != null)) && ((this.Room.Lobby != null) && (this.gamePlayer == null)))
                        {
                            int key = Encoding.decodeVL64(currentPacket.Substring(2));
                            if (!this.Room.Lobby.Games.ContainsKey(key))
                            {
                                return;
                            }
                            this.gamePlayer = new Otaku.Virtual.Rooms.Games.gamePlayer(this, this.roomUser.roomUID, (Game) this.Room.Lobby.Games[key]);
                            this.gamePlayer.Game.Subviewers.Add(this.gamePlayer);
                            this.sendData("Ci" + this.gamePlayer.Game.Sub);
                        }
                        return;

                    case "Bb":
                        if (((this.Room != null) && (this.roomUser != null)) && ((this.Room.Lobby != null) && (this.gamePlayer == null)))
                        {
                            if (this._Tickets <= 1)
                            {
                                this.sendData("ClJ");
                                return;
                            }
                            if (!this.Room.Lobby.validGamerank(this.roomUser.gamePoints))
                            {
                                this.sendData("ClK");
                                return;
                            }
                            if (!this.Room.Lobby.isBattleBall)
                            {
                                this.sendData(string.Concat(new object[] { "CkRAsecondsUntilRestart", Convert.ToChar(2), "HIRGIHHfieldType", Convert.ToChar(2), "HKIIIISAnumTeams", Convert.ToChar(2), "HJJIIIPAgameLengthChoice", Convert.ToChar(2), "HJIIIIKname", Convert.ToChar(2), "IJ", Convert.ToChar(2), "HsecondsUntilStart", Convert.ToChar(2), "HIRBIHH" }));
                                return;
                            }
                            this.sendData("Ck" + this.Room.Lobby.getCreateGameSettings());
                        }
                        return;

                    case "Bc":
                        if (((this.Room != null) && (this.roomUser != null)) && ((this.Room.Lobby != null) && (this.gamePlayer == null)))
                        {
                            if (this._Tickets <= 1)
                            {
                                this.sendData("ClJ");
                                return;
                            }
                            if (this.Room.Lobby.validGamerank(this.roomUser.gamePoints))
                            {
                                try
                                {
                                    int mapID = -1;
                                    int teamAmount = -1;
                                    int[] enabledPowerups = null;
                                    string str107 = "";
                                    int num191 = Encoding.decodeVL64(currentPacket.Substring(2));
                                    currentPacket = currentPacket.Substring(Encoding.encodeVL64(num191).Length + 2);
                                    for (int num192 = 0; num192 < num191; num192++)
                                    {
                                        int num195;
                                        int num196;
                                        int num193 = Encoding.decodeB64(currentPacket.Substring(0, 2));
                                        string str108 = currentPacket.Substring(2, num193);
                                        if (!(currentPacket.Substring(num193 + 2, 1) == "H"))
                                        {
                                            goto Label_C4D8;
                                        }
                                        int num194 = Encoding.decodeVL64(currentPacket.Substring(num193 + 3));
                                        str113 = str108;
                                        if (str113 != null)
                                        {
                                            if (!(str113 == "fieldType"))
                                            {
                                                if (str113 == "numTeams")
                                                {
                                                    goto Label_C4A6;
                                                }
                                            }
                                            else
                                            {
                                                mapID = num194;
                                            }
                                        }
                                        goto Label_C4AE;
                                    Label_C4A6:
                                        teamAmount = num194;
                                    Label_C4AE:
                                        num195 = Encoding.encodeVL64(num194).Length;
                                        currentPacket = currentPacket.Substring((num193 + num195) + 3);
                                        continue;
                                    Label_C4D8:
                                        num196 = Encoding.decodeB64(currentPacket.Substring(num193 + 3, 2));
                                        string str109 = currentPacket.Substring(num193 + 5, num196);
                                        str113 = str108;
                                        if (str113 != null)
                                        {
                                            if (!(str113 == "allowedPowerups"))
                                            {
                                                if (str113 == "name")
                                                {
                                                    goto Label_C5C5;
                                                }
                                            }
                                            else
                                            {
                                                string[] strArray28 = str109.Split(new char[] { ',' });
                                                enabledPowerups = new int[strArray28.Length];
                                                for (int num197 = 0; num197 < strArray28.Length; num197++)
                                                {
                                                    int num198 = int.Parse(strArray28[num197]);
                                                    if (!this.Room.Lobby.allowsPowerup(num198))
                                                    {
                                                        return;
                                                    }
                                                    enabledPowerups[num197] = num198;
                                                }
                                            }
                                        }
                                        goto Label_C5D2;
                                    Label_C5C5:
                                        str107 = stringManager.filterSwearwords(str109);
                                    Label_C5D2:
                                        currentPacket = currentPacket.Substring((num193 + num196) + 5);
                                    }
                                    if (((mapID != -1) && (teamAmount != -1)) && (str107 != ""))
                                    {
                                        this.gamePlayer = new Otaku.Virtual.Rooms.Games.gamePlayer(this, this.roomUser.roomUID, null);
                                        this.Room.Lobby.createGame(this.gamePlayer, str107, mapID, teamAmount, enabledPowerups);
                                    }
                                    return;
                                }
                                catch
                                {
                                    return;
                                }
                            }
                            this.sendData("ClK");
                        }
                        return;

                    case "Be":
                        if (((this.Room != null) && (this.Room.Lobby != null)) && ((this.gamePlayer != null) && (this.gamePlayer.Game.State == Game.gameState.Waiting)))
                        {
                            if (this._Tickets <= 1)
                            {
                                this.sendData("ClJ");
                                return;
                            }
                            if (!this.Room.Lobby.validGamerank(this.roomUser.gamePoints))
                            {
                                this.sendData("ClK");
                                return;
                            }
                            int num199 = Encoding.decodeVL64(currentPacket.Substring(2));
                            int teamID = Encoding.decodeVL64(currentPacket.Substring(Encoding.encodeVL64(num199).Length + 2));
                            if ((teamID == this.gamePlayer.teamID) || !this.gamePlayer.Game.teamHasSpace(teamID))
                            {
                                this.sendData("ClH");
                                return;
                            }
                            if (this.gamePlayer.teamID == -1)
                            {
                                this.gamePlayer.Game.Subviewers.Remove(this.gamePlayer);
                            }
                            this.gamePlayer.Game.movePlayer(this.gamePlayer, this.gamePlayer.teamID, teamID);
                        }
                        return;

                    case "Bg":
                        this.leaveGame();
                        return;

                    case "Bh":
                        if ((((this.Room != null) && (this.Room.Lobby != null)) && ((this.gamePlayer != null) && (this.gamePlayer.Game != null))) && (this.gamePlayer == this.gamePlayer.Game.Owner))
                        {
                            int num201 = Encoding.decodeVL64(currentPacket.Substring(2));
                            for (int num202 = 0; num202 < this.gamePlayer.Game.Teams.Length; num202++)
                            {
                                foreach (Otaku.Virtual.Rooms.Games.gamePlayer player in this.gamePlayer.Game.Teams[num202])
                                {
                                    if (player.roomUID == num201)
                                    {
                                        player.sendData("ClRA");
                                        this.gamePlayer.Game.movePlayer(player, num202, -1);
                                        return;
                                    }
                                }
                            }
                        }
                        return;

                    case "Bj":
                        if (((this.Room != null) && (this.Room.Lobby != null)) && ((this.gamePlayer != null) && (this.gamePlayer == this.gamePlayer.Game.Owner)))
                        {
                            this.gamePlayer.Game.startGame();
                        }
                        return;

                    case "Bk":
                        if (((this.gamePlayer != null) && (this.gamePlayer.Game.State == Game.gameState.Started)) && (this.gamePlayer.teamID != -1))
                        {
                            this.gamePlayer.goalX = Encoding.decodeVL64(currentPacket.Substring(3));
                            this.gamePlayer.goalY = Encoding.decodeVL64(currentPacket.Substring(Encoding.encodeVL64(this.gamePlayer.goalX).Length + 3));
                            Out.WriteLine(string.Concat(new object[] { this._Username, ": ", this.gamePlayer.goalX, ",", this.gamePlayer.goalY }));
                        }
                        return;

                    case "Bl":
                        if (((this.gamePlayer != null) && (this.gamePlayer.Game.State == Game.gameState.Ended)) && (this.gamePlayer.teamID != -1))
                        {
                            this.gamePlayer.Game.sendData("BK" + this._Username + " wants to replay!");
                        }
                        return;

                    case "Ej":
                        DB.runQuery("UPDATE users SET guideavailable = '1' WHERE id = '" + this.userID + "' LIMIT 1");
                        return;

                    case "Ek":
                        DB.runQuery("UPDATE users SET guideavailable = '0' WHERE id = '" + this.userID + "' LIMIT 1");
                        return;

                    case "EW":
                        if (this._isOwner)
                        {
                            roomManager.moodlight.setSettings(this._roomID, false, 0, 0, null, 0);
                            return;
                        }
                        return;

                    case "EU":
                        if (this._isOwner)
                        {
                            string str110 = roomManager.moodlight.getSettings(this._roomID);
                            if (str110 != null)
                            {
                                this.sendData("Em" + str110);
                            }
                            return;
                        }
                        return;

                    case "EV":
                        if ((this._hasRights && (this.Room != null)) && ((this.roomUser != null) && !this._inPublicroom))
                        {
                            int presetID = Encoding.decodeVL64(currentPacket.Substring(2, 1));
                            int bgState = Encoding.decodeVL64(currentPacket.Substring(3, 1));
                            currentPacket = DB.Stripslash(currentPacket);
                            string presetColour = currentPacket.Substring(6, Encoding.decodeB64(currentPacket.Substring(4, 2)));
                            int alphaDarkF = Encoding.decodeVL64(currentPacket.Substring(presetColour.Length + 6));
                            roomManager.moodlight.setSettings(this._roomID, true, presetID, bgState, presetColour, alphaDarkF);
                            string str112 = roomManager.moodlight.getSettings(this._roomID);
                            if (str112 != null)
                            {
                                this.Room.sendData("Em" + str112);
                            }
                            return;
                        }
                        return;
                }
                return;
            }
            Out.WriteLine(currentPacket, "Logging In");
            switch (currentPacket.Substring(0, 2))
            {
                case "CD":
                    this.pingOK = true;
                    return;

                case "CN":
                    this.sendData("DUIH");
                    return;

                case "_R":
                    this.sendData("DAIJWVVVSNKQCFUBJASMSLKUUOJCOLJQPNSBIRSVQBRXZQOTGPMNJIHLVJCRRULBLUO");
                    return;

                case "CJ":
                    this.sendData(string.Concat(new object[] { "DAQBHHIIKHJIPAHQAdd-MM-yyyy", Convert.ToChar(2), "SAHPBhttp://www.Otaku-Hotel.co.uk", Convert.ToChar(2), "QBH" }));
                    return;

                case "CL":
                {
                    int num = DB.runRead("SELECT id FROM users WHERE ticket_sso = '" + DB.Stripslash(currentPacket.Substring(4)) + "'", null);
                    if (num == 0)
                    {
                        this.Disconnect();
                        return;
                    }
                    string str2 = userManager.getBanReason(num);
                    if (str2 != "")
                    {
                        this.sendData("@c" + str2);
                        this.Disconnect(0x3e8);
                        return;
                    }
                    this.userID = num;
                    string[] strArray = DB.runReadRow("SELECT name,figure,sex,mission,rank,consolemission FROM users WHERE id = '" + num + "'");
                    this._Username = strArray[0];
                    this._Figure = strArray[1];
                    this._Sex = char.Parse(strArray[2]);
                    this._Mission = strArray[3];
                    this._Rank = byte.Parse(strArray[4]);
                    this._consoleMission = strArray[5];
                    userManager.addUser(num, this);
                    this._isLoggedIn = true;
                    this.sendData(string.Concat(new object[] { "DAQBHIIIKHJIPAIQAdd-MM-yyyy", Convert.ToChar(2), "SAHPB/client", Convert.ToChar(2), "QBH" }));
                    this.sendData("@B" + rankManager.fuseRights(this._Rank));
                    this.sendData("DbIH");
                    this.sendData("@C");
                    this.sendData("FC");
                    if (DB.runRead("SELECT guide FROM users WHERE id = '" + this.userID + "'", null) == 1)
                    {
                        this.sendData("BKhoi");
                        this.sendData("FiI");
                        return;
                    }
                    if (Config.enableWelcomeMessage)
                    {
                        this.sendData("BK" + stringManager.getString("welcomemessage_text"));
                    }
                    return;
                }
                default:
                    this.Disconnect();
                    return;
            }
        Label_173A:
            if (this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Sprite == "one_way_door*2")
            {
                if (this._isRoomStaff)
                {
                    switch (str3)
                    {
                        case "X-1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X + 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                            break;

                        case "X1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X - 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                            break;

                        case "Y-1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y + 1, true);
                            break;

                        case "Y1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y - 1, true);
                            break;
                    }
                }
                else if (this._isOwner)
                {
                    switch (str3)
                    {
                        case "X-1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X + 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                            break;

                        case "X1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X - 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                            break;

                        case "Y-1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y + 1, true);
                            break;

                        case "Y1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y - 1, true);
                            break;
                    }
                }
                else
                {
                    this.sendData("BKStaff Access Only.");
                    switch (str3)
                    {
                        case "X1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X + 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                            break;

                        case "X-1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X - 1, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y, true);
                            break;

                        case "Y1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y + 1, true);
                            break;

                        case "Y-1":
                            this.Room.moveUser(this.roomUser, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).X, this.Room.floorItemManager.getItem(Encoding.decodeVL64(currentPacket.Substring(2))).Y - 1, true);
                            break;
                    }
                }
            }
            Thread.Sleep(500);
            this.Room.sendData("Dx" + currentPacket.Substring(2) + "HH");
        }

        internal void refreshAppearance(bool Reload, bool refreshSettings, bool refreshRoom)
        {
            if (Reload)
            {
                string[] strArray = DB.runReadRow("SELECT figure,sex,mission FROM users WHERE id = '" + this.userID + "'");
                this._Figure = strArray[0];
                this._Sex = char.Parse(strArray[1]);
                this._Mission = strArray[2];
            }
            if (refreshSettings)
            {
                this.sendData(string.Concat(new object[] { "@E", this.connectionID, Convert.ToChar(2), this._Username, Convert.ToChar(2), this._Figure, Convert.ToChar(2), this._Sex, Convert.ToChar(2), this._Mission, Convert.ToChar(2), Convert.ToChar(2), "PCch=s02/53,51,44", Convert.ToChar(2), "HI" }));
            }
            if ((refreshRoom && (this.Room != null)) && (this.roomUser != null))
            {
                this.Room.sendData(string.Concat(new object[] { "DJ", Encoding.encodeVL64(this.roomUser.roomUID), this._Figure, Convert.ToChar(2), this._Sex, Convert.ToChar(2), this._Mission, Convert.ToChar(2) }));
            }
        }

        internal void refreshBadges()
        {
            this._nowBadge = "";
            int i = 0;
            int num2 = 0;
            string[] strArray = DB.runReadColumn("SELECT badgeid FROM users_badges WHERE userid = '" + this.userID + "'", 0);
            StringBuilder builder = new StringBuilder();
            if (strArray.Length > 0)
            {
                num2 = DB.runRead("SELECT badge_status FROM users WHERE id = '" + this.userID + "'", null);
                string str = DB.runRead("SELECT badgeid FROM users_badges WHERE userid = '" + this.userID + "' AND iscurrent = '1'");
                for (int j = 0; j < strArray.Length; j++)
                {
                    builder.Append(strArray[j] + Convert.ToChar(2));
                    if (strArray[j] == str)
                    {
                        i = j;
                    }
                }
                if (num2 == 1)
                {
                    this._nowBadge = str;
                }
                this.sendData("Ce" + Encoding.encodeVL64(strArray.Length) + builder.ToString() + Encoding.encodeVL64(i) + Encoding.encodeVL64(num2));
            }
            else
            {
                this.sendData("CeHH");
            }
        }

        internal void refreshClub()
        {
            int i = 0;
            int num2 = 0;
            int num3 = 0;
            string[] strArray = DB.runReadRow(string.Concat(new object[] { "SELECT months_expired,months_left,date_monthstarted FROM users_club WHERE userid = '", this.userID, '1', " LIMIT 1'" }));
            if (strArray.Length > 0)
            {
                num2 = int.Parse(strArray[0]);
                num3 = int.Parse(strArray[1]) - 1;
                i = ((int) DateTime.Parse(strArray[2], new CultureInfo("en-GB")).Subtract(DateTime.Now).TotalDays) + 0x20;
                this._clubMember = true;
            }
            this.sendData(string.Concat(new object[] { "@Gclub_habbo", Convert.ToChar(2), Encoding.encodeVL64(i), Encoding.encodeVL64(num2), Encoding.encodeVL64(num3), Encoding.encodeVL64(1) }));
        }

        internal void refreshGroupStatus()
        {
            this._groupID = DB.runReadUnsafe("SELECT groupid FROM groups_memberships WHERE userid = '" + this.userID + "' AND is_current = '1'", null);
            if (this._groupID > 0)
            {
                this._groupMemberRank = DB.runRead(string.Concat(new object[] { "SELECT member_rank FROM groups_memberships WHERE userid = '", this.userID, "' AND groupID = '", this._groupID, "'" }), null);
            }
        }

        internal void refreshHand(string Mode)
        {
            int[] numArray = DB.runReadColumn("SELECT id FROM furniture WHERE ownerid = '" + this.userID + "' AND roomid = '0' ORDER BY id ASC", 0, null);
            StringBuilder builder = new StringBuilder("BL");
            int num = 0;
            int length = numArray.Length;
            string str2 = Mode;
            if (str2 != null)
            {
                if (!(str2 == "next"))
                {
                    if (str2 == "prev")
                    {
                        this._handPage--;
                        goto Label_00A8;
                    }
                    if (str2 == "last")
                    {
                        this._handPage = (length - 1) / 9;
                        goto Label_00A8;
                    }
                    if (str2 == "update")
                    {
                        goto Label_00A8;
                    }
                }
                else
                {
                    this._handPage++;
                    goto Label_00A8;
                }
            }
            this._handPage = 0;
        Label_00A8:
            try
            {
                if (numArray.Length > 0)
                {
                    while (true)
                    {
                        num = this._handPage * 9;
                        if (length > (num + 9))
                        {
                            length = num + 9;
                        }
                        if ((num <= length) && (num != length))
                        {
                            break;
                        }
                        this._handPage--;
                    }
                    for (int i = num; i < length; i++)
                    {
                        catalogueManager.itemTemplate template = catalogueManager.getTemplate(DB.runRead("SELECT tid FROM furniture WHERE id = '" + numArray[i] + "'", null));
                        char ch = '1';
                        if (!template.isRecycleable)
                        {
                            ch = '0';
                        }
                        if (template.typeID == 0)
                        {
                            string colour = template.Colour;
                            if ((template.Sprite == "post.it") || (template.Sprite == "post.it.vd"))
                            {
                                colour = DB.runRead("SELECT var FROM furniture WHERE id = '" + numArray[i] + "'");
                            }
                            builder.Append(string.Concat(new object[] { "SI", Convert.ToChar(30).ToString(), numArray[i], Convert.ToChar(30).ToString(), i, Convert.ToChar(30).ToString(), "I", Convert.ToChar(30).ToString(), numArray[i], Convert.ToChar(30).ToString(), template.Sprite, Convert.ToChar(30).ToString(), colour, Convert.ToChar(30).ToString(), ch, "/" }));
                        }
                        else
                        {
                            builder.Append(string.Concat(new object[] { 
                                "SI", Convert.ToChar(30).ToString(), numArray[i], Convert.ToChar(30).ToString(), i, Convert.ToChar(30).ToString(), "S", Convert.ToChar(30).ToString(), numArray[i], Convert.ToChar(30).ToString(), template.Sprite, Convert.ToChar(30).ToString(), template.Length, Convert.ToChar(30).ToString(), template.Width, Convert.ToChar(30).ToString(), 
                                DB.runRead("SELECT var FROM furniture WHERE id = '" + numArray[i] + "'"), Convert.ToChar(30).ToString(), template.Colour, Convert.ToChar(30).ToString(), ch, Convert.ToChar(30).ToString(), template.Sprite, Convert.ToChar(30).ToString(), "/"
                             }));
                        }
                    }
                }
                builder.Append(Convert.ToChar(13).ToString() + numArray.Length);
                this.sendData(builder.ToString());
            }
            catch
            {
                this.sendData("BL" + Convert.ToChar(13) + "0");
            }
        }

        internal void refreshTradeBoxes()
        {
            if (((this.Room != null) && this.Room.containsUser(this._tradePartnerRoomUID)) && (this.roomUser != null))
            {
                virtualUser user = this.Room.getUser(this._tradePartnerRoomUID);
                StringBuilder builder = new StringBuilder(string.Concat(new object[] { "Al", this._Username, Convert.ToChar(9), this._tradeAccept.ToString().ToLower(), Convert.ToChar(9) }));
                if (this._tradeItemCount > 0)
                {
                    builder.Append(catalogueManager.tradeItemList(this._tradeItems));
                }
                builder.Append(string.Concat(new object[] { Convert.ToChar(13), user._Username, Convert.ToChar(9), user._tradeAccept.ToString().ToLower(), Convert.ToChar(9) }));
                if (user._tradeItemCount > 0)
                {
                    builder.Append(catalogueManager.tradeItemList(user._tradeItems));
                }
                this.sendData(builder.ToString());
            }
        }

        internal void refreshValueables(bool Credits, bool Tickets)
        {
            if (Credits)
            {
                this._Credits = DB.runRead("SELECT credits FROM users WHERE id = '" + this.userID + "'", null);
                this.sendData("@F" + this._Credits);
            }
            if (Tickets)
            {
                this._Tickets = DB.runRead("SELECT tickets FROM users WHERE id = '" + this.userID + "'", null);
                this.sendData("A|" + this._Tickets);
            }
        }

        internal void sendData(string Data)
        {
            try
            {
                byte[] bytes = Encoding.Default.GetBytes(Data.Replace(Convert.ToChar(1), Convert.ToChar(160)) + Convert.ToChar(1));
                this.connectionSocket.BeginSend(bytes, 0, bytes.Length, SocketFlags.None, new AsyncCallback(this.sentData), null);
            }
            catch
            {
                this.Disconnect();
            }
        }

        private void sentData(IAsyncResult iAr)
        {
            try
            {
                this.connectionSocket.EndSend(iAr);
            }
            catch
            {
                this.Disconnect();
            }
        }

        private void useTeleporter(floorItem Teleporter1, int idTeleporter2, int roomIDTeleporter2)
        {
            this.roomUser.walkLock = true;
            string sprite = Teleporter1.Sprite;
            if (roomIDTeleporter2 == this._roomID)
            {
                floorItem item = this.Room.floorItemManager.getItem(idTeleporter2);
                Thread.Sleep(500);
                this.Room.sendData(string.Concat(new object[] { "AY", Teleporter1.ID, "/", this._Username, "/", sprite }));
                this.Room.sendData(string.Concat(new object[] { @"A\", item.ID, "/", this._Username, "/", sprite }));
                this.roomUser.X = item.X;
                this.roomUser.Y = item.Y;
                this.roomUser.H = item.H;
                this.roomUser.Z1 = item.Z;
                this.roomUser.Z2 = item.Z;
                this.roomUser.Refresh();
                this.roomUser.walkLock = false;
            }
            else
            {
                this._teleporterID = idTeleporter2;
                this.sendData("@~" + Encoding.encodeVL64(idTeleporter2) + Encoding.encodeVL64(roomIDTeleporter2));
                this.Room.sendData(string.Concat(new object[] { "AY", Teleporter1.ID, "/", this._Username, "/", sprite }));
            }
        }

        internal string connectionRemoteIP
        {
            get
            {
                return this.connectionSocket.RemoteEndPoint.ToString().Split(new char[] { ':' })[0];
            }
        }

        private delegate void TeleporterUsageSleep(floorItem Teleporter1, int idTeleporter2, int roomIDTeleporter2);

        private delegate void timedDisconnector(int ms);
    }
}

